2026-03-22  Werner Lemberg  <wl@gnu.org>

	* Version 2.14.3 released.
	==========================

	Tag sources with `VER-2-14-3'.

	* docs/VERSION.TXT: Add entry for version 2.14.3.
	* docs/CHANGES: Updated.
	* docs/release, docs/README, builds/macs/README: Updated.

	* README, src/base/ftver.rc, builds/windows/vc2010/index.html,
	  builds/windows/visualc/index.html, builds/windows/visualce/index.html,
	  builds/wince/vc2005-ce/index.html, builds/wince/vc2008-ce/index.html,
	  docs/freetype-config.1: s/2.14.2/2.14.3/, s/2142/2143/.

	* include/freetype/freetype.h (FREETYPE_PATCH): Set to 3.

	* builds/unix/configure.raw (version_info): Set to 26:6:20.
	* CMakeLists.txt (VERSION_PATCH): Set to 3.

2026-03-22  Werner Lemberg  <wl@gnu.org>

	* subprojects/harfbuzz.wrap: Updated.

2026-03-22  David Pokora  <david.pokora@trailofbits.com>

	[psaux] Avoid stack overflow.

	* src/psaux/t1.decode.c (t1_decoder_parse_charstrings) [op_pop]: Check stack
	  size.

	Fixes issue #1406.

2026-03-22  Werner Lemberg  <wl@gnu.org>

	* src/psaux/t1decide.c (t1_decoder_parse_charstrings): Fix bounds check.

	During charstring processing, the `decoder->len_buildchar` field can be
	corrupted.  Avoid this by caching this value in a local variable at function
	entry.

	Based on a patch submitted by David Pokora <david.pokora@trailofbits.com>.

	Fixes issue #1405.

2026-03-20  Werner Lemberg  <wl@gnu.org>

	ttnameid.h: Minor documentation improvement.

2026-03-20  Werner Lemberg  <wl@gnu.org>

	* src/sdf/ftsdf.c (sdf_generate_bounding_box): Fix thinko.

	Bug introduced in commit bda1d87f694dd.

	We would need an `FT_NEW_ARRAY_MULT` array...

	Reported as

	  https://issues.oss-fuzz.com/issues/494362618

2026-03-19  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[sfnt/COLRv0] Revise sanity checks.

	This re-implements 6d62076a and potentially fixes #1404.

	* src/sfnt/ttcolr.c (tt_face_get_colr_layer): Rely on validated total num_layers.

2026-03-19  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/truetype/ttgload.c (TT_Process_Composite_Glyph): Fix allocation.

	Fixes #1403, proposed by Chris Anderson.

2026-03-18  Werner Lemberg  <wl@gnu.org>

	* src/sdf/ftsdf.c (sdf_generate_bounding_box): Fix allocation.

	Reported in

	  https://mail.gnu.org/archive/html/freetype-devel/2026-02/msg00005.html

2026-03-11  Werner Lemberg  <wl@gnu.org>

	Update all copyright notices.

2026-03-10  Alexei Podtelezhnikov  <apodtele@gmail.com>

	.gitlab-ci.yml: Upgrade Windows pipelines.

2026-03-10  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[base] Reintroduce overall rendering limits.

	* src/base/ftobjs.c (ft_glyphslot_preset_bitmap): Limit absolute
	outline coordinnates to prevent integer issues downstream.

2026-03-10  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/base/ftglyph.c (FT_Glyph_To_Bitmap): Fix memory leak.

	This leak was introduced in 85c8efe0afa5ad by overlooking the
	direct `ft_bitmap_glyph_init` call (now gone). Fixes #1399,
	also reported earlier:
	  https://issues.oss-fuzz.com/issues/482909897.

2026-03-10  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/raster/ftraster.c (Conic_To, Cubic_To): Avoid UB.

	Fixes #1396.

2026-03-10  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[stroker] Actually validate outlines.

	Fixes #1400.

	* src/base/ftstroke.c (FT_Glyph_Stroke): Check for `GetCount` error.
	(ft_stroke_border_get_counts): Actually return expected error.
	(FT_Glyph_Stroke): Minor.

2026-03-09  Miguel Sousa  <@miguelsousa>

	* src/sfnt/ttobjs.c (tt_size_init_bytecode): Be more generous.

	Fixes issue #1137.

2026-03-09  Werner Lemberg  <wl@gnu.org>

	* src/sfnt/ttgpos.c (tt_face_load_gpos): Correctly release `gpos`.

	This is a follow-up to issue #1398.

2026-03-09  Dominik Röttsches  <drott@chromium.org>

	[sfnt] Use array count in sanitization of `BaseGlyphPaintRecord` list.

	* src/sfnt/ttcolr.c (tt_face_load_colr): Compute correct length
	  of `BaseGlyphPaintRecord` array size.

	Fixes issue #1397.

2026-03-09  Werner Lemberg  <wl@gnu.org>

	* src/sfnt/ttgpos.c (tt_face_validate_pair_pos2): Correct limit check.

	Fixes issue #1398.

2026-03-09  Werner Lemberg  <wl@gnu.org>

	* src/truetype/ttgload.c (load_truetype_glyph): Limit recursion.

	Fixes issue #1395.

2026-03-08  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/raster/ftraster.c (Set_High_Precision): Limit size.

	This should avoid integer overflows:
	   https://issues.oss-fuzz.com/issues/490433932
	   https://issues.oss-fuzz.com/issues/490464129

2026-03-06  Werner Lemberg  <wl@gnu.org>

	[cid] Add boundary check in incremental interface.

	* src/cid/cidgload.c (cid_load_glyph) [FT_CONFIG_OPTION_INCREMENTAL]:
	  Validate `fd_select`.

	Fixes issue #1394.

2026-03-06  Werner Lemberg  <wl@gnu.org>

	* src/sfnt/ttgpos.c (tt_face_get_pair_pos1_kerning): Typo.

	This could lead to make FreeType miss some kerning pairs.

	Fixes issue #1393.

2026-03-06  Werner Lemberg  <wl@gnu.org>

	* src/sfnt/ttgpos.c (tt_face_get_class): Fix range check.

	Fixes issue #1392.

2026-03-06  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[base] Adjust rendering limits.

	* src/base/ftobjs.c (ft_glyphslot_preset_bitmap): Check width and
	height directly. Fixes #1390.

2026-03-03  Debbie Goldsmith  <goldsmit@apple.com>

	[truetype] Reject fonts without 'glyf' and 'loca' table.

	* src/truetype/ttobjs.c (tt_face_init): Add check.

2026-03-03  Werner Lemberg  <wl@gnu.org>

	Minor whitespace.

2026-03-03  Werner Lemberg  <wl@gnu.org>

	CMakeLists.txt: Formatting.

2026-03-02  Werner Lemberg  <wl@gnu.org>

	* subprojects/*: Fix meson wrap files.

2026-03-01  Werner Lemberg  <wl@gnu.org>

	* Version 2.14.2 released.
	==========================

	Tag sources with `VER-2-14-2'.

	* docs/VERSION.TXT: Add entry for version 2.14.2.
	* docs/CHANGES: Updated.
	* docs/release, docs/README, builds/macs/README: Updated.

	* README, src/base/ftver.rc, builds/windows/vc2010/index.html,
	  builds/windows/visualc/index.html, builds/windows/visualce/index.html,
	  builds/wince/vc2005-ce/index.html, builds/wince/vc2008-ce/index.html,
	  docs/freetype-config.1: s/2.14.1/2.14.2/, s/2141/2142/.

	* include/freetype/freetype.h (FREETYPE_PATCH): Set to 2.

	* builds/unix/configure.raw (version_info): Set to 26:5:20.
	* CMakeLists.txt (VERSION_PATCH): Set to 2.

2026-03-01  Werner Lemberg  <wl@gnu.org>

	* subprojects/*.wrap: Updated.

2026-03-01  Werner Lemberg  <wl@gnu.org>

	Very minor doc fixes.

2026-02-23  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[truetype] Clean up TT_Load_Context.

	* src/truetype/ttinterp.c (TT_Load_Context): Remove return type.
	* src/truetype/ttinterp.h (TT_Load_Context): Update signature.
	* src/truetype/ttobjs.c (tt_size_run_{fpgm,prep}): Update callers.
	* src/truetype/ttgload.c (tt_loader_init): Ditto.

2026-02-21  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[truetype] Use FT_QALLOC_MULT.

	* src/truetype/ttgxvar.c (tt_var_load_item_variation_store): Here.
	This call provides builtin overflow protection. See #1382.

2026-02-21  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/base/ftbitmap.c (FT_Bitmap_Blend): Use FT_ALLOC_MULT.

	This call is fortified with builtin overflow checks.

2026-02-21  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[sdf] Substitute allocation macros.

	* src/sdf/ftsdf.c (sdf_generate_bounding_box,
	sdf_generate_with_overlaps): Use more robust macros.

2026-02-21  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[base] Clean up bitmap allocations.

	* src/base/src/base/ftobjs.c (ft_glyphslot_alloc_bitmap): Use preset
	dimensions and call FT_MEM_ALLOC_MULT.
	* include/freetype/internal/ftobjs.h (ft_glyphslot_alloc_bitmap):
	Updated signature...
	* src/*: ... and all callers.

2026-02-20  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/sfnt/ttcolr.c (tt_face_colr_blend_layer): Use FT_ALLOC_MULT.

	Fixes #1389. The overflow is detected in ft_mem_qrealloc.

2026-02-08  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/base/ftglyph.c (ft_bitmap_glyph_init): Always copy in full.

	Other glyph formats never perform lazy copy.  Fixes #1385.

2026-02-07  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* include/freetype/config/mac-support.h: Check for FT_MACINTOSH.

	Fixes warnings reported in !414.

2026-02-04  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[pshinter] Merge extrema and inflex analyses.

	Any point on the horizontal or vertical segment, which can either
	be either extreme or inflection point is now marked.  This makes
	separate inflection algorithm unnecessary.  This simplifies the
	algorithm without noticeable rendering differences.

	* src/pshinter/pshalgo.c (psh_glyph_compute_extrema): Rewrite
	to detect both extrema and inflection points. Determine the
	their direction instantly.

2026-02-04  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/sfnt/ttgpos.c (tt_face_validate_*): Fix check signedness.

	This is an alternative to !398 without signed -1.

2026-01-28  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/sfnt/sfwoff2.c (reconstruct_glyf): Revise variables.

	This should fix #1379 while resonstructing the code intent.

2026-01-26  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[base, smooth] Implement direct LCD filtering.

	Applying an LCD filter to spans rather than the entire image improves
	the performance of ClearType-like rendering by about 40% at 32 ppem
	and much more at larger sizes.  Small rounding differences are expected.

	* src/smooth/ftsmooth.c (ft_smooth_raster_lcd, ft_smooth_lcd_spans,
	ft_smooth_raster_lcdv, ft_smooth_lcdv_spans, TOrigin): Implement it.
	* include/freetype/internal/ftobjs.h (FT_LibraryRec): lcd_filter_func gone.
	* src/base/ftlcdfil.c (ft_lcd_filter_fir): Removed.
	(ft_lcd_padding): Use padding sufficient for any 5-tap filter.
	(FT_Library_SetLcdFilterWeights, FT_Library_SetLcdFilter): Updated.
	* docs/CHANGES: Updated.

2026-01-25  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[base, smooth] Remove LCD filter from face properties.

	This removes the internal face property that sets the filtering weights.
	The global filtering algorithms and weights are now optimized to work
	well under all conditions.

	* include/freetype/internal/ftobjs.h (FT_Face_InternalRec): Do it.
	* include/freetype/freetype.h (FT_Face_Properties): Revised docs.
	* include/freetype/ftparams.h (FT_PARAM_TAG_LCD_FILTER_WEIGHTS): Ditto.
	* src/base/ftlcdfil.c (ft_lcd_padding): Updated.
	* src/base/ftobjs.c (ft_open_face_internal, FT_Face_Properties): Ditto.
	* src/smooth/ftsmooth.c (ft_smooth_render): Ditto.
	* docs/CHANGES: Updated.

2026-01-25  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[base] Remove legacy LCD filter.

	* src/base/ftlcdfil.c (_ft_lcd_filter_legacy): Removed.
	(FT_Library_SetLcdFilter): Updated.
	* include/freetype/ftlcdfil.h (FT_LcdFilter): Updated.
	* doc/CHANGES: Updated.

2026-01-22  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/svg/ftsvg.c: Use FT_ALLOC_MULT.

	Fixes #1378.

2026-01-19  Harish Raja Selvan  <harish.rajaselvan@multicorewareinc.com>

	* .gitlab-ci.yml: Add MSBuild for ARM64.

2026-01-18  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[base, smooth] Fortify direct rendering.

	This is a better fix for #1384, which is rather about signed overflow.

	* include/freetype/ftimage.h (FT_Span): Use unsigned position.
	* src/smooth/ftgrays.c (gray_sweep_direct): Sync with FT_Span.
	* src/smooth/ftsmooth.c (ft_smooth_render): Remove redundant shift.
	* src/base/ftobjs.c (ft_glyphslot_preset_bitmap): Readjust limits.

2026-01-16  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[base] Maintain overall rendering limits.

	Reject rendering of outlines that stretch beyond 32767 pixels from
	the origin,  which is further restricted to 10922 horizontal pixels
	for LCD rendering with ClearType-like algorithms. 16-bit FT_Span is
	one of the reasons to have this limit imposed, fixes #1384.

	* src/base/ftobjs.c (ft_glyphslot_preset_bitmap): Impose global
	rendering limits.

2026-01-13  Harry Sintonen  <sintonen@iki.fi>

	* src/autofit/ft-hb-ft.c (ft_hb_ft_reference_table): Use `ft_sfree`.

2026-01-10  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[base] Set ppem-based rendering limits.

	Many rendering timeouts occur when the outline stretches far beyond
	the Em size.  Limiting the bounding box to 10 Em should reject such
	requests.  It is still to possible scribble excessively within the set
	limits.  At least, the memory usage will be curtained.

	* src/base/ftobjs.c (ft_glyphslot_free_bitmap): Revise limits based
	on ppem when available.

2026-01-07  Werner Lemberg  <wl@gnu.org>

	[autofit] Prevent signed integer overflow.

	Reported as

	  https://issues.oss-fuzz.com/issues/473887994
	  https://issues.oss-fuzz.com/issues/473912282

	* src/autofit/afatin.c (af_latin_align_top_tilde,
	  af_latin_align_bottom_tilde), src/autofit/afloader.c
	  (af_loader_load_glyph): Use `FT_PIX_ROUND_LONG`, `FT_PIX_CEIL_LONG`, and
	  `SUB_LONG`.

2026-01-06  Werner Lemberg  <wl@gnu.org>

	[truetype] Prevent signed integer overflow.

	Reported as

	  https://issues.oss-fuzz.com/issues/473582311

	* src/truetype/ttinterp.c (Ins_MDRP): Use `ADD_LONG` and `SUB_LONG`.

2026-01-06  Werner Lemberg  <wl@gnu.org>

	[autofit] Prevent signed integer overflow.

	Reported as

	  https://issues.oss-fuzz.com/issues/473582304

	* src/autofit/afloader.c (af_loader_load_glyph): Use `ADD_LONG`.

2026-01-05  Ben Wagner  <bungeman@chromium.org>

	Fix leak of exec->FDefs in tt_size_init_bytecode

2026-01-04  Werner Lemberg  <wl@gnu.org>

	[autofit] Prevent signed integer overflow.

	Reported as

	  https://issues.oss-fuzz.com/issues/471525116

	* src/autofit/aflatin.c (af_latin_stretch_top_tilde,
	  af_latin_stretch_bottom_tilde): Use `MUL_LONG`.

2026-01-04  Celeste Liu  <uwu@coelacanthus.name>

	[base] Fix support for format 13 charmaps.

	According to the OpenType specification of the 'cmap' table, the pair (0,6)
	for platform and encoding IDs is used for format 13 charmap tables.  Commit
	ba6f3e18 (from 2017-01-17) introduced the `TT_APPLE_ID_FULL_UNICODE` macro
	(i.e., encoding_id == 6, added to OpenType 1.8); however, the corresponding
	cmap selection code wasn't updated.

	Unicode's Last Resort font (https://github.com/unicode-org/last-resort-font)
	can be used to test a format 13 charmap.

	Fixes issue #1383.

	* src/base/ftobjc.s (find_unicode_charmap): Support
	  `TT_APPLE_ID_FULL_UNICODE`.

2026-01-03  Werner Lemberg  <wl@gnu.org>

	[ttgxvar] Check for overflow in array size computation.

	Problem reported and analyzed by povcfe <povcfe2sec@gmail.com>.

	Fixes issue #1382.

	* src/truetype/ttgxvar.c (tt_var_load_item_variation_store): Do it.

2025-12-11  Ben Wagner  <bungeman@chromium.org>

	Fix leak of exec in tt_size_init_bytecode

	* src/truetype/ttobjs.c (tt_size_init_bytecode): Call `TT_Done_Context`
	on `exec` if it has not yet been assigned to `size->context`.

	Bug: https://issues.oss-fuzz.com/issues/467782706

2025-12-05  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/pcf/pcfdrivr.c (PCF_Face_Init): Handle charmap errors.

	This is a quick fix for #1377, more clean-ups to follow.

2025-12-04  Werner Lemberg  <wl@gnu.org>

	* src/sfnt/ttbdf.c (tt_face_load_bdf_props): Fix size test.

	This prevents a potential overflow on 32bit systems.

	Problem reported by Zhao Zijie <zijie4@illinois.edu>.

2025-12-04  Werner Lemberg  <wl@gnu.org>

	Improve documentation of the 'BDF ' table as used in X11 `.otb` files.

	Also do some minor code formatting.

2025-12-02  Werner Lemberg  <wl@gnu.org>

	* src/otvalid/otvcommn.c (otv_FeatureList_validate): Fix array size check.

	Reported by Marc Schönefeld.

2025-12-02  Werner Lemberg  <wl@gnu.org>

	[otvalid] Minor formatting and comment fixes.

2025-11-30  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[pshinter] Slightly simplify BlueShift application.

	* src/pshinter/pshglob.c (psh_blues_scale_zones): Just divide.

2025-11-30  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[pshinter] Slightly simplify BlueScale application.

	* src/pshinter/pshglob.c (psh_globals_new): Update condition and
	properly rescale BlueScale.
	(psh_blues_scale_zones): Use it directly.

2025-11-30  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[pshinter] Fix up degenerate contours.

	* src/pshinter/pshalgo.c (psh_glyph_compute_extrema): Use correct
	goto label and shortcut degenerate contours.

2025-11-29  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/base/ftutil.c (FT_List_Finalize): Delay reading 'data'.

	Fixes #1376.

2025-11-29  Werner Lemberg  <wl@gnu.org>

	* src/autofit/afgsub.c (af_parse_gsub): Always init `gsub_lookup_count`.

	Problem reported by Marc Schönefeld.

2025-11-28  Werner Lemberg  <wl@gnu.org>

	[autofit] Fix handling of invalid GSUB lookup indices.

	Problem reported by Marc Schönefeld.

	HarfBuzz validates everything while processing OpenType tables in fonts.
	However, the data returned by `hb_ot_layout_collect_lookups` is not
	validated.  This commit adds proper checks.

	* src/autofit/afglobal.h (AF_FaceGlobals): New field `gsub_lookup_count`.
	* src/autofit/afgsub.c (af_parse_gsub): Set it.

	* src/autofit/afadjust.c (af_reverse_character_map_new): Test result of
	  `hb_set_next`.

2025-11-28  Werner Lemberg  <wl@gnu.org>

	[sfnt] Fix GPOS handling.

	Problem reported by Marc Schönefeld.

	* src/sfnt/ttgpos.c (tt_face_validate_lookup_table, tt_face_load_gpos): Fix
	  counting of fitting subtables by correctly rejecting invalid data.

2025-11-28  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* builds/toplevel.mk (dist): Replace `for` with `find ... -exec`.

2025-11-27  Suzuki, Toshiya (鈴木俊哉)  <mpsuzuki@hiroshima-u.ac.jp>

	* builds/toplevel.mk (dist): `-wholename` -> `-name`.

	POSIX does not request `find` to support '-wholename'.
	`find ... -wholename '*/.git' -prune -o ...` can be
	rewritten as `find ... -name '*/.git' -prune -o ...`
	for POSIX find.  Fixes issue #1370.

2025-11-27  suzuki toshiya  <mpsuzuki@hiroshima-u.ac.jp>

	* .gitlab-ci.yml: update macos image to Tahoe:2025-09-30.

	Fixes issue #1394.

2025-11-17  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* builds/toplevel.mk (dist): Improve compatibility with BSD tar.

2025-11-05  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[cff] Handle underline position and thickness as integers.

	This is done for consistency with Type 1 fonts.

	* include/freetype/internal/cfftypes.h (CFF_FontRecDic): Change
	the variable types.
	* include/cff/cfftoken.h (CFF_FontRecDic): Change the parsing macros.
	* src/cff/cffobjs.c (cff_face_init), src/cff/cffload.c (cff_subfont_load),
	src/cff/cffdrivr.c (cff_ps_get_font_info): Update users.

2025-11-05  suzuki toshiya  <mpsuzuki@hiroshima-u.ac.jp>

	* src/tools/apinames.c (names_add): Remove unrequired cast of
	  `nm->hash` to int, which has been unrequired since eba2781a.

	Fixes issue #1361.

2025-11-05  Suzuki, Toshiya (鈴木俊哉)  <mpsuzuki@hiroshima-u.ac.jp>

	* src/autofit/afgsub.c: Evaluate FT_CONFIG_OPTION_USE_HARFBUZZ
	  after <freetype/freetype.h> and others.

	Fixes issue #1360.

2025-11-05  Alexei Podtelezhnikov  <apodtele@gmail.com>

	Minor.

2025-11-05  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[cff,cid,type1,type42] Fix up `PS_FontInfo`.

	The italic angle is commonly specified in fractional degrees in
	Type 1 fonts and its derivatives.  This change clarifies and fixes
	these values.  Note that CFF fonts has always reported them as such,
	but truncated the underline position and thickness.  Fixes #1367.

	* include/freetype/t1tables.h (PS_FontInfoRec):
	Use FT_Fixed for italic_angle.
	* src/cid/cidtoken.h, src/type1/t1tokens.h, src/type42/t42parse.c:
	Modify the italic_angle token.
	* src/cff/cffdrivr.c (cff_ps_get_font_info): Fix the underline
	position and thickness.

	* docs/CHANGES: Note this change.

2025-10-26  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/base/ftadvanc.c (ft_face_scale_advances_): Adjust scaling.

	This is safe because advances are short originally.

2025-10-26  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[base] Refactor obtaining advances.

	* src/base/ftadvanc.c (ft_load_advances): New separate function to
	handle slow advances.
	(FT_Get_Advance, FT_Get_Advances): Updated.

2025-10-17  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/truetype/ttgload.c (tt_loader_init): Reset compatibility.

	This may fix #1262, credits to Honnesh Ramachandra.
	    https://lists.nongnu.org/archive/html/freetype-devel/2025-10/msg00004.html

2025-09-28  Werner Lemberg  <wl@gnu.org>

	[autofit] Prevent signed integer overflow.

	* src/autofit/aflatin.c (af_latin_stretch_top_tilde,
	  af_latin_stretch_bottom_tilde, af_latin_align_top_tilde,
	  af_latin_align_bottom_tilde,
	  af_glyph_hints_apply_vertical_separation_adjustments): Use `ADD_LONG` and
	  `SUB_LONG` for values that involve `FT_LONG_MAX` and `FT_LONG_MIN`.

	Fixes issue #1363.

2025-09-24  Werner Lemberg  <wl@gnu.org>

	* src/bdf/bdfdriver.c (BDF_Glyph_Load): Use `bdf->bdffont->bpp` directly.

	Fixes issue #1362.

2025-09-18  Alan Coopersmith  <alan.coopersmith@oracle.com>

	* tests/README.md: Fix a script name.

2025-09-14  Werner Lemberg  <wl@gnu.org>

	[build] Don't use non-POSIX escapes in sed regexp.

	* builds/unix/configure.raw (ftoption_set, ftoption_unset): Avoid `\>`.

	Fixes issue #1358.

2025-09-14  Werner Lemberg  <wl@gnu.org>

	Typo.

2025-09-12  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* include/freetype/internal/ftobjs.h (ft_default_raster): Relic removed.

2025-09-11  Werner Lemberg  <wl@gnu.org>

	* Version 2.14.1 released.
	==========================

	Tag sources with `VER-2-14-1'.

	* docs/VERSION.TXT: Add entry for version 2.14.1.
	* docs/CHANGES: Updated.
	* docs/release, docs/README, builds/macs/README: Updated.

	* README, src/base/ftver.rc, builds/windows/vc2010/index.html,
	builds/windows/visualc/index.html, builds/windows/visualce/index.html,
	builds/wince/vc2005-ce/index.html, builds/wince/vc2008-ce/index.html,
	docs/freetype-config.1: s/2.14.0/2.14.1/, s/2140/2141/.

	* include/freetype/freetype.h (FREETYPE_PATCH): Set to 1.

	* builds/unix/configure.raw (version_info): Set to 26:4:20.
	* CMakeLists.txt (VERSION_PATCH): Set to 1.

2025-09-10  Behdad Esfahbod  <behdad@behdad.org>

	[base] Fix return values of two Font Variation functions.

	* src/base/ftmm.c (FT_Set_Var_Design_Coordinates,
	  FT_Set_Var_Blend_Coordinates): Do it.

	Fixes issue #1355.

2025-09-10  Werner Lemberg  <wl@gnu.org>

	* src/autofit/afgsub.c (af_map_lookup): Fix handling of lookup type 7.

	Fixes issue #1356.

2025-09-08  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/truetype/ttinterp.c (TT_Run_Context): Fix IUP tracking bits.

	Correctly fixes #1353 and #1349.

2025-09-08  Alexei Podtelezhnikov  <apodtele@gmail.com>

	Typo!

2025-09-08  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/truetype/ttinterp.c (TT_Run_Context): Reset IUP tracking bits.

	Fixes #1353.

2025-09-08  Behdad Esfahbod  <behdad@behdad.org>

	[autofit] Fix HarfBuzz calling.

	* src/autofit/afadjust.c (af_reverse_character_map_new)
	  [FT_CONFIG_OPTION_USE_HARFBUZZ]: Use `ft_hb_enabled`.

	Fixes issue #1354.

2025-09-08  Werner Lemberg  <wl@gnu.org>

	* docs/release: Use `sshpass` for SourceForge.net password.

2025-09-08  Werner Lemberg  <wl@gnu.org>

	* docs/release: Fix `scp` usage with OpenSSH version >= 9.0.

	Starting with this version, OpenSSH uses `scp` with the SFTP protocol as the
	default.  However, SFTP is disabled on savannah.gnu.org since January 2025.

2025-09-06  Werner Lemberg  <wl@gnu.org>

	* Version 2.14.0 released.
	==========================

	Tag sources with `VER-2-14-0'.

	* docs/VERSION.TXT: Add entry for version 2.14.0.
	* docs/CHANGES: Updated.
	* docs/release, docs/README, builds/macs/README: Updated.

	* README, src/base/ftver.rc, builds/windows/vc2010/index.html,
	builds/windows/visualc/index.html, builds/windows/visualce/index.html,
	builds/wince/vc2005-ce/index.html, builds/wince/vc2008-ce/index.html,
	docs/freetype-config.1: s/2.13.3/2.14.0/, s/2133/2140/.

	* include/freetype/freetype.h (FREETYPE_MINOR): Set to 14.
	(FREETYPE_PATCH): Set to 0.

	* builds/unix/configure.raw (version_info): Set to 26:3:20.
	* CMakeLists.txt (VERSION_MINOR): Set to 14.
	(VERSION_PATCH): Set to 0.

2025-09-06  Werner Lemberg  <wl@gnu.org>

	* builds/toplevel.mk (do-dist): Download shallow clone of `config.git`.

	No need for any other commit than the current one.

2025-09-06  Werner Lemberg  <wl@gnu.org>

	Update all copyright notices.

2025-09-05  Werner Lemberg  <wl@gnu.org>

	src/sfnt/ttload.c (tt_face_load_any): Correctly handle font containers.

	Reported as

	  https://issues.oss-fuzz.com/issues/424613326

2025-09-05  Jouk Jansen  <joukj@hrem.nano.tudelft.nl>

	Clean up OpenVMS support.

	This avoids cluttering the source code with VMS-specific changes.

	* include/freetype/internal/ftcalc.h [__VMS], src/base/ftcalc.c
	  [vms_auto64_source]: Remove.

	* builds/vms/patch_ftcalc.sed: New file.

	* vms_make.com: Change macro definitions while this script is running; we
	  use `GNU sed` to inject the necessary preprocessor code on the fly.

2025-09-01  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/psaux/psauxmod.h (psaux_driver_class): Removed declaration.

2025-08-29  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[base] Use const FT_Module_Class.

	This is intended to warn against modifying any fields in the class,
	at compile-time and avoid crashes at run-time.

	* include/freetype/internal/ftobjs.h (FT_ModuleRec): Do it.
	* src/base/ftobjs.c (Destroy_Module, FT_Add_Module): Updated.

2025-08-27  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/base/ftobjs.c (FT_Load_Glyph): Reduces scope of 'ttface'.

2025-08-25  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/truetype/ttinterp.c: Fix some builds.

2025-08-23  Werner Lemberg  <wl@gnu.org>

	* subprojects/*.wrap: Updated.

2025-08-23  Werner Lemberg  <wl@gnu.org>

	Updating `CHANGES` file; minor fixes elsewhere (mostly formatting).

2025-08-20  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[truetype] Fix compilation without bytecode.

	Fixes #1351 and various warnings about unused variables.

	* src/truetype/ttinterp.c: Put the entire body under #ifdef.
	* src/truetype/ttgload.c (TT_Process_Composite_Glyph): Relocate
	some declarations.
	* src/truetype/ttinterp.h: Remove some #ifdef conditions.
	* src/truetype/ttobjs.c (tt_size_done): Modified.

2025-08-14  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[truetype] Small fix in the incremental interface (again).

	

	Fixes #1299, last [-Wdangling-pointer=] warning.

	

	* src/truetype/ttgload.c (load_truetype_glyph): Restore original stream

	on exit unconditionally.

2025-08-14  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[truetype] Small fix in the incremental interface.

	

	Fixes #1299, last [-Wdangling-pointer=] warning.

	

	* src/truetype/ttgload.c (load_truetype_glyph): Restore original stream

	on exit.

2025-08-14  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/autofit/afgsub.c: Fix a warning.

	

	Fixes [-Wunused-function] warning without HarfBuzz.

2025-08-11  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* */ftoption.h: Update C99 wording.

2025-08-11  Alexei Podtelezhnikov  <apodtele@gmail.com>

	*  */ftoption.h: Note C99 compliance.

2025-08-08  Behdad Esfahbod  <behdad@behdad.org>

	[ttgxvar] Fix caching of scalars when there are intermediate tuples.

	For example, with `GoogleSansFlex-Regular.ttf` at ROND=100, the 'Q' glyph
	was misrendering.

	* src/truetype/ttgxvar.c (TT_Vary_Apply_Glyph_Deltas): Reset `tupleScalars`
	  earlier.

2025-08-05  Jouk Jansen  <joukj@hrem.nano.tudelft.nl>

	Improvements to OpenVMS support.

	* include/freetype/internal/ftcalc.h [__VMS]: Undefine `FT_MulFix`.

	* src/base/ftcalc.c [vms_auto64_source]: Define `FT_MulFix`.

	* vms_make.com: Also create 32bit version of the FreeType library.

2025-08-04  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* docs/CHANGES: Mention 'ftmulti' improvements.

2025-08-02  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[type1/MM] Correctly reset the default instance.

	Call T1_Set_MM_WeightVector, which actually sets default weights,
	instead of TT_Set_MM_Blend, which just centers the axes.

	* src/type1/t1load.c (T1_Reset_MM_Blend): Do it.

2025-08-01  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[truetype/v40] Fix ROUND_XY_TO_GRID handling.

	Fixes #1346.

	* src/truetype/ttgload.c (TT_Process_Composite_Component): Round
	the x-position unless in backward_compatibility mode.

2025-07-30  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/truetype/ttinterp.c (Ins_MDRP,MIRP): Small tweak.

2025-07-30  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[truetype] Tweak size management.

	* include/freetype/internal/services/svmetric.h (FT_Size_Reset_Func):
	Update typedef, do not return error.
	* src/truetype/ttobjs.c (tt_size_reset_height): Move the PPem error
	handling from here...
	(tt_size_reset): ... to here to improve readability.
	src/truetype/ttobjs.h (tt_size_reset_height): Update prototype.

2025-07-30  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[truetype] Relocate color compensation (cont'd).

	* src/truetype/ttinterp.c (Inc_MDAR,MIAP,MDRP,MIRP): Fix forgotten
	rounding.

2025-07-29  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[truetype] Fix EVEN and ODD instructions.

	It is possible to have a fractional part after rounding when rounding
	to half-grid or super-rounding. The specs call to ignore the fractional
	part in that case.

	^ src/truetype/ttinterp.c (Ins_EVEN, Ins_ODD): Fix mask.

2025-07-28  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/truetype/ttinterp.c: Fix comments.

2025-07-28  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/truetype/ttinterp.h (TT_Round_Func): Fix argument.

	Fixes #1347: function type mismatch.

2025-07-27  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[truetype] Clean up size validation.

	Rely on non-zero ppem to validate the size object.

	* src/truetype/ttobjs.h (TT_Size_Merics): Remove the `valid` flag.
	* src/truetype/ttobjs.c (tt_size_init,done,reset,reset_height): Updated.
	* src/truetype/ttgload.c (TT_Load_Glyph): Check for non-zero ppem.

2025-07-27  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[truetype] Relocate color compensation.

	The rounding color compensation, which is not used by FreeType, belongs
	to GS. This is a more logical place for it, next to round_state.

	* src/truetype/ttobjs.h (TT_GraphicsState): Move compensations here...
	(TT_Size_Metrics): ... from here.
	* src/truetype/ttobjs.c (tt_size_init_bytecode): Updated.
	* src/truetype/ttinterp.c (tt_default_graphics_state): Updated.
	(Ins_ROUND,NROUND,EVEN,ODD): Updated.
	(Round_*): Updated.

2025-07-26  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[smooth] Remove usage of setjmp and longjmp.

	To support WASM targets with slow or unsupported setjmp and longjmp,
	we eliminate these calls in favor of an error propagation model.
	When gray_set_cell is out of cells, it raises an exception which is
	later handled in gray_convert_glyph_inner.
	This is a less invasive alternative to !385.

	* src/smooth/ftgrays.c (gray_set_cell): Raise the overflow exception
	and redirect all work to `cell_null`.
	(gray_move,line,conic,cubic_to): Return the exception.
	(gray_convert_glyph, gray_convert_glyph_inner): Handle the exception.

2025-07-05  Werner Lemberg  <wl@gnu.org>

	[sfnt] Rewrite GPOS kerning support. (2/2)

	The previous code had a fundamental flaw: it didn't validate the necessary
	parts of the 'GPOS' table before accessing it, causing crashes with
	malformed data (since `TT_CONFIG_OPTION_GPOS_KERNING` is off by default,
	standard fuzzers don't catch these problems).  Additionally, it did a lot of
	parsing while accessing kerning data, making it rather slow.

	The new implementation fixes this.  After validation, offsets to the 'GPOS'
	lookup subtables used in the 'kern' feature that correspond to 'simple'
	kerning (i.e., similar to 'kern' table kerning) are stored in `TT_Face`;
	this greatly simplifies and accelerates access to the kerning data.

	Testing with font `SF-Pro.ttf` version '1.00', the validation time for the
	'GPOS' table increases the start-up time of `FT_New_Face` by less than 1%,
	while calls to `FT_Get_Kerning` become about 3.5 times faster.

	* include/freetype/internal (gpos_kerning_available): Replace with...
	  (gpos_lookups_kerning, num_gpos_lookups_kerning): ... these new fields.
	  Update callers.

	* src/ttgpos.c [TT_CONFIG_OPTION_GPOS_KERNING]: A new implementation.

2025-07-05  Werner Lemberg  <wl@gnu.org>

	[sfnt] Rewrite GPOS kerning support. (1/2)

	This commit removes the previous implementation.

2025-07-05  Werner Lemberg  <wl@gnu.org>

	[cff] Support GPOS kerning.

	* src/cff/cffdrivr.c (cff_get_kerning) [TT_CONFIG_OPTION_GPOS_KERNING]: Add
	  code similar to the one in `tt_get_kerning`.

2025-07-05  Werner Lemberg  <wl@gnu.org>

	* src/sfnt/ttkern.h (TT_FACE_HAS_KERNING): Remove macro.

	Given that we also support (limited) 'GPOS' table kerning if
	`TT_CONFIG_OPTION_GPOS_KERNING` is defined, the name of this macro is
	misleading since it only is true for 'kern' table kerning.

	* src/sfnt/sfobjs.c (sfn_load_face): Replace `TT_FACE_HAS_KERNING` with
	  plain code.

2025-07-05  Werner Lemberg  <wl@gnu.org>

	[autofit] Remove `globals->gsub_length`.

	We completely validate the accessed data from the 'GSUB' table, making this
	field unnecessary.

	* src/autofit/afglobal.h (AF_FaceGlobalsRec): Remove `gsub_length` field.

	* src/autofit/afglobal.c (af_face_globals_new), src/autofit/afgsub.c
	  (af_parse_gsub): Updated.

2025-07-01  Werner Lemberg  <wl@gnu.org>

	* src/truetype/ttobjs.c (tt_size_init_bytecode): Correct previous fix.

	`FT_NEW_ARRAY` expects a signed value, not an unsigned one.

2025-07-01  Werner Lemberg  <wl@gnu.org>

	* src/autofit/afgsub.c: Include `tttables.h` and `afgsub.h`.

	This fixes 'make multi' compilation with clang.

	Reported as

	  https://gitlab.freedesktop.org/freetype/freetype/-/merge_requests/381#note_2984610

2025-07-01  Werner Lemberg  <wl@gnu.org>

	Various minor fixes.

	As reported by clang 19.

	* src/autofit/afadjust.c (adjustment_database): Make it static.

	* src/base/ftdbgmem.c (FT_MEM_SIZE_MIN): Remove unused macro.

	* src/psaux/psobjs.c (skip_procedure), src/truetype/ttinterp.c (Ins_IF,
	  Ins_ELSE, Ins_FDEF, Ins_IDEF): Add `default` clause.

2025-07-01  Werner Lemberg  <wl@gnu.org>

	More signedness fixes.

	As reported by clang 19.

	* src/autofit/afadjust.c (add_substitute): Make first argument unsigned.
	  Update all callers.
	  Other minor signedness fixes.
	  (af_reverse_character_map_new): Minor signedness fixes.

	* src/autofit/afgsub.c (af_hash_insert): Minor signedness fixes.

	* src/autofit/aflatin.c
	  (af_glyph_hints_apply_vertical_separation_adjustments): Make third
	  argument unsigned.
	  Update all callers.
	  Other minor signedness fixes.
	  (af_latin_hints_apply): Minor signedness fixes.

	* src/bdf/bdflib.c (bdf_parse_bitmap_): Minor signedness fix.

	* src/truetype/ttobjs.c (tt_size_init_bytecode): Minor signedness fix.

2025-07-01  Werner Lemberg  <wl@gnu.org>

	*/*: Fix trivial signedness issues with format strings in trace messages.

	As reported with clang 19's `-Wformat` option.

2025-07-01  Werner Lemberg  <wl@gnu.org>

	Fix `make multi`.

	Reported as

	  https://gitlab.freedesktop.org/freetype/freetype/-/merge_requests/381#note_2984253

	* src/base/fthash.c: Include `ftobjs.h`.
	* src/autofit/afgsub.c: Include `afglobal.h`.

2025-06-30  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* MSBuild.sln: Minor.

2025-06-29  Werner Lemberg  <wl@gnu.org>

	[doc] Revise font variation API.

2025-06-29  Werner Lemberg  <wl@gnu.org>

	[doc] Use 'Adobe MM', 'TrueType GX', and 'OpenType Font Variations'.

2025-06-26  Werner Lemberg  <wl@gnu.org>

	Set minimum HarfBuzz version back to 2.0.0.

	Due to the new GSUB parsing we no longer need
	`hb_ot_layout_lookup_get_glyph_alternates`.

	This partially reverts commit 5d2fd7608a9.

	* CMakeLists.txt (HARFBUZZ_MIN_VERSION), meson.build (harfbuzz_dep),
	  builds/unix/configure.raw (harfbuzz_pkg): Set version to 2.0.0.

	* src/autofit/ft-hb-decls.h: Remove entry for
	  `hb_ot_layout_lookup_get_glyph_alternates`.

2025-06-26  Werner Lemberg  <wl@gnu.org>

	[autofit] Speed up computation of `af_reverse_character_map_new`. (4/4)

	With this commit, the start-up time for creating the reverse character map
	gets reduced from more than 300% to about 25% (as tested with `arial.ttf`
	version 7.00).

	* src/autofit/afadjust.c [FT_CONFIG_OPTION_USE_HARFBUZZ]: Include
	  `afgsub.h`.
	  (add_substitute): New auxiliary function to recursively add elements to
	  the reverse cmap.
	  (af_reverse_character_map_new): New code that replaces the old code
	  removed in the previous commit.

2025-06-26  Werner Lemberg  <wl@gnu.org>

	[autofit] Speed up computation of `af_reverse_character_map_new`. (3/4)

	Rip out some HarfBuzz code of `af_reverse_character_map_new`.  The new code
	comes immediately in a follow-up commit, making it easier to follow the
	changes.

	* src/autofit/afadjust.c (af_get_glyph_alternates_helper,
	  af_get_glyph_alternates): Remove.
	  (af_reverse_character_map_new): Remove code to create the `*map` hash.

2025-06-26  Werner Lemberg  <wl@gnu.org>

	[autofit] Speed up computation of `af_reverse_character_map_new`. (2/4)

	Create an array of GSUB lookup indices for `SingleSubst` and
	`AlternateSubst` lookup types to exit early if we have different types.

	Also improve tracing.

	* src/autofit/afglobal.h (AF_FaceGlobals) [FT_CONFIG_OPTION_USE_HARFBUZZ]:
	  New fields `gsub_length`, `gsub`, and `gsub_lookups_single_alternate`.

	* src/autofit/afglobal.c [FT_CONFIG_OPTION_USE_HARFBUZZ]: Include
	  `afgsub.h`.
	  (af_face_globals_new) [FT_CONFIG_OPTION_USE_HARFBUZZ]: Call
	  `af_parse_gsub` to fill `gsub_lookups_single_alternate`.
	  (af_face_globals_free): Updated.

	* src/autofit/afadjust.c (af_get_glyph_alternates_helper): Exit early if we
	  possible.
	  (af_reverse_character_map_new): Trace GSUB lookup indices to be checked.

2025-06-26  Werner Lemberg  <wl@gnu.org>

	[autofit] Speed up computation of `af_reverse_character_map_new`. (1/4)

	Using HarfBuzz's API functions to construct the reverse map is too slow; we
	have to call `hb_ot_layout_lookup_get_glyph_alternates` far too often
	because it can only handle a single glyph at a time.  For this reason we are
	going to parse the GSUB table by ourselves.

	The new non-local functions are `af_parse_gsub` and `af_map_lookup`.

	* src/autofit/afgsub.c, src/autofit/afgsub.h: New files for parsing,
	  validating, and mapping the `SingleSubst` and `AlternateSubst` subtable
	  types of a GSUB table.

	* src/autofit/autofit.c, src/autofit/rules.mk (AUTOF_DRV_SRC): Updated.

2025-06-26  Werner Lemberg  <wl@gnu.org>

	[base] Add no-overwrite hash insert functions.

	* src/base/fthash.c (ft_hash_num_insert_no_overwrite,
	  ft_hash_str_insert_no_overwrite): New functions.
	* include/freetype/internal/fthash.h: Updated.

2025-06-26  Werner Lemberg  <wl@gnu.org>

	[base] Add iterators for `FT_Hash`.

	* src/base/fthash.c (ft_hash_num_iterator, ft_hash_str_iterator): New
	  functions.
	* include/freetype/internal/fthash.h: Updated.

2025-06-24  Werner Lemberg  <wl@gnu.org>

	[truetype] Add comment to explain heuristic limit for twilight points.

2025-06-23  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[truetype] Restore non-persistent CVT and storage.

	

	According to specifications, CVT and storage area may or may not be

	persistent after modifications by a glyf program.  FreeType had always

	reset them, which was broken by the last commit.

	

	* src/truetype/ttinterp.c (TT_Load_Context): Set CVT and storage here.

	* src/truetype.ttobjs.c (tt_size_run_prep): Prioritize TT_Load_Context.

	(tt_size_init_bytecode): Allocate but not set CVT and storage area.


2025-06-22  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[truetype] Deduplicate 'codeRangeTable'.

	* src/truetype/ttinterp.c (TT_Load_Context, TT_Save_Context): Do not
	copy 'codeRangeTable'.
	* src/truetype/ttobjs.h (TT_Size): Remove 'codeRangeTable'.
	(TT_CodeRange_Tag, TT_CodeRange, TT_DefArray): Moved to...
	* src/truetype/ttinterp.h: ... this header.1

2025-06-22  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[truetype] Simplify bytecode allocations.

	To avoid repeated synchronization, some TT_Size allocations are moved
	TT_ExecContext for good.  The memory blocks are also consolidated.

	* src/truetype/ttinterp.c (TT_{Load,Save,Done}_Context): Remove
	synchronization and stack management.
	* src/truetype/ttobjs.c (tt_size_{init,done}_bytecode): Manage allocations
	and assign them to the execution context.
	(tt_size_run_prep): Updated.

2025-06-22  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[truetype] Rework handling of rendering mode in bytecode.

	This replaces a large number of confusing boolean constructs that
	describe the target rendering mode in the execution context with
	the straight mode variable.  It might fix some hidden bugs when
	FT_LOAD_TARGET_XXX were used as flags, which they are not.

	The condition that triggers the CV program re-execution is simplified.
	These events due the rendering mode change are rather rare and unexpected
	and, therefore, should not be over-analyzed. In v40, all mode changes
	now trigger the CV program. In v35, only switches to/from mono do.

	* src/truetype/ttinterp.h (TT_ExecContext): Replace 'grayscale',
	'grayscale_cleartype', 'subpixel_hinting_lean', and 'vertical_lcd_lean'
	with the rendering 'mode'.
	* src/truetype/ttinterp.c (Ins_GETINFO): Updated.
	* src/truetype/ttgload.c (tt_loader_init): Replace 'prep' re-execution
	trigger and update 'backward_compatibility' condition.
	(tt_loader_set_pp): Updated.

2025-06-21  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/truetype/{ttinterp.c,ttobjs.c}: Minor.

2025-06-21  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[truetype] Clean up bytecode execution triggers.

	This avoids executing the CV program twice and cleans up the use of
	'fpgm' and 'prep' triggers

	* src/truetype/ttgload.c (tt_loader_init): Call 'tt_size_init_bytecode'
	and 'tt_size_run_prep' explicitly and avoid the call repetition.
	* src/truetype/ttobjs.c (tt_size_ready_bytecode): Removed as unused.
	(tt_size_init, tt_size_init_bytecode, tt_size_done_bytecode): Remove some
	'fpgm' and 'prep' triggers and update.
	(tt_size_run_fpgm, tt_size_run_prep): Do not set the pedantic flag here.
	* src/truetype/ttobjs.h: Update signatures.

2025-06-21  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/truetype/ttgload.c (tt_loader_init, load_sbit_image): Clean up.

2025-06-21  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[truetype] Simplify twilight zone management.

	* include/freetype/internal/tttypes.h (TT_GlyphZone): Remove 'memory'.
	* src/truetype/ttobjs.c (tt_glyphzone_done): Use 'memory' as argument.
	(tt_glyphzone_new, tt_glyphzone_done): Allocate/free as a single block.
	(tt_size_init_bytecode, tt_size_done_bytecode): Updated.
	* src/truetype/ttobjs.h (tt_glyphzone_done): Updated signature.

2025-06-19  Behdad Esfahbod  <behdad@behdad.org>

	[autofit] Really fix handling of `RTLD_DEFAULT`.

	This commit actually implements what commit 43ec023e1a7 describes.

	* src/autofit/ft-hb.c (FT_RTLD_FLAGS): New macro for `dlopen`; it uses
	  `RTLD_GLOBAL` only if `RTLD_DEFAULT` is available.

2025-06-15  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[truetype] Revise twilight zone initiation.

	This assures that twilight zone is reset before each CV program
	execution, including after the rendering mode switch. Fixes #1344.

	* src/truetype/ttobjs.c (tt_size_ready_bytecode): Relocate the GS
	the twilight zone initiation from here...
	(tt_size_run_prep): ... to this function, sho that it is always
	done prior to the CV program execution.
	* src/truetype/ttobjs.c (TT_Run_Context): Set twilight zone here...
	(TT_Load_Context): ... rather than here, as it used to be.

2025-06-13  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/base/ftrfork.c (FT_Raccess_Get_DataOffsets): Remove check.

	

	The highest (sign) attribute bit is reserved and should be zero.

	It is harmless to omit this check however. Fixes #1342.

2025-06-12  Werner Lemberg  <wl@gnu.org>

	[autofit] Ignore virtual glyph indices from GSUB lookups.

	Reported as

	  https://issues.chromium.org/issues/420401651

	* src/autofit/afadjust.c (af_reverse_character_map_new): Implement it.

2025-06-11  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[truetype] Clean up TT_GlyphZone.

	

	* include/freetype/internal/tttypes.h (TT_GlyphZone): Delete fields.

	* src/truetype/ttobjs.c (tt_glyphzone_new, tt_glyphzone_done,

	tt_size_init_bytecode): Updated.

2025-06-11  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[truetype] Use FT_ARRAY_ZERO.

	* src/truetype/ttgxvar.c (TT_Vary_Apply_Glyph_Deltas): Updated.
	* src/truetype/ttobjs.c (tt_check_trickyness_sfnt_ids,
	tt_size_ready_bytecode): Updated.

2025-06-11  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[truetype] Rearrange bytecode run.

	This is a minor change with large code rearrangements.

	* src/truetype/ttinterp.c (TT_RunIns): Just loop through instructions
	and move all setup to...
	(TT_Run_Context): ... here; relocated.
	(Compute_Round): Replaced by simple assignment, removed.

2025-06-11  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[truetype] Relocate the interpreter pointer.

	This reduces dereferencing when calling the interpreter.

	* include/freetype/internal/tttypes.h (TT_Face): Move it from here...
	* src/truetype/ttinterp.h (TT_ExecContext): ... to here.
	* src/truetype/ttobjs.c (tt_size_init_bytecode):  Move its initialization
	* src/truetype/ttinterp.c (TT_New_Context): ... to here.
	(TT_Run_Context): Updated.

2025-06-11  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[truetype] Clean up the loader initiation.

	* include/freetype/internal/tttypes.h (TT_LoaderRec): Remove unused field.
	* src/truetype/ttgload.c (tt_loader_init): Refactor.

2025-06-11  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[truetype] Modify bytecode initiation.

	This reduces the number of function calls and data copying events.

	* src/truetype/ttinterp.c (TT_Goto_CodeRange): Merge into...
	(TT_Set_CodeRange): ... this function.
	(TT_Load_Context): Do not set up any zones, copy GS, or prepare the
	execution...
	(TT_Run_Context): ... do this here instead..
	* src/truetype/ttinterp.c (TT_Set_CodeRange): Update signature.
	* src/truetype/ttobjs.c (tt_size_run_fpgm, tt_size_run_prep): Call
	TT_Run_Context.
	* src/truetype/ttgload.c (TT_Hint_Glyph, tt_loader_init): Updated.

2025-06-11  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[truetype] Modify the graphics state management.

	Instead of restoring persistent GS variables, we only save modifications
	permitted by the CVT program. This reduces the context manipulations.

	* src/truetype/ttobjs.h (TT_GraphicsState): Reorder fields.
	* src/truetype/ttobjs.c (tt_size_run_fpgm, tt_size_run_prep):
	Do not alter the context.

	* src/truetype/ttgload.c (TT_Hint_Glyph): Do not reset GS.
	(tt_loader_init): Fix potential issue in 'instruct_control' handling.
	* src/truetype/ttinterp.c (TT_Run_Context): Fully reset GS.
	(TT_Load_Conext): Rearrange and remove the 'size' check, already
	performed in FT_Load_Glyph.
	(TT_Save_Context): Save only modifiable GS parts.
	(tt_default_graphics_state): Updated.
	* src/truetype/ttinterp.h (TT_Run_Context): Update signature.

2025-06-10  Werner Lemberg  <wl@gnu.org>

	[gxvar] Really fix setting of named-instance to Regular.

	This fixes an ommission in commit cf06661c51.

	* src/truetype/ttgxvar.c (TT_Vary_Apply_Glyph_Deltas): Initialize `error`.

2025-06-10  Werner Lemberg  <wl@gnu.org>

	Two more link fixes.

2025-06-10  Werner Lemberg  <wl@gnu.org>

	Update links.

	Found with `linkchecker --check-extern index.html` running locally in the
	'freetype-web' repository.

2025-06-07  Behdad Esfahbod  <behdad@behdad.org>

	Fix setting of named-instance to Regular

	Fixes https://gitlab.freedesktop.org/freetype/freetype/-/issues/1341

	And more elaborate avoidance of loading face->blend if all coords
	are zero.

2025-06-04  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/type42/t42objs.c (T42_Size_Init): Fix uninitialized use.

	

	Found by Ozkan Sezer.

2025-06-04  Ozkan Sezer  <sezeroz@gmail.com>

	[autofit] Fix `-Wunused-but-set-variable` warning in Windows builds.

	With this commit, the following warning gets removed.

	```
	In file included from src/autofit/autofit.c:21:0:
	src/autofit/ft-hb.c: In function 'ft_hb_funcs_init':
	src/autofit/ft-hb.c:75:35: warning:
	  variable 'version_atleast' set but not used [-Wunused-but-set-variable]
	     ft_hb_version_atleast_func_t  version_atleast = NULL;
	                                   ^~~~~~~~~~~~~~~
	```

	* src/autofit/ft-hb.c (ft_hb_funcs_init): Move `NULL` check of
	  `version_atleast` out of ifdefs.

2025-06-04  Ozkan Sezer  <sezeroz@gmail.com>

	[build] Revise visibility attributes usage in autotools and CMake.

	* CMakeLists.txt: Set `C_VISIBILITY_PRESET` to hidden for non-Windows only.
	  Windows handles exports with `DLL_EXPORT` defined, and old MinGW
	  toolchains emit a lot of warnings about visibility attributes not being
	  supported in this configuration.

	* build/unix/configure.raw: Revise visibility attributes checks by compiling a
	  better test program with `-Werror` in `CFLAGS` so that warnings correctly
	  indicate unsupported configurations.

2025-06-04  Ozkan Sezer  <sezeroz@gmail.com>

	* CMakeLists.txt: Add support for `FT_CONFIG_OPTION_USE_HARFBUZZ_DYNAMIC`.

	This commit introduces a new CMake option `FT_DYNAMIC_HARFBUZZ`.

2025-06-03  Ozkan Sezer  <sezeroz@gmail.com>

	* src/autofit/ft-hb.c: Fix definition of `_GNU_SOURCE`.

	Commit 43ec023e1a730f defined the macro too late.

2025-06-03  Werner Lemberg  <wl@gnu.org>

	Replace 'www.freetype.org' with 'freetype.org'.

2025-06-03  Ozkan Sezer  <sezeroz@gmail.com>

	* builds/unix/configure.raw: Fix HarfBuzz library detection for MinGW.

	Set `have_harfbuzz*` variables explicitly to dynamic for MinGW, since
	Windows uses its own `LoadLibrary` call.

	This fixes a MinGW configuration error:

	```
	checking for HARFBUZZ... no
	checking for dlopen in -lc... no
	checking for dlopen in -ldl... no
	configure: error: harfbuzz support requested but library not found
	```

2025-06-03  Ozkan Sezer  <sezeroz@gmail.com>

	* builds/unix/configure.raw: Improve check for `dlopen`.

	Look for `dlopen` first in 'libc', then in 'libdl'.

2025-06-03  Behdad Esfahbod  <behdad@behdad.org>

	* src/autofit/ft-hb.c: Fix usage of `RTLD_DEFAULT`.

	Using `RTLD_DEFAULT` we see whether the process already has HarfBuzz linked
	in, and reuse it.  If this symbol is not defined it is tempting to use
	`RTLD_GLOBAL` instead, which would make the library available to the whole
	process.  However, without `RTLD_DEFAULT`, we would risk loading a second
	HarfBuzz library, and if the linker mixes them up, probably giving symbols
	from the new library to other clients, we might get into trouble.  For this
	reason, we do not pass `RTLD_GLOBAL` to `dlopen`; the default is
	`RTLD_LOCAL`, and the rest of the process won't see the loaded HarfBuzz and
	hopefully all be happy.

2025-05-28  Werner Lemberg  <wl@gnu.org>

	[sfnt] `FT_Load_Sfnt_Table` can now also load a font's table directory.

	Closes issue #1263.

	* src/sfnt/ttload.c (tt_face_load_any): Implement it.

2025-05-28  Werner Lemberg  <wl@gnu.org>

	[gzip] Update sources to zlib 1.13.1.

	Fixes issue #1294.

2025-05-27  Vítor Ramos  <vitor.ramos@ufrn.br>

	* src/base/ftobjs.c (FT_Load_Glyph): Loosen auto-hinting constraints.

	Fixes issue #1320.

2025-05-27  Werner Lemberg  <wl@gnu.org>

	Update `CHANGES` file.

2025-05-27  Behdad Esfahbod  <behdad@behdad.org>

	[gxvar] Optimize out more bounds checking.

	Big win, ~20% in measured mega-var font, HarfBuzz's `benchmark-font`
	'glyph_h_advances' benchmark.

	* src/truetype/ttgxvar.c (TT_Vary_Apply_Glyph_Deltas): Implement it in
	  loops.

2025-05-27  Behdad Esfahbod  <behdad@behdad.org>

	* src/truetype/ttgload.c (load_truetype_glyph): Use `IS_DEFAULT_INSTANCE`.

2025-05-27  Behdad Esfahbod  <behdad@behdad.org>

	[gxvar] Set `doblend` to `FALSE` if at default location.

	* src/truetype/ttgxvar.c (tt_set_mm_blend, TT_Get_Var_Design): Do it.

2025-05-27  Behdad Esfahbod  <behdad@behdad.org>

	[mm/gxvar] Always detect default instance and use optimized codepath.

	Even if it was explicitly set by either design or normalized APIs.

	Also update documentation.

	* src/truetype/ttgxvar.c (TT_Set_MM_Blend, TT_Set_Var_Design): Use value -2
	  of `error` to indicate that we have a non-default instance.
	  (TT_Set_Named_Instance): Updated.

	* src/base/ftmm.c (FT_Set_Var_Design_Coordinates,
	  FT_Set_Var_Blend_Coordinates): Updated.

2025-05-27  Alexei Podtelezhnikov  <apodtele@gmail.com>

	Typo.

2025-05-27  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/truetype/ttinterp.c (TT_Load_Context): Clean up.

2025-05-26  Werner Lemberg  <wl@gnu.org>

	[autofit] Fix integer overflow.

	Reported as

	  https://issues.oss-fuzz.com/issues/420401635

	* src/autofit/aflatin.c (af_latin_stretch_top_tilde,
	  af_latin_stretch_bottom_tilde): Use `SUB_LONG`.

2025-05-26  Werner Lemberg  <wl@gnu.org>

	[gxvar] Speed up handling of deltas in `ItemVariationStore`. (3/3)

	* src/base/ftcalc.c (FT_MulAddFix): Removed, no longer needed.
	* include/freetype/internal/ftcalc.h: Updated.

2025-05-26  Behdad Esfahbod  <behdad@behdad.org>

	[gxvar] Speed up handling of deltas in `ItemVariationStore`. (2/3)

	Do all math in fixed integer and do a single divide at the end.

	Also don't use an array to read deltas; just read them as we go, and skip
	(branch-free) when scalar is 0.

	30% speedup in measured mega-var font, HarfBuzz's `benchmark-font`
	'glyph_h_advances' benchmark.

2025-05-26  Behdad Esfahbod  <behdad@behdad.org>

	[gxvar] Speed up handling of deltas in `ItemVariationStore`. (1/3)

	* src/truetype/ttgxvar.c (ft_mul_add_delta_scalar, ft_round_and_shift16):
	  New functions, reusing code from `ftcalc.c`.

2025-05-26  Behdad Esfahbod  <behdad@behdad.org>

	Lift `FT_Int64` type to global (internal) FreeType use.

	* src/base/ftcalc.c (FT_Int64) [!FT_INT64]: Move declaration to...
	* include/freetype/config/integer-types.h: ... this file.
	  (FT_UInt64) [!FT_INT64]: New structure.
	  (FT_INT64_ZERO): New macro.

2025-05-26  Behdad Esfahbod  <behdad@behdad.org>

	[gxvar] Move scalar computation into its own function.

	* src/truetype/ttgxvar.c (tt_var_get_item_delta): Split off affected code
	  into...
	  (tt_calculate_scalar): ...this new function.

2025-05-26  Werner Lemberg  <wl@gnu.org>

	[autofit] Make the accent database work for more glyphs (again).

	See the added comment for an explanation.

	This partially undoes commit f68733d4a8.

	* src/autofit/afadjust.c (af_reverse_character_map_new): Always loop over all
	  elements of the adjustment database.
	  (in_range): Removed, no longer needed.

2025-05-26  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[trueetype] Remove useless assignments.

	* src/truetype/ttobjs.c (tt_size_run_fpgm): Remove assignment that
	is ignored and overridden later in 'Compute_Funcs'.
	* src/truetype/ttinterp.c (TT_RunIns): Ditto.
	(Ins_MIAP): Formatting.

2025-05-25  Werner Lemberg  <wl@gnu.org>

	[autofit] Minor code cleanup.

	* src/autofit/afadjust.c (af_reverse_character_map_new): Rename `result_set`
	  to `glyph_alternates` and move its clearing to...
	  (af_get_glyph_alternates): ...this function.
	  (af_get_glyph_alternates_helper): s/result/helper_result/.

2025-05-25  Werner Lemberg  <wl@gnu.org>

	[autofit] Speed up construction of reverse character map. (4/4)

	* src/autofit/afadjust.c (af_get_glyph_alternates): Move creation and
	  deletion of the `helper_result` set to...
	  (af_reverse_character_map_new): ...this function.
	  Gain for `arial.ttf` version 7.00: approx. 1%.

2025-05-25  Werner Lemberg  <wl@gnu.org>

	[autofit] Speed up construction of reverse character map. (3/4)

	* src/autofit/afadjust.c (af_reverse_character_map_new): Fold two loops into
	  one.
	  Gain for `arial.ttf` version 7.00: approx. 1%.

2025-05-25  Werner Lemberg  <wl@gnu.org>

	[autofit] Speed up construction of reverse character map. (2/4)

	This commit, together with the previous one, makes the startup of the
	auto-hinter much faster.

	Note, though, that the startup time for handling the diacritic database is
	still rather large.  For example, loading `arial.ttf` version 7.00 followed
	by auto-hinting a first Latin glyph is still approx. three times slower
	than before the introduction of the database (this is because function
	`hb_ot_layout_lookup_get_glyph_alternates` is called very often).

	* src/autofit/afshaper.c (scripts): Rename this array to...
	  (af_hb_scripts): ...this and export it.
	  (af_shaper_get_coverage_hb): Updated.
	* src/autofit/afshaper.h: Updated.

	* src/autofit/afadjust.c (af_reverse_character_map_new): Pass the current
	  script to `hb_ot_layout_collect_lookups` to make HarfBuzz check less
	  lookups while searching for glyph alternates.

2025-05-25  Werner Lemberg  <wl@gnu.org>

	[autofit] Speed up construction of reverse character map. (1/4)

	Build reverse cmap for characters of the current script style only.

	* src/autofit/afadjust.c (in_range): New function.
	  (af_reverse_character_map_new): Pass `AF_StyleMetrics` instead of
	  `AF_FaceGlobals` so that we can access the current script style.
	  Use `in_range` to limit tested code points.
	* src/autofit/afadjust.h: Updated.
	* src/autofit/aflatin.c (af_latin_metrics_init): Updated.

2025-05-25  Werner Lemberg  <wl@gnu.org>

	[autofit] Avoid variable shadowing.

	* src/autofit/afadjust.c (af_reverse_character_map_new): Do it.

2025-05-25  Werner Lemberg  <wl@gnu.org>

	[autofit] Minor speedup of reverse charmap creation.

	* src/autofit/afglobal.h (AF_HAS_CMAP_ENTRY): New flag.
	  (AF_STYLE_MASK): Update value.
	* src/autofit/afglobal.c (af_face_globals_compute_style_coverage): Set
	  `AF_HAS_CMAP_ENTRY`.

	* src/autofit/afadjust.c (af_reverse_character_map_new): For the creation of
	  the reverse map, change code to handle glyphs with cmap entries before
	  glyphs without cmap entries.  Doing so avoids some code redundancy and
	  reduces the number of hash lookups.

2025-05-25  Werner Lemberg  <wl@gnu.org>

	[autofit] Whitespace.

2025-05-25  Werner Lemberg  <wl@gnu.org>

	[autofit] Use `FT_Offset`.

	* src/autofit/afadjust.c (af_adjustment_database_lookup,
	  af_reverse_character_map_new): Do it.

2025-05-25  Werner Lemberg  <wl@gnu.org>

	[autofit] Simplify return value of `af_adjustment_database_lookup`.

	* src/autofit/adfadjust.h (af_adjustment_database_lookup): Return integer.
	  (AF_AdjustmentDatabaseEntry): Move structure to...
	* src/autofit/afadjust.c: ...this file.
	  (af_adjustment_database_lookup, af_reverse_character_map_new): Updated.
	* src/autofit/aflatin.c
	  (af_glyph_hints_apply_vertical_separation_adjustments): Updated.

2025-05-25  Werner Lemberg  <wl@gnu.org>

	[autofit] Remove no longer used functions and structures.

	This is the clean-up from the previous commit.

	* src/autofit/afadjust.c (af_reverse_character_map_entry_compare,
	  af_reverse_character_map_lookup, af_reverse_character_map_expand):
	  Removed.
	* src/autofit/afadjust.h: Updated.
	* src/autofit/aftypes.h (AF_ReverseMapEntry, AF_ReverseCharacterMap):
	  Removed.

2025-05-25  Werner Lemberg  <wl@gnu.org>

	[autofit] Use a hash for handling vertical accent adjustments.

	This greatly simplifies the code.

	* src/autofit/afadjust.c (af_reverse_character_map_new): Implement it.
	  (af_reverse_character_map_done): Updated.
	* src/autofit/afadjust.h: Updated.

	* src/autofit/aflatin.c
	  (af_glyph_hints_apply_vertical_separation_adjustments): Updated.

	* src/autofit/aftypes.h: Include `fthash.h`.
	  (AF_StyleMetrics): Change type of `reverse_charmap` to `FT_Hash`.

2025-05-25  Werner Lemberg  <wl@gnu.org>

	* src/autofit/aflatin.c (af_latin_hints_apply): Improve code legibility.

2025-05-25  Werner Lemberg  <wl@gnu.org>

	[autofit] Use `FT_LONG_MIN` and `FT_LONG_MAX` for `FT_Pos` variables.

	* src/autofit/aflatin.c (af_latin_metrics_init_blues,
	  af_compute_vertical_extrema, af_find_highest_contour,
	  af_find_second_highest_contour, af_find_lowest_contour,
	  af_find_second_lowest_contour, af_check_contour_horizontal_overlap):
	  Updated.

2025-05-25  Werner Lemberg  <wl@gnu.org>

	[autofit] Fix uninitialized variables.

	* src/autofit/aflatin.c (af_latin_stretch_top_tilde,
	  af_latin_stretch_bottom_tilde): Initialize `min_measurement`.

2025-05-23  Behdad Esfahbod  <behdad@behdad.org>

	[ttmtx] Fix check for being non-default variation position.

	If user explicitly sets variations to `NULL` after it being set to something
	else, `face->blend` will still be non-`NULL`.  The intention here however is
	correctly captured by `FT_IS_VARIATION`.

	* src/sfnt/ttmtx.c (tt_face_get_metrics): Use `FT_IS_VARIATION`.

2025-05-23  Behdad Esfahbod  <behdad@behdad.org>

	[gxvar] Optimize loading of 'gvar' table.

	* src/truetype/ttgxvar.c (tt_var_load_item_variation_store,
	  tt_var_load_delta_set_index_mapping, ft_var_load_gvar): Use frames to
	  reduce bounds checking.
	  (TT_Vary_Apply_Glyph_Deltas): Better macro usage.

2025-05-22  Behdad Esfahbod  <behdad@behdad.org>

	[mm] Short-circuit setting face to default instance if already is so.

	I found that in hb-ft I need to sometime reset the face to the default
	instance.  However, calling `FT_Set_Var_Design_Coordinates` with no coords
	was still slowing down at least the glyph-advance code by processing
	variations.

	Perhaps there's a better fix, but this handles the easy cases.

	* src/base/ftmm.c (FT_Set_Var_Design_Coordinates): Implement it.

2025-05-22  Behdad Esfahbod  <behdad@behdad.org>

	* src/truetype/ttgxvar.c (TT_Vary_Apply_Glyph_Deltas): Fix allocation.

	Bug was introduced in commit 582de1a4b6f.

2025-05-21  Werner Lemberg  <wl@gnu.org>

	* src/truetype/ttgxvar.c (ft_var_apply_tuple): Remove redundant test.

	This was erroneously added in commit e6e9110a8.

2025-05-21  ColdPaleLight  <coldpalelight@gmail.com>

	[sdf] Skip neighbor comparison for pixels near edges.

	If the distance of the current pixel to the edge is less than or equal
	to 0.5, skip further neighbor comparisons to avoid unnecessary
	calculations. When the `USE_SQUARED_DISTANCES` macro is defined,
	compare to 0.25 instead.

	* src/sdf/ftbsdf.c (compare_neighbor): Add early return for pixels
	  close to edges to avoid unnecessary neighbor checks.

2025-05-21  Behdad Esfahbod (بهداد اسفهبد)  <behdad@behdad.org>

	[gxvar] Cache shared-tuple scalar values.

	GoogleSansFlex HB benchmark-font draw results:

	  Before:  2.13ms
	  After:   1.65ms
	  Speedup: 22%

	* src/truetype/ttgxvar.h (GX_BlendRec): Add `tuplescalars` field.

	* src/truetype/ttgxvar.c (ft_var_load_gvar): Allocate `tuplescalars` array.
	  (tt_set_mm_blend): Set its values.
	  (TT_Vary_Apply_Glyph_Deltas): Use it.
	  (tt_done_blend): Deallocate it.

2025-05-21  Behdad Esfahbod (بهداد اسفهبد)  <behdad@behdad.org>

	[gxvar] Reduce number of mallocs.

	8% speed up in drawing GoogleSansFlex variable in HB benchmark-font.

	* src/truetype/ttgxvar.c (TT_Vary_Apply_Glyph_Deltas): Use an allocation
	  pool instead of individual allocations.

2025-05-21  Behdad Esfahbod (بهداد اسفهبد)  <behdad@behdad.org>

	[gxvar] Another optimization in computing scalar.

	Another ~6% speedup in GoogleSansFlex var drawing.

	* src/truetype/ttgxvar.c (ft_var_apply_tuple): Test `ncv` for being zero.

2025-05-21  Behdad Esfahbod (بهداد اسفهبد)  <behdad@behdad.org>

	[gxvar] Remove stale comment.

	The code *does* check against start/end!

2025-05-21  Behdad Esfahbod (بهداد اسفهبد)  <behdad@behdad.org>

	* src/truetype/ttgxvar.c (ft_var_apply_tuple): Micro-optimize.

2025-05-21  Behdad Esfahbod (بهداد اسفهبد)  <behdad@behdad.org>

	[gxvar] Inline two USHORT reads.

	Speeds up GoogleSansFlex variable glyph drawing by ~13%.

	  Before: 2.95ms
	  After:  2.57ms

	* src/truetype/ttgxvar.c (TT_Vary_Apply_Glyph_Deltas): Do it.

2025-05-21  Behdad Esfahbod (بهداد اسفهبد)  <behdad@behdad.org>

	[gxvar] Micro-optimize loop end condition.

	* src/truetype/ttgxvar.c (TT_Vary_Apply_Glyph_Deltas): Do it.

2025-05-21  Behdad Esfahbod  <behdad@behdad.org>

	[truetype] Don't process `mvar` metrics if default instance.

	GoogleSansFlex default-instance HarfBuzz benchmark-font draw:

	  Before:  0.610ms
	  After:   0.435ms
	  Speedup: 28%

	* src/truetype/ttobjs.c (tt_face_init) [TT_CONFIG_OPTION_GX_VAR_SUPPORT]:
	  Check `instance_index`.

2025-05-21  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/truetype/ttinterp.c (Ins_MIRP,DELTAP,DELTAC): Minor.

2025-05-20  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[truetype] Update bytecode error handling.

	* src/truetype/ttinterp.c (Ins_SHP,SHPIX,ALIGNRP): Return appropriate
	error in case of stack underflow.
	(Ins_IP): Ditto and remove redundant check.

2025-05-19  Werner Lemberg  <wl@gnu.org>

	* src/aflatin.c (af_latin_hint_edges): Refine fix for serif handling.

	Commit 11432424 (from 2025-May-12) was too aggressive; it is now restricted
	to edges that are not too far away.

2025-05-19  Werner Lemberg  <wl@gnu.org>

	* src/afadjust.c (adjustment_database): Make it complete up to U+FFFF.

	Also fix two entries.

	This is for Unicode 17.0.

2025-05-19  Werner Lemberg  <wl@gnu.org>

	[autofit] Fix vertical adjustment of (mainly) double diacritics.

	The series of commits that introduced this adjustment support had some
	flaws.

	- If there were two diacritics on top of a base glyph, and the upper
	  diacritic was a tilde, the vertical centering correction was incorrectly
	  applied to the lower, non-tilde glyph instead of the tilde.

	- The maximum value allowed to shift a glyph was too strict (and also not
	  handling rounding issues), causing some diacritics and combinations of
	  diacritics to be not shifted at all.

	* src/autofit/aflatin.c
	  (af_glyph_hints_apply_vertical_separation_adjustments): Correctly handle
	  vertical centering correction.

2025-05-19  Werner Lemberg  <wl@gnu.org>

	[autofit] Code hygiene.

	* src/autofit/aflatin.c
	  (af_glyph_hints_apply_vertical_separation_adjustments): Use more flag
	  variables and improve trace messages.

2025-05-19  Werner Lemberg  <wl@gnu.org>

	* src/autofit/aflatin.c (af_latin_hint_edges): Fix handling of serifs.

	This has been discovered while inspecting the auto-hinting results of
	character 'Ễ' in font `arial.ttf` (version 7.00) at 13ppem.

2025-05-19  Werner Lemberg  <wl@gnu.org>

	[autofit] Minor.

	* src/autofit/aflatin.c (af_latin_hint_edges): Rename `has_serifs` to
	  `has_non_stem_edges` and make it of type `FT_Bool`.

2025-05-19  Werner Lemberg  <wl@gnu.org>

	[autofit] New algorithm for preventing hinting of tilde glyphs.

	The old algorithm removed segments from edges to make the auto-hinter ignore
	a tilde.  However, the implementation had two flaws.

	- Edge array elements were moved around without reordering them afterwards.
	- The linking between edges and segments wasn't correctly updated for moved
	  edges, which could cause endless loops.

	Correcting both problems are non-trivial; additionally, a fix would make
	the auto-hinter slower.

	For these reasons, a new, simpler approach is taken: A new flag allows
	points to be tagged as being ignored, and if such a point is enountered, it
	doesn't get added to a segment.

	Fixes issue #1333.

	* src/autofit/afhints.h (AF_FLAG_IGNORE): New macro.

	* src/autofit/aflatin.c (af_latin_hints_compute_segments, af_touch_contour):
	  Use it.
	  (af_remove_segments_containing_point, af_remove_top_points_from_edges,
	  af_remove_bottom_points_from_edges): Removed.
	  (af_latin_stretch_top_tilde): Call `af_touch_top_contours` and
	  `af_touch_bottom_contours` unconditionally.
	  (af_latin_hints_apply): Updated.

2025-05-16  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/truetype/ttinterp.c (TT_DotFix14): Silence UBSAN.

2025-05-16  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/truetype/ttinterp.c (Ins_DELTAP): Flip if-else.

2025-05-15  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[truetype] Optimize DELTAP and DELTAC.

	* src/truetype/ttinterp.c (Ins_DELTAP,DELTAC): Perform PPEM range-
	checking and manipulations outside the loop.

2025-05-14  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/truetype/ttinterp.c (Compute_Funcs): Replace shifts.

2025-05-14  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[truetype] Tighten code overflow checks.

	

	Fixes #1336.

	

	* src/truetype/ttinterp.c (Ins_NPUSHB,NPUSHW,PUSHB, PUSHW):

	Tighten conditions.

2025-05-14  Chris Liddell  <chris.liddell@artifex.com>

	[type1] Fix memory leak on CharString error.

	In the event that a CharString retrieved via the incremental interface
	caused an error, the memory for that CharString was not being freed.

	* src/type1/t1gload.c (T1_Parse_Glyph_And_Get_Char_String): Free charstring.

2025-05-14  Werner Lemberg  <wl@gnu.org>

	Whitespace, formatting, minor spelling fix.

2025-05-14  Werner Lemberg  <wl@gnu.org>

	Adminstrativa.

2025-05-13  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[truetype] Finalize bytecode changes.

	* src/truetype/ttinterp.c: Formatting, minor.
	(TT_Goto_CodeRange): Initialize 'iniRange' here...
	(TT_RunIns): ... instead of here.
	* docs/CHANGES: Updated.

2025-05-13  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[truetype] Streamline backward compatibility.

	The 'backward_compatibility' is only set in v40: no need to check
	the interpreter version again and again. In addition, we now track
	IUP in its lower bits.  After both IUPx and IUPy have been called,
	'backward_compatibility' becomes equal to 0x7.

	* src/truetype/ttinterp.h (TT_ExecContextRec): Wrap 'iup?_called'
	into 'backward_compatibility'.
	* src/truetype/ttinterp.c (Ins_INSTCTRL): Sync 'backward_compatibility'.
	(Direct_Move, Direct_Move_X/Y, Move_Zp2_Point,
	Ins_FLIPPT,FLIPRGON,FLIPRGOFF,SHPIX,DELTAP): Updated.
	(TT_RunIns): Do not mess with IUP flags.
	* src/truetype/ttgload.c (tt_loader_init): Set 'backward_compatibility'.
	(TT_Hint_Glyph): Updated.

2025-05-10  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[truetype] Optimize bytecode movements.

	Replacing FT_MulDiv with FT_MulFix gives large performance gains.

	* src/truetype/ttinterp.h (TT_ExecContextRec): Store "projected"
	freedom vector.
	* src/truetype/ttinterp.c (Compute_Funcs): Compute "projected"
	freedom vector.
	(Direct_Move, Direct_Move_Orig, Compute_Point_displacement): Use it.

2025-05-10  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[truetype] Simplify stack access.

	* src/truetype/ttinterp.c (Ins_MINDEX,CINDEX): Use local stack pointers.
	(Ins_DELTAP,DELTAC): Ditto; limit the number of pairs before looping.

2025-05-10  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[truetype] Tweak bytecode looping.

	* src/truetype/ttinterp.c (Ins_FLIPPT,SHP,SHPIX,IP,ALIGNRP): Handle
	counters and stack locally.
	(TT_RunIns): Updated.

2025-05-10  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[truetype] Tweak bytecode initiation.

	* src/truetype/ttinterp.c (TT_Load_Context): Init stack tops.
	* src/truetype/ttinterp.h (TT_ExecContextRec): Document it and clean.
	* src/truetype/ttobjs.c (tt_size_run_prep,fpgm): Updated.
	* src/truetype/ttgload.c (tt_loader_init): Minor.

2025-05-10  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[truetype] Modify stack handling.

	* src/truetype/ttinterp.c (Ins_GETVARIATION): Increment stack.
	(Ins_NPUSHB,NPUSHW,PUSHB,PUSHW): Handle the code stack here, ...
	(TT_RunIns): ... instead of here. Consolidate error handling.
	(SkipCode): Remove preemptive check.

2025-05-10  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[truetype] Modify bytecode steps.

	* src/truetype/ttinterp.h (TT_Exec_ContextRec): Remove 'step_ins'.
	* src/truetype/ttinterp.c (TT_RunIns, Ins_Goto_CodeRange,
	Ins_JMPR,ENDF,PUSHW,NPUSHW): Set and use zero increment 'length' instead.
	(Ins_CALL,LOOPCALL,UNKNOWN): Updated.

2025-05-10  Werner Lemberg  <wl@gnu.org>

	[autofit] Add safety check for accent adjustments.

	This commit does two things.

	- Ignore accents that have too large heights.  This situation can happen if
	  an accent outline is unexpectedly not the highest (or lowest) contour.
	- Add a new adjustment flag `AF_ADJUST_NO_HEIGHT_CHECK` to override the
	  height check.

	* src/autofit/afadjust.h (AF_ADJUST_NO_HEIGHT_CHECK): New macro.

	* src/autofit/afadjust.c (adjustment_database): Updated.

	* src/autofit/aflatin.c (af_latin_hints_apply): Handle new flag.
	  (af_glyph_hints_apply_vertical_separation_adjustments): Check limit.

2025-05-10  Werner Lemberg  <wl@gnu.org>

	[autofit] Better handling of characters with attached diacritics. (3/3)

	Fixes issue #136.

	* src/autofit/afadjust.c (adjustment_database): Updated.

2025-05-10  Werner Lemberg  <wl@gnu.org>

	[autofit] Better handling of characters with attached diacritics. (2/3)

	* src/autofit/afadjust.h (AF_IGNORE_CAPITAL_TOP, AF_IGNORE_CAPITAL_BOTTOM,
	  AF_IGNORE_SMALL_TOP, AF_IGNORE_SMALL_BOTTOM): New macros.

	* src/autofit/afadjust.c (af_reverse_character_map_new)
	  [FT_DEBUG_LEVEL_TRACE]: Updated.
	  Also fix debugging strings of other flags.

	* src/autofit/afhints.h (AF_EDGE_NO_BLUE): New edge flag to make the
	  auto-hinter ignore the edge while assigning blue zones.

	* src/autofit/aflatin.c (af_latin_hints_compute_blue_edges): Use it.
	  (af_prevent_top_blue_alignment, af_prevent_bottom_blue_alignment,
	  af_latin_get_base_glyph_blues, af_latin_ignore_top,
	  af_latin_ignore_bottom): New functions.
	  (af_latin_hints_apply): Updated.

2025-05-10  Werner Lemberg  <wl@gnu.org>

	[autofit] Better handling of characters with attached diacritics. (1/3)

	Introduce blue zone properties that will be used to make the auto-hinter
	ignore diacritics attached on the top or the bottom of a base character.

	* src/autofit/afblue.hin (AF_BLUE_PROPERTY_LATIN_CAPITAL_BOTTOM,
	  AF_BLUE_PROPERTY_LATIN_SMALL_BOTTOM): New properties.
	* src/autofit/afblue.dat: Use them.

	* src/autofit/afblue.c, src/autofit/afblue.h: Rengenerated.

	* src/autofit/aflatin.h (AF_LATIN_IS_CAPITAL_BOTTOM_BLUE,
	  AF_LATIN_IS_SMALL_BOTTOM_BLUE, AF_LATIN_BLUE_BOTTOM,
	  AF_LATIN_BLUE_BOTTOM_SMALL): New macros.

	* src/autofit/aflatin.c (af_latin_metrics_init_blues)[FT_DEBUG_LEVEL_TRACE]:
	  Updated.

2025-05-09  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/raster/ftraster.c (Line_Up): Use 64-bit calculations.

	Attempt to fix #1332.

2025-05-09  Werner Lemberg  <wl@gnu.org>

	[sfnt] Avoid allocation bomb in compressed SVG documents.

	Reported as

	  https://issues.oss-fuzz.com/issues/416538625

	* src/sfnt/ttsvg.c (MAX_SVG_SIZE): New macro.
	  (tt_face_load_svg_doc): Reject too large buffer.

2025-05-08  Werner Lemberg  <wl@gnu.org>

	* include/freetype/ttnameid.h (TT_UCR_*): Define with unsigned long.
	  (TT_UCR_PHAGSPA): Fix definition.

	Fixes issue #1300.

2025-05-08  Werner Lemberg  <wl@gnu.org>

	[doc] Mention that there is no rendering support for 'COLR' v1 tables.

	Handles issue #1319.

2025-05-08  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/truetype/ttinterp.c (TT_DotFix14): Silence UBSAN.

2025-05-07  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/cff/cffgload.c (cff_slot_load): Fix autohinter scaling.

	Fixes #1330.

2025-05-05  Werner Lemberg  <wl@gnu.org>

	[autofit] Avoid division by zero.

	Fixes issue #1331.

	* src/autofit/aflatin.c (af_latin_stretch_bottom_tilde): Don't divide by
	  zero.

2025-05-04  Carlo Bramini  <carlo.bramix@libero.it>

	Fix Cygwin visibility attributes.

	Reported as compilation warnings in #1329.

	* include/freetype/config/public-macros.h: Check __CYGWIN__.
	* include/freetype/internal/compiler-macros.h: Ditto.

2025-05-03  KatekovAnton  <void0main@gmail.com>

	* CMakeLists.txt: Fix cmake 4 error by specifying the policy version.

2025-04-29  Werner Lemberg  <wl@gnu.org>

	* docs/CHANGES: Updated.

2025-04-29  Behdad Esfahbod (بهداد اسفهبد)  <behdad@behdad.org>

	Provide configuration option to dynamically load the HarfBuzz library.

	We now request HarfBuzz version 2.6.8 (published in June 2020) or newer to
	simplify the setup; this version introduced function
	`hb_ot_layout_lookup_get_glyph_alternates`, which we need for the adjustment
	database of the auto-hinter.

	No CMake support yet for dynamic loading.

	* include/freetype/config/ftoption.h, devel/ftoption.h
	  (FT_CONFIG_OPTION_USE_HARFBUZZ_DYNAMIC): New configuration macro.

	* builds/unix/configure.raw: Implement `--with-harfbuzz=dynamic`.
	  This gets tested automatically if we can't link with `libharfbuzz`.
	  (ft_option_set, ft_option_unset): Refine.
	  Require at least HarfBuzz version 2.6.8.

	* meson.build: Do the same as `configure.raw`.
	* meson_options.txt: Updated.

	* CMakeLists.txt: Require at least HarfBuzz version 2.6.8.

2025-04-29  Behdad Esfahbod (بهداد اسفهبد)  <behdad@behdad.org>

	[autofit] Enable dynamic loading of HarfBuzz. (2/2)

	Handle the case where loading HarfBuzz dynamically fails.

	* src/autofit/ft-hb.c, src/autofit/ft-hb.h (ft_hb_enabled): New function.

	* src/autofit/afglobal.c (af_face_globals_new, af_face_globals_free):
	  Guard HarfBuzz functions with `ft_hb_enabled`.

	* src/autofit/aflatin.c (af_latin_metrics_init_widths,
	  af_latin_metrics_init_blues, af_latin_metrics_check_digits): Simplify
	  setup of `shaper_buf`.
	  Guard calls of `af_shaper_buf_create` with `ft_hb_enabled`.

	* src/autofit/afcjk.c (af_cjk_metrics_init_widths,
	  af_cjk_metrics_init_blues, af_cjk_metrics_check_digits): Dito.

	* src/autofit/afshaper.c: Guard all HarfBuzz function calls with
	  `ft_hb_enabled`.

2025-04-29  Behdad Esfahbod (بهداد اسفهبد)  <behdad@behdad.org>

	[autofit] Enable dynamic loading of HarfBuzz. (1/2)

	This commit activates the mini-HarfBuzz header files and provides the
	necessary infrastructure for dynamically loading HarfBuzz if
	`FT_CONFIG_OPTION_USE_HARFBUZZ_DYNAMIC` is defined (this macro gets set up
	in a follow-up commit).

	* src/autofit/ft-hb.c: New file, providing `ft_hb_funcs_init` and
	  `ft_hb_funcs_done` for loading HarfBuzz dynamically.  The name of the
	  library is hold in the macro `FT_LIBHARFBUZZ`, which can be overridden.

	* src/autofit/ft-hb.h: Don't include `hb.h` but `ft-hb-types.h`.
	  (hb): Modified to handle both standard linking and dynamically
	  loading of HarfBuzz.
	  (HB_EXTERN): New macro to load `ft-hb-decls.h`.

	* src/autofit/afadjust.c [FT_CONFIG_OPTION_USE_HARFBUZZ]: For the sake of
	  dynamically loading the HarfBuzz library, replace the compile-time macro
	  `HB_VERSION_ATLEAST` with a call to the run-time function
	  `hb_version_atleast` where necessary – a follow-up commit will set the
	  minimum version of HarfBuzz to 2.6.8, which provides all necessary
	  functions needed by FreeType.

	* src/autofit/afmodule.h: Include `ft-hb.h`.
	  (AF_ModuleRec) [FT_CONFIG_OPTION_USE_HARFBUZZ_DYNAMIC]: Add `hb_funcs`
	  structure to hold pointers to the dynamically loaded HarfBuzz functions.

	* src/autofit/afmodule.c (af_autofitter_init, af_autofitter_done)
	  [FT_CONFIG_OPTION_USE_HARFBUZZ_DYNAMIC]: Call `ft_hb_funcs_init` and
	  `ft_hb_funcs_done`.

	* src/autofit/afshaper.h: Updated.
	* src/autofit/autofit.c: Include `ft-hb.c`.

	* src/autofit/rules.mk (AUTOF_DRV_SRC, AUTOF_DRV_H): Updated.

2025-04-29  Behdad Esfahbod (بهداد اسفهبد)  <behdad@behdad.org>

	[autofit] Some preparations for loading HarfBuzz dynamically. (4/4)

	Add 'mini' HarfBuzz declarations to make FreeType independent on HarfBuzz
	header files.

	The files get activated in a follow-up commit.

	* src/autofit/ft-hb-decls.h, src/autofit/ft-hb-types.h: New files, holding
	  verbatim (or slightly massaged) entries from public HarfBuzz header files.

	* src/autofit/hb-script: New file.
	  A verbatim copy of a public HarfBuzz header file.

2025-04-29  Behdad Esfahbod (بهداد اسفهبد)  <behdad@behdad.org>

	[autofit] Some preparations for loading HarfBuzz dynamically. (3/4)

	* src/autofit/afshaper.c: Move around code so that the non-HarfBuzz code is
	  present even if `FT_CONFIG_OPTION_USE_HARFBUZZ` is not defined.  This is a
	  preliminary step to allow deactivation of HarfBuzz at run-time.

2025-04-29  Behdad Esfahbod (بهداد اسفهبد)  <behdad@behdad.org>

	[autofit] Some preparations for loading HarfBuzz dynamically. (2/4)

	Pass `AF_FaceGlobals` to many functions, or provide it, tagged with
	`FT_UNUSED`.  We need this later on to access a dynamically linked HarfBuzz
	library.

	* src/autofit/ft-hb-ft.h (ft_hb_ft_font_create): Use `globals` argument.
	  Drop unused `destroy` argument.
	* src/autofit/ft-hb-ft.c (ft_hb_ft_face_create, ft_hb_ft_font_create): Use
	  `globals` argument.
	  Drop unused `destroy` argument.
	  (ft_hb_ft_face_create, ft_hb_ft_reference_table): Cast `user_data` to
	  `AF_FaceGlobals`.

	* src/autofit/afadjust.c (af_get_glyph_alternates_helper,
	  af_get_glyph_alternates): Add `globals` argument.
	  Update callers.

	* src/autofit/afshaper.c, src/autofit/afshaper.h (af_shaper_buf_create,
	  af_shaper_buf_destroy): Use `globals` argument.

	* src/autofit/afglobal.c (af_face_globals_new): Updated.

	* src/autofit/afcjk.c (af_cjk_metrics_init_widths,
	  af_cjk_metrics_init_blues, af_cjk_metrics_check_digits): Updated.
	* src/autofit/aflatin.c (af_latin_metrics_init_widths,
	  af_latin_metrics_init_blues, af_latin_metrics_check_digits): Updated.

2025-04-29  Behdad Esfahbod (بهداد اسفهبد)  <behdad@behdad.org>

	[autofit] Some preparations for loading HarfBuzz dynamically. (1/4)

	* src/autofit/ft-hb.h: New file, defining the `hb` macro.  Later on, we
	  provide a different definition of this macro depending on a yet-to-come
	  configuration option to support dynamic loading of HarfBuzz functions.

	* src/autofit/afadjust.c, src/autofit/afglobal.c, src/autofit/afshaper.c,
	  stc/ft-hb-ft.c: Use it.

2025-04-29  Behdad Esfahbod (بهداد اسفهبد)  <behdad@behdad.org>

	[autofit] Rename 'ft-hb' to 'ft-hb-ft'.

	Since it's a (shrinked) copy of 'hb-ft'.

	* src/autofit/afglobal.c (af_face_globals_new), src/autofit/afshaper.h,
	  src/autofit/autofit.c: Updated.

	* src/autofit/ft-hb.c, src/autofit/ft-hb.h: Renamed to...
	* src/autofit/ft-hb-ft.c, src/autofit/ft-hb-ft.h: ...this; updated.

	* src/autofit/rules.mk (AUTOF_DRV_SRC): Updated.

2025-04-29  Werner Lemberg  <wl@gnu.org>

	* src/autofit/aflatin.c (af_latin_stretch_top_tilde): Don't divide by zero.

	Reported as

	  https://issues.oss-fuzz.com/issues/414320186

2025-04-28  Werner Lemberg  <wl@gnu.org>

	[autofit] Extend adjustment database with characters up to U+1FFF.

	This adds many pre-combined Latin glyphs, Cyrillic, Greek, and some
	characters from other scripts (or rather, Unicode blocks).

	Fixes issues #112 and #471.

2025-04-28  Werner Lemberg  <wl@gnu.org>

	[autofit] Support diacritics with special vertical minima.

	This code catches situations like U+1F90 ('ᾐ'), where some fonts have
	exactly the same vertical minimum for the lower accent as for the base
	glyph.

	* src/autofit/aflatin.c (af_find_highest_contour, af_find_lowest_contour):
	  Handle it.

2025-04-28  Werner Lemberg  <wl@gnu.org>

	[autofit] More tilde stretch support. (3/3)

	The auto-hinter now supports up to four tilde glyphs (two above and two
	below a base character).

	Note that diacritics above (or below) a tilde are now also ignored by the
	auto-hinter.

	* src/autofit/afadjust.h (AF_ADJUST_TILDE_TOP2, AF_ADJUST_TILDE_BOTTOM2):
	  New macros.
	* src/autofit/afadjust.c (af_reverse_character_map_new): Updated.

	* src/autofit/aflatin.c (af_remove_top_points_from_edges,
	  af_remove_bottom_points_from_edges): Make functions also handle all
	  contours higher (or lower) of the given one in the argument.
	  (af_touch_top_contours, af_touch_bottom_contours): New functions.
	  (af_latin_stretch_top_tilde, af_latin_stretch_bottom_tilde): Use it to
	  also handle all contours higher (or lower) than the tilde contour.

	* (af_latin_hints_apply): Handle more tilde glyphs.

2025-04-28  Werner Lemberg  <wl@gnu.org>

	[autofit] More tilde stretch support. (2/3)

	* src/autofit/aflatin.c (af_latin_stretch_top_tilde,
	  af_latin_stretch_bottom_tilde): Return vertical size difference between
	  stretched and original contour.
	  (af_latin_align_top_tilde, af_latin_align_bottom_tilde): Return applied
	  delta.
	  (af_latin_hints_apply): Updated; the return values are not used yet.

2025-04-28  Werner Lemberg  <wl@gnu.org>

	[autofit] More tilde stretch support. (1/3)

	Move some existing code that we soon need elsewhere into separate functions.

	* src/autofit/aflatin.c (af_move_contours_up, af_move_contours, down): New
	  functions.
	  (af_glyph_hints_apply_vertical_separation_adjustments): Use them.
	  (af_touch_contour): New function.
	  (af_latin_stretch_top_tilde, af_latin_stretch_bottom_tilde): Use it.

	  (af_latin_remove_top_tilde_points_from_edges,
	  af_latin_remove_bottom_tilde_points_from_edges): Renamed to...
	  (af_remove_top_points_from_edges, af_remove_bottom_points_from_edges):
	  ...this.
	  Update callers.

2025-04-28  Werner Lemberg  <wl@gnu.org>

	[autofit] Support two below/above accents for vertical adjustment. (2/2)

	* src/autofit/afadjust.h (AF_ADJUST_UP2, AF_ADJUST_DOWN2): New macros.
	* src/autofit/afadjust.c (af_reverse_character_map_new): Updated.

	* src/autofit/aflatin.c
	  (af_glyph_hints_apply_vertical_separation_adjustments): Implement it.

2025-04-28  Werner Lemberg  <wl@gnu.org>

	[autofit] Support two below/above accents for vertical adjustment. (1/2)

	Some variable renamings.

2025-04-28  Werner Lemberg  <wl@gnu.org>

	[autofit] Routines for finding the second highest/lowest contour.

	* src/autofit/aflatin.c (af_find_second_highest_contour,
	  af_find_second_lowest_contour): New functions.

2025-04-28  Werner Lemberg  <wl@gnu.org>

	[autofit] Use more functions to reduce code.

	* src/autofit/aflatin.c (af_find_highest_contour, af_find_lowest_contour):
	  Updated.
	  (af_glyph_hints_apply_vertical_separation_adjustments): Use
	  `af_compute_vertical_extrema`, `af_find_highest_contour`, and
	  `af_find_lowest_contour`.
	  (af_latin_hints_apply): Use `af_compute_vertical_extrema`,

2025-04-28  Werner Lemberg  <wl@gnu.org>

	* src/autofit/aflatin.c (af_compute_vertical_extrema): New function.

	To be used in a follow-up commit.

2025-04-28  Werner Lemberg  <wl@gnu.org>

	* src/autofit/aflatin.c: Some variable renaming.

2025-04-28  Werner Lemberg  <wl@gnu.org>

	[autofit] Avoid recomputation of highest and lowest contour.

	* src/autofit/aflatin.c (af_latin_hints_apply): Compute highest and lowest
	  contour in this function.
	  (af_latin_remove_top_tilde_points_from_edges,
	  af_latin_remove_bottom_tilde_points_from_edges,
	  af_latin_stretch_top_tilde, af_latin_stretch_bottom_tilde,
	  af_latin_align_top_tilde, af_latin_align_bottom_tilde): Updated.

2025-04-28  Werner Lemberg  <wl@gnu.org>

	* src/aflatin.c (af_latin_trace_height): Remove.
	  Update caller.

	The algorithm works fine.

2025-04-28  Werner Lemberg  <wl@gnu.org>

	[autofit] Support vertical stretching of tilde below base glyph. (2/2)

	* src/autofit/afadjust.h (AF_ADJUST_TILDE_BOTTOM): New macro.
	* src/autofit/afadjust.c (af_reverse_character_map_new): Updated.

	* src/autofit/aflatin.c (af_find_lowest_contour,
	  af_latin_remove_bottom_tilde_points_from_edges,
	  af_latin_stretch_bottom_tilde, af_latin_align_bottom_tilde): New functions
	  in analogy to the top tilde versions.
	  (af_glyph_hints_apply_vertical_separation_adjustments): Add support in
	  analogy to the top tilde code.
	  (af_latin_hints_apply): Updated.

2025-04-28  Werner Lemberg  <wl@gnu.org>

	[autofit] Support vertical stretching of tilde below base glyph. (1/2)

	* src/autofit/aflatin.c (af_latin_remove_tilde_points_from_edges,
	  af_latin_stretch_tilde, af_latin_align_tilde): Rename to...
	  (af_latin_remove_top_tilde_points_from_edges, af_latin_stretch_top_tilde,
	  af_latin_align_top_tilde): ...this.
	  Update all callers.
	  (af_latin_hints_apply): Rename `is_tilde` to `is_top_tilde`.

2025-04-28  Werner Lemberg  <wl@gnu.org>

	[autofit] Allow vertical adjustment at the top and bottom simultaneously.

	This will be used to hint characters like U+1FB7 ('ᾷ').

	* src/autofit/aflatin.c
	  (af_glyph_hints_apply_vertical_separation_adjustments): Implement it.

2025-04-28  Werner Lemberg  <wl@gnu.org>

	* src/autofit/afadjust.c (af_reverse_character_map_new): Update tracing.

2025-04-28  Werner Lemberg  <wl@gnu.org>

	[autofit] Indicate tilde handling with a flag macro, too.

	* src/autofit/afadjust.h (AF_ADJUST_TILDE_TOP): New macro.
	  (AF_AdjustmentDatabaseEntry): Remove field `apply_tilde`.

	* src/autofit/afadjust.c (adjustment_database,
	  af_reverse_character_map_new), src/autofit/aflatin.c
	  (af_glyph_hints_apply_vertical_separation_adjustments,
	  af_latin_hints_apply): Updated.

2025-04-28  Werner Lemberg  <wl@gnu.org>

	[aflatin] Convert adjustment database enum to macros.

	We are going to add more values, and we want to use combinations of them.

	* src/autofit/afadjust.h (AF_VerticalSeparationAdjustmentType): Replace
	  with...
	  (AF_ADJUST_UP, AF_ADJUST_DOWN, AF_ADJUST_NONE): ... new macros.
	  (AF_AdjustmentDatabaseEntry): Rename field
	  `vertical_separation_adjustment_type` to `flags`.

	* src/autofit/afadjust.c (af_reverse_character_map_new),
	  src/autofit/aflatin.c
	  (af_glyph_hints_apply_vertical_separation_adjustments): Updated.

2025-04-28  Werner Lemberg  <wl@gnu.org>

	[autofit] Shorten adjustment enum names.

	* src/autofit/afadjust.h (AF_VERTICAL_ADJUSTMENT_TOP_CONTOUR_UP,
	  AF_VERTICAL_ADJUSTMENT_BOTTOM_CONTOUR_DOWN, AF_VERTICAL_ADJUSTMENT_NONE):
	  Renamed to...
	  (AF_ADJUST_UP, AF_ADJUST_DOWN, AF_ADJUST_NONE): ...this.

	* src/autofit/afadjust.c (adjustment_database,
	  af_reverse_character_map_expand), src/autofit/aflatin.c
	  (af_glyph_hints_apply_vertical_separation_adjustments): Updated.

2025-04-26  Werner Lemberg  <wl@gnu.org>

	* src/autofit/afranges.c: Updated to Unicode 17.0.

	But no support for new scripts (volunteers welcomed).

2025-04-26  Werner Lemberg  <wl@gnu.org>

	* src/autofit/afranges.c: Updated to Unicode 16.0.

	But no support for new scripts (volunteers welcomed).

2025-04-26  Werner Lemberg  <wl@gnu.org>

	* src/autofit/afranges.c: Updated to Unicode 15.1.

	But no support for new scripts (volunteers welcomed).

2025-04-26  Werner Lemberg  <wl@gnu.org>

	* src/autofit/afranges.c: Updated to Unicode 14.0.

	But no support for new scripts (volunteers welcomed).

2025-04-26  Werner Lemberg  <wl@gnu.org>

	* src/autofit/afranges.c: Updated to Unicode 13.0.

	But no support for new scripts (volunteers welcomed).

2025-04-26  Werner Lemberg  <wl@gnu.org>

	* src/autofit/afranges.c: Updated to Unicode 12.0.

	But no support for new scripts (volunteers welcomed).

2025-04-25  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* include/freetype/internal/ftcalc.h (FT_MulFix_64): Silence UBSAN.

2025-04-22  Behdad Esfahbod  <behdad@behdad.org>

	* src/autofit/afadjust.c (af_get_glyph_alternates): Fix endless loop.

2025-04-20  Werner Lemberg  <wl@gnu.org>

	* src/afadjust.c: Fix test for newer HarfBuzz version (second try).

2025-04-20  Werner Lemberg  <wl@gnu.org>

	* src/afadjust.c: Fix test for newer HarfBuzz version.

2025-04-20  Werner Lemberg  <wl@gnu.org>

	[autofit] Request at least HarfBuzz 7.2.0 for diacritic support. (3/3)

	This version (from April 2023) added 'SingleSubst' support to
	`hb_ot_layout_lookup_get_glyph_alternates`.

2025-04-20  Werner Lemberg  <wl@gnu.org>

	[autofit] Speed up creation of the adjustment database's reverse map. (2/3)

	Remove the old code and activate the new one.

2025-04-20  Werner Lemberg  <wl@gnu.org>

	[autofit] Speed up creation of the adjustment database's reverse map. (1/3)

	As it turns out, the original implementation using
	`hb_ot_shape_glyphs_closure` is extremely slow if a font has a rich set of
	OpenType features.  For example, this function was called 66954 times while
	loading font `arial.ttf` version 7.00, increasing FreeType's startup time by
	a factor of 10, which is unacceptable.

	The new algorithm uses a completely different, more low-level approach, no
	longer working with OpenType features but with OpenType lookups.  It relies
	on function `hb_ot_layout_lookup_get_glyph_alternates`, also replacing
	recursion with a simple loop.  In total, this brings the additional startup
	time back to an acceptable range of a few percent.

	A side effect of the new approach is that it catches more alternate forms:
	the old code didn't properly handle script-specific features.

	To make the change more readable, this commit only adds new code.

2025-04-18  Werner Lemberg  <wl@gnu.org>

	* src/autofit/afadjust.c (af_reverse_character_map_new): Check `map` limit.

	Reported as

	  https://issues.chromium.org/issues/410925355

2025-04-18  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* include/freetype/internal/ftcalc.h: Fix fringe compilation.

2025-04-18  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/base/ftcalc.c (ft_corner_orientation) [!FT_INT32]: Fix up.

2025-04-17  Werner Lemberg  <wl@gnu.org>

	[autofit] Don't access uninitialized memory.

	Reported as

	  https://bugs.ghostscript.com/show_bug.cgi?id=708295

	* src/autofit/aflatin.c
	  (af_glyph_hints_apply_vertical_separation_adjustments): Initialize all
	  array elements of `contour_y_minima` and `contour_y_maxima`.

2025-04-17  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/truetype/ttinterp.c (TT_MulFix14,TT_DotFix14)[!FT_INT64]: Sync.

2025-04-17  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/truetype/ttinterp.c (TT_DotFix14): Silence UBSAN.

2025-04-17  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/base/ftcalc.c: Miscellaneous cleanups.

2025-04-16  Werner Lemberg  <wl@gnu.org>

	[autofit] Avoid crash.

	Reported as

	  https://issues.oss-fuzz.com/issues/410811029

	* src/autofit/aflatin.c (af_remove_segments_containing_point): Check
	  `edge->last`.

2025-04-15  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[base, truetype] Silence UBSAN (cont'd).

	

	* src/truetype/ttinterp.c (TT_MulFix14, TT_DotFix14): Use MUL_INT64.

	* include/freetype/internal/ftcalc.c (FT_MulFix): Ditto.

2025-04-15  Werner Lemberg  <wl@gnu.org>

	[autofit] Avoid unnecessary recomputation of HarfBuzz data.

	Call the functions once per font instead of once per glyph.

	* src/autofit/afadjust.c (af_all_glyph_variants): Move code to compute the
	  `feature_tags` and `type_3_lookup_indices` sets to...
	  (af_reverse_character_map_new): ...this function.

2025-04-15  Werner Lemberg  <wl@gnu.org>

	[autofit] Fix creation of the adjustment database's reverse map.

	Due to the way the reverse map array gets constructed with HarfBuzz, there
	might be multiple, identical glyph index entries with different character
	values in the array.  As an example, an OpenType feature like 'unic' might
	map lowercase glyph 'ae' to uppercase glyph 'AE', in addition to the already
	present cmap entry for 'AE'.

	In most cases, this incorrect mapping is harmless (but still wrong).
	However, there exist some lowercase/uppercase character pairs where the
	diacritic for the uppercase character is on the other vertical side of the
	base character as for the lowercase character.  An example is U+0122 (LATIN
	CAPITAL LETTER G WITH CEDILLA) and U+0123 (LATIN SMALL LETTER G WITH
	CEDILLA): the former has the cedilla below, the latter above.  A wrong
	mapping would thus shift the base glyph 'G' up by a pixel instead of
	shifting the cedilla down.

	We fix this by always giving precedence to cmap entries.

	* src/autofit/afadjust.c (af_reverse_character_map_entry_compare): Do a
	  secondary sort on the character code.

	  (af_reverse_character_map_lookup): Adjust binary search to return the
	  first occurrence of an entry (i.e., the one with the lowest array index).

	  (af_reverse_character_map_new)[FT_CONFIG_OPTION_USE_HARFBUZZ]: Implement
	  cmap priority.

2025-04-15  Werner Lemberg  <wl@gnu.org>

	[autofit] Reduce adjustment database lookups.

	This is also in preparation for a follow-up commit.

	* src/autofit/afadjust.h (af_lookup_vertical_separation_type,
	  af_lookup_tilde_correction_type): Replaced with...
	  (af_adjustment_database_lookup, af_reverse_character_map_lookup):
	  ... this.

	* src/autofit/afadjust.c (af_adjustment_database_lookup,
	  af_adjustment_database_lookup): Updated.
	  (af_lookup_vertical_separation_type, af_lookup_tilde_correction_type):
	  Removed.
	  (af_reverse_character_map_new)[FT_DEBUG_LEVEL_TRACE]: Updated.

	* src/autofit/aflatin.c
	  (af_glyph_hints_apply_vertical_separation_adjustments,
	  af_latin_hints_apply): Updated.

2025-04-15  Werner Lemberg  <wl@gnu.org>

	* src/afadjust.c (adjustment_database): Make it complete up to U+017F.

2025-04-15  Werner Lemberg  <wl@gnu.org>

	* src/autofit/afadjust.c (af_reverse_character_map_new): Add tracing code.

2025-04-15  Werner Lemberg  <wl@gnu.org>

	* src/afadjust.c: Minor fixes.

2025-04-15  Werner Lemberg  <wl@gnu.org>

	[autofit] Better vertical separation adjustment support. (2/2)

	* src/autofit/aflatin.c
	  (af_glyph_hints_apply_vertical_separation_adjustments): Handle diacritics
	  with more than a single contour.

2025-04-15  Werner Lemberg  <wl@gnu.org>

	[autofit] Better vertical separation adjustment support. (1/2)

	Test vertical maxima instead of vertical minima to identify the highest
	contour (and vice versa to identify the lowest contour).  Doing so will
	allow support of diacritics that consist of more than a single outline.

	This works because of the topological constraints ensured by the adjustment
	database.

	* src/autofit/aflatin.c (af_find_highest_contour,
	  af_glyph_hints_apply_vertical_separation_adjustments): Implement it.

2025-04-15  Werner Lemberg  <wl@gnu.org>

	[autofit] Use new y extrema arrays.

	* src/autofit/aflatin.c
	  (af_glyph_hints_apply_vertical_separation_adjustments): Implement it.

2025-04-15  Werner Lemberg  <wl@gnu.org>

	[autofit] Provide infrastructure for storing y extrema of contours.

	We need this for better positioning support of diacritics.

	* src/autofit/afhints.h (AF_GlyphHintsRec): New fields `contour_y_minima`
	  and `contour_y_maxima`, together with its embedded variants.

	* src/autofit/afhints.c (af_glyph_hints_done, af_glyph_hints_reload): Handle
	  new arrays.

2025-04-15  Werner Lemberg  <wl@gnu.org>

	[autofit] Avoid crash.

	Reported as

	  https://issues.oss-fuzz.com/issues/410609442

	* src/autofit/aflatin.c (af_remove_segments_containing_point): Check `edge`.

2025-04-14  Werner Lemberg  <wl@gnu.org>

	[autofit] Fix just introduced heap buffer overflow

	Reported as

	  https://issues.oss-fuzz.com/issues/410393975

	* src/autofit/afadjust.c [!FT_CONFIG_OPTION_USE_HARFBUZZ]: Synchronize with
	  HarfBuzz code.

2025-04-14  Werner Lemberg  <wl@gnu.org>

	* docs/CHANGES: Mention Craig's GSoC 2023 project.

2025-04-14  Craig White  <gerzytet@gmail.com>

	[autofit] Add GSUB table handling to reverse character map generation.

	If HarfBuzz is enabled, the reverse character map generation now considers
	GSUB entries when looking for glyphs that correspond to a code point.

	* src/autofit/afadjust.c (af_all_glyph_variants_helper,
	af_all_glyph_variants) [FT_CONFIG_OPTION_USE_HARFBUZZ]: New functions.

	(af_reverse_character_map_new) [FT_CONFIG_OPTION_USE_HARFBUZZ]: Call new
	code.

2025-04-14  Craig White  <gerzytet@gmail.com>

	[autofit] Add tilde-unflattening algorithm.

	* src/autofit/aflatin.c (af_find_highest_contour,
	af_remove_segments_containing_point,
	af_latin_remove_tilde_points_from_edges, af_latin_stretch_tilde,
	af_latin_align_tilde): New functions.
	(af_latin_hints_apply): Call tilde-unflatting code if necessary.

2025-04-14  Craig White  <gerzytet@gmail.com>

	[autofit] Implement vertical separation adjustment.

	* src/autofit/aflatin.c: Include `afadjust.h`.
	(af_latin_metrics_init): Call `af_reverse_character_map_new`.
	(af_latin_metrics_done): New function.

	(af_move_contour_vertically, af_check_contour_horizontal_overlap,
	af_glyph_hints_apply_vertical_separation_adjustments): New functions.

	(af_latin_hints_apply): Call
	`af_glyph_hints_apply_vertical_separation_adjustments`.

	(af_latin_writing_system_class): Updated.

	* src/autofit/aftypes.h (AF_StyleMetricsRec): Add `reverse_charmap` field.

2025-04-14  Craig White  <gerzytet@gmail.com>

	[autofit] Add code for reverse charmaps and adjustment database lookup.

	* src/autofit/aftypes.h (AF_ReverseMapEntry, AF_ReverseCharacterMap): New
	structures.

	* src/autofit/afadjust.c (af_adjustment_database_lookup,
	af_reverse_character_map_entry_compare, af_reverse_character_map_lookup,
	af_lookup_vertical_separation_type, af_lookup_tilde_correction_type,
	af_reverse_character_map_expand, af_reverse_character_map_new,
	af_reverse_character_map_done): New functions.

	* src/autofit/afadjust.c: Updated.

2025-04-14  Craig White  <gerzytet@gmail.com>

	[autofit] Add adjustment database.

	* src/autofit/afadjust.c, src/autofit/afadjust.h: New files.

	* include/freetype/internal/fttrace.h: Add 'afadjust' component.

	* src/autofit/autofit.c: Include `afadjust.c`.

	* src/autofit/rules.mk (AUTOF_DRV_SRC): Add `afadjust.c`.

2025-04-14  Craig White  <gerzytet@gmail.com>

	[base] Make `find_unicode_charmap` a base function.

	This is needed for forthcoming changes in the auto-hinter.

	* include/freetype/internal/ftobjs.h, src/base/ftobjs.c: Updated.

2025-04-12  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/bdf/bdflib.c (hdigits): Removed.

	Fixes #1325.

2025-04-12  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* include/freetype/internal/ftcalc.h (FT_MSB) [__CC_ARM]: Added.

2025-04-12  Alexei Podtelezhnikov  <apodtele@gmail.com>

	Typos in macros.

	* include/freetype/internal/ftcalc.h: s/_M_X86/_M_IX86/.
	* src/truetype/ttinterp.c: s/_M_X86/_M_IX86/.

2025-04-12  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* docs/CHANGES: Updated.

2025-04-12  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[base, truetype] Silence UBSAN.

	* src/truetype/ttinterp.c (TT_MulFix14_64): Use unsigned multiplication.
	* include/freetype/internal/ftcalc.h (FT_MulFix_64): Ditto.

2025-04-12  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[base, truetype] Synchronize MulFix assembly.

	* include/freetype/internal/ftcalc.h (FT_MulFix_*),
	src/truetype/ttinterp.c (TT_MulFix14_*): Synchronize routines.

2025-04-10  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[truetype] Modernize bytecode projections.

	

	With 64-bit platforms widely available, it is more efficient to use

	64-bit variables readily. It results in noticeable 10% improvement

	in glyph loading speed.

	

	* src/truetype/ttinterp.c (TT_MulFix14, TT_DotFix14) [FT_INT64]:

	Prioritize available implementation with arguments adjusted based on

	the use cases.


2025-04-09  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[base] Update FT_MulFix inlining.

	Resolves inconsistencies in 64-bit multiplication discussed in !355.
	Importantly, FT_MulFix arguments and return value is FT_Long,
	whatever sizeof FT_Long is on 64-bit platforms: 8 bytes on Linux or
	4 bytes on Windows.

	* include/freetype/internal/ftcalc.h (FT_MulFix_x86_64): Removed.
	(FT_MulFix_64): Generalize and prioritize the inline implementation
	for all 64-bit platforms ifdef FT_INT64.
	* src/base/ftcalc.c (FT_MulFix)[FT_INT64]: Call 'FT_MulFix_64'.
	* src/base/ftbase.c: Include 'ftcalc.c' after the FT_MulFix callers
	to enable its inlining.

2025-04-09  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[base] Update FT_MulFix inlining.

	                                                                                                                        Resolves inconsistencies in 64-bit multiplication discussed in !355.                                                    Importantly, FT_MulFix arguments and return value is FT_Long,                                                           whatever sizeof FT_Long is on 64-bit platforms: 8 bytes on Linux or                                                     4 bytes on Windows.                                                                                                                                                                                                                             * include/freetype/internal/ftcalc.h (FT_MulFix_x86_64): Removed.                                                       (FT_MulFix_64): Generalize and prioritize the inline implementation

	for all 64-bit platforms ifdef FT_INT64.                                                                                * src/base/ftcalc.c (FT_MulFix)[FT_INT64]: Call 'FT_MulFix_64'.                                                         * src/base/ftbase.c: Include 'ftcalc.c' after the FT_MulFix callers                                                     to enable its inlining.


2025-04-05  Graham Asher  <graham.asher@cartotype.com>

	Missing header wrappers.

	* include/freetype/config/integer-types.h, src/smooth/ftgrays.h:
	Add missing FT_BEGIN_HEADER and FT_END_HEADER.
	* src/smooth/ftgrays.c: Cosmetics.

2025-03-26  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[bdf] Clarify callback flow.

	* src/bdf/bdflib.c (bdf_line_func_t_): Modify callback prototype.
	(bdf_parse_*_): Updated.
	(bdf_load_font, bdf_readstream_): Delay callback initiation.

2025-03-26  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/bdf/bdflib.c (bdf_readstream_): Relocate.

2025-03-26  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/bdf/bdflib.c (bdf_is_atom_): Do not check tabs.

2025-03-26  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/bdf/bdflib.c (_bdf_strncmp): Macro removed, callers updated.

2025-02-26  Alexei Podtelezhnikov  <apodtele@gmail.com>

	.gitlab-ci.yml: Minor.

2025-02-26  Tim-Philipp Müller  <tim@centricular.com>

	* .gitlab-ci.yml: Switch to arm64 runners for macOS CI.

2025-02-25  Behdad Esfahbod  <behdad@behdad.org>

	[sfnt/CPAL] Return early if user requested currently-set palette

	Before, we were loading a palette (again and again) even if the
	same was requested. Even if the font only had one palette...

	For a font like NotoColorEmoji that has over 5000 colors in its
	palette, this was dominating the COLRv1 loading times for HarfBuzz
	(and I believe all other clients) because they have to set the
	palette to get access to the colors.

	* src/base/ftcolor.c (FT_Palette_Select): Check the current palette.

2025-01-29  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/bdf/bdflib.c (bdf_parse_start_): Move setup of properties.

2025-01-25  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[bdf] Treat all comments uniformly.

	* src/bdf/bdflib.c (bdf_parse_start_): Reject fonts with initial
	COMMENTs.
	(bdf_parse_properties_): Skip COMMENTs so that...
	(bdf_add_property_): Do not make exception for COMMENT.
	(bdf_parse_glyphs_, bdf_add_comments): Updated.

2025-01-25  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/bdf/bdflib.c (BDF_SWIDTH_ADJ_): Remove clashing flag and update.

2025-01-23  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/bdf/bdflib.c (bdf_atous_): Remove unnecessary checks.

2025-01-23  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/bdf/bdflib.c (bdf_ato{i.ul.s.us}_]): Remove uncecessary checks.

2025-01-23  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[bdf] Postpone font default char handling.

	* src/bdf/bdflib.c (bdf_parse_start_, bdf_add_property_): Delay handling
	of the default char until...
	* src/bdf/bdfdrivr.c (BDF_Face_Init): ... handles all other properties.

2025-01-23  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[bdf] Postpone font spacing handling.

	* src/bdf/bdf.h (bdf_font_t): Remove `monowidth`.
	* src/bdf/bdflib.c (bdf_parse_start_, bdf_add_property_): Delay handling
	of the font spacing until...
	* src/bdf/bdfdrivr.c (BDF_Face_Init): ... handles all other properties.

2025-01-23  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[bdf] Postpone font ascent and descent handling.

	* src/bdf/bdflib.c (bdf_parse_start_, bdf_add_property_): Delay handling
	of the font ascent and descent until...
	* src/bdf/bdfdrivr.c (BDF_Face_Init): ... handles all other properties.

2025-01-22  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/bdf/bdflib.c (bdf_parse_start_): Relax the header order.

	We now check that the header is complete in no specific order.

2025-01-20  Chad Brokaw  <cbrokaw@gmail.com>

	* src/truetype/ttgxvar.c (tt_face_vary_cvt): Fix all shared values.

	Applying cvar deltas to all shared points was incorrectly omitted.
	Fixes #1314.

2025-01-19  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/bdf/bdflib.c (bdf_parse_glyphs_): Fix tracing.

2025-01-19  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[bdf] Tokenize input instead of listing.

	Instead of cumbersome field list mamangement, we will tokenize input
	using custom `bdf_strtok_`.

	* src/bdf/bdflib.c (bdf_list_t_, bdf_list_init_, bdf_list_ensure_,
	bdf_list_shift_, bdf_list_join_, bdf_list_split_,
	bdf_set_default_spacing_): Removed.
	(bdf_strtok_): New function which NUL-terminates the first token at
	the delimiter position and returns the next token that follows
	consequtive delimiters.
	(bdf_parse_*_, bdf_load_font): Updated.

	* docs/CHANGES: Claim overall 75% performance improvement.

2025-01-18  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/bdf/bdflib.c (bdf_parse_start_): Prevent another STARTPROPERTIES.

	Only one STARTPROPERTIES was permitted in the old flow preventing
	leaks and overflows.

	See https://issues.oss-fuzz.com/issues/389968131
	    https://issues.oss-fuzz.com/issues/390464875

2025-01-17  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/bdf/bdflib.c (bdf_parse_start_): Do not overwrite flags.

2025-01-16  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/bdf/bdflib.c (bdf_readstream_): Skip all control characters.

	This agrees with specifications and makes the code a lot simpler.

2025-01-16  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/bdf/bdflib.c (bdf_parse_start_): Reserve space for artificial properties.

2025-01-15  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/bdf/bdflib.c (bdf_add_property_): Add extra protection.

	See https://issues.oss-fuzz.com/issues/389972472
	    https://issues.oss-fuzz.com/issues/389968131

2025-01-15  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/bdf/bdflib.c: Clean up.

2025-01-15  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[bdf] Use flags instead of options.

	* src/bdf/bdf.h (bdf_options_t): Removed.
	(BDF_KEEP_COMMENTS, BDF_KEEP_UNENCODED, BDF_CORRECT_METRICS): Updated
	to avoid collisions with the other parsing flags.
	* src/bdf/bdfdrivr.c (BDF_Face_Init): Use default flags explicitly.
	* src/bdf/bdflib.c (bdf_load_font): Use flags as an argument to
	initialize the parser.
	(bdf_set_fedault_spacing_): Default to BDF_PROPORTIONAL explicitly.
	(bdf_parse_*_): Updated.

2025-01-15  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[bdf] Adjust parsing flow and CHARS handling.

	* src/bdf/bdflib.c (bdf_readstream_): Remove CHARS exception.
	(bdf_parse_glyphs_): Move glyphs allocation...
	(bdf_parse_properties_): and missing ascent and descent handling...
	(bdf_parse_start_): ...to here under CHARS.

2025-01-15  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/bdf/bdflib.c (bdf_readstream_): Tweak variables and loop design.

2025-01-13  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/bdf/bdflib.c (bdf_parse_glyphs_): Free unused glyph_name.

	See https://issues.oss-fuzz.com/issues/389330334.

2025-01-13  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/bdf/bdflib.c (bdf_parse_glyphs_): Store glyph as soon as possible.

2025-01-12  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/bdf/bdflib.c (bdf_parse_glyphs_): Avoid possible leak.

2025-01-12  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[bdf] Speed up bitmap parsing.

	A dedicated parser of bitmap data with minimal error checking and
	no string comparisons helps to improve performance.

	* src/bdf/bdflib.c (bdf_parse_bitmap_): New dedicated bitmap parser.
	(bdf_parse_glyphs_): Pass to `bdf_parse_bitmap_` on BITMAP.

2025-01-12  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/bdf/bdflib.c (a2i): Formatting.

2025-01-11  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/bdf/bdflib.c (bdf_parse_*_): Minor improvements.

2025-01-11  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/bdf/bdf.h (bdf_font_t): Correct `internal` type.
	* src/bdf/bdflib.c (*): Update users.

2025-01-10  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* builds/windows/ftsystem.c: Fix ancient condition.

2025-01-10  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/bdf/bdflib.c (bdf_parse_start_): Fix tracing labels.

2025-01-09  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* MSBuild.rsp: Force console color for mintty.

2025-01-09  Heiko Lewin  <hlewin@worldiety.de>

	* CMakeLists.txt: Use modern IMPORTED targets.

	This resolves build problems with newer libPNG versions by switching
	to using IMPORTED CMake targets for common libraries where provided.
	To do this the required CMake version is raised to version 3.12.
	Doing this seems justified as using IMPORTED targets is a cleaner
	and more powerful solution that can leverage advanced and CMake-specific
	features that may be utilized by the referred dependencies' CMake modules.

	Resolves #1311.

2025-01-08  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[cff] Remove size/slot checks.

	After the previous commit, cff_glyph_load is no longer called
	without first checking for valid size and glyph objects in
	FT_Glyph_Load and these checks can be removed downstream.

	* src/cff/cffdrivr.c (cff_glyph_load): Remove `size` and `glyph` checks.
	* src/cff/cffgload.c (cff_slot_load): Ditto.

2025-01-08  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/cff/cffdrivr.c (cff_get_advances): Do only fast advances.

	Otherwise, let TT_Get_Advances fall back on cff_load_glyph to do
	slow advances. This avoids unchecked access to cff_load_glyph and
	this is how tt_get_advances is implemented.

2025-01-04  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/truetype/ttgload.c (TT_Load_Glyph): Consolidate flag setting.

2025-01-04  Alexei Podtelezhnikov  <apodtele@gmail.com>

	Delay FT_GLYPH_FORMAT_OUTLINE assignmets.

	This assignmets used to be done prematurely before errors were checked
	and outlines were actually loaded. Delaying the assignment provides
	certain protection against careless usage of malformed input that
	should now remain FT_GLYPH_FORMAT_NONE.

	* src/cff/cffgload.c (cff_slot_load): Ditto.
	* src/cid/cidgload.c (cid_slot_load_glyph): Ditto.
	* src/pfr/pfrobjs.c (pfr_slot_load): Ditto.
	* src/truetype/ttgload.c (TT_Load_Glyph): Ditto.
	* src/type1/t1gload.c (T1_Load_Glyph): Ditto.

2025-01-03  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* builds/compiler/gcc-dev.mk: Silence some warnings.

2025-01-02  Alexei Podtelezhnikov  <apodtele@gmail.com>

	Remove superfluous outline zeroing.

	

	This is already done by `ft_glyphslot_clear`.

	

	* src/cff/cffgload.c (cff_slot_load): Do not zero outline fields.

	* src/cid/cidgload.c (cid_slot_load_glyph: Ditto.

	* src/pfr/pfrobjs.c (pfr_slot_load): Ditto.

	* src/truetype/ttgload.c (load_sbit_image): Ditto.

	* src/type1/t1gload.c (T1_Load_Glyph): Ditto.

2025-01-02  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/truetype/ttobjs.c: Abbreviate tracing.

2025-01-02  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/sfnt/ttsbit.c (tt_face_load_sbix_image): Refactor `flip`.

2025-01-01  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[truetype] Consolidate bitmap strike handling.

	* src/truetype/ttgload.c (TT_Load_Glyph): Relocate omitted whitespace
	strike handling from here...
	(load_sbit_image): ... to here.

2024-12-31  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[truetype] Ingnore FT_LOAD_NO_BITMAP in bitmap-only fonts.

	For consistency with other bitmap-only fonts, we should ignore this
	flag of the font is not scalable.

	* src/truetype/ttgload.c (TT_Load_Glyph): Check if face is scalable
	when checking for FT_LOAD_NO_BITMAP.

	* docs/CHANGES: Start new chapter wtith this change.

2024-12-16  Ben Wagner  <bungeman@chromium.org>

	[ftstroke] Fix invalid pointer assignement to `arc`

	In `FT_Stroker_ConicTo` and `FT_Stroker_CubicTo` there is a `bez_stack`.
	`arc` is initialized with `arc = bez_stack` and is never set to point
	into any different object. The main loop looks like `while ( arc >=
	bez_stack )` which is depending on a later `arc -= 2` (or `arc -= 3`) to
	make `arc` point to before `bez_stack`. However, using pointer
	subtraction to make `arc` point outside the array is undefined behavior,
	and attempting to use the value in the loop predicate is "very"
	undefined behavior. (C99 "Additive operators" 6.5.6.8.)

	This particular undefined behavior was discovered as either hangs or
	MemorySantizer issues after "[InstCombine] Infer nuw for gep inbounds
	from base of object" [0]. With this change, clang can infer that `arc`
	must always point into the `bez_stack` object and therefore cannot be at
	a "negative index" so the predicate is always true.

	[0] https://github.com/llvm/llvm-project/commit/e21ab4d16b555c28ded307571d138f594f33e325

	* src/base/ftstroke.c (FT_Stroker_ConicTo, FT_Stroker_CubicTo): test
	loop exit condition (there are no more arcs to process) before
	decrementing `arc`

	Fixes: #1307

2024-12-04  Ben Wagner  <bungeman@chromium.org>

	[cff] Fix leak of cmap data

	When `sfnt->load_face` succeeds it has already loaded any (optional)
	cmap data. As a result, a subsequent call to `sfnt->load_cmap` will
	overwrite the cmap data pointer with a new copy of the data but not free
	the old, leading to a leak.

	This is a fix for "* src/cff/cffobjs.c (cff_face_init): Better handling
	of Type0 fonts.". This still allows the cmap to be missing but avoids
	the leak by only calling `sfnt->load_cmap` when there is no `head`
	table (the font data is not being loaded as OpenType/CFF).

	* src/cff/cffobjs.c (cff_face_init): Fix leak

	Fixes: #1306

2024-11-06  Honnesh Ramachandra  <hramachandra@adobe.com>

	* src/cff/cffobjs.c (cff_face_init): Better handling of Type0 fonts.

	This issue relates to the PDF specification and its usage of CFF-based
	embedded Type0 fonts.  For Type0 fonts containing CID-keyed descendant
	CFF-based fonts, the glyph index is the CID present in the content stream.
	As a result, there is no requirement for a 'cmap' table to be present in the
	font since the glyph indices are derived directly from the CIDs.  FreeType
	throws an error when it doesn’t find a 'cmap' table for such an Open Type
	font containing CFF outlines.  This commit relaxes this requirement for a
	'cmap' table for such fonts.

2024-10-18  suzuki toshiya  <mpsuzuki@hiroshima-u.ac.jp>

	Download the latest gnu-config files in `make dist`.

	* builds/toplevel.mk: In `make dist`, checkout gnu-config
	git repository at savannah, copy the latest versions of
	`config.guess` and `config.sub` to builds/unix/.  Also
	the latest version of `gitlog-to-changelog` is used to
	generate `ChangeLog`.

2024-10-16  Behdad Esfahbod  <behdad@behdad.org>

	Move generic destroy to later in the face and size destruction.

	* src/base/ftobjs.c (destroy_size, destroy_face): This is such that the
	  generic destroy can be used to call `FT_Done_Library`.  For that to work,
	  it needs to call it *after* having removed the face from the respective
	  module.

2024-10-14  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/truetype/ttgload.c (load_truetype_glyph): Rearrange.

2024-10-14  suzuki toshiya  <mpsuzuki@hiroshima-u.ac.jp>

	* autogen.sh: Fix for Solaris 10.

	o Replace `test -e` by `test -d` (directory) and `-h`
	  (symlink), because pre-POSIX /bin/sh of Solaris 10
	  does not support `test -e`.
	o Replace the combination of `head` and `sed ...` by
	  single sed command `sed -n 1...p`.  GNU libtoolize
	  with Solaris 10 /bin/sh complains "Broken Pipe" for
	  the closure of stdout by `head`.  Let `sed` receive
	  all stdout and discard.

2024-10-13  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/smooth/ftgrays.c (gray_convert_glyph): Clear stack pointers.

	Fixes a dangling pointer warning, see #1299.

2024-10-13  suzuki toshiya  <mpsuzuki@hiroshima-u.ac.jp>

	apinames: Fix a buffer overrun for VMS platform.

	Some output formats may rewrite symbol names during the output,
	like the concatenation of "64__" suffix on VMS.  To estimate
	sufficient size to store symbol name, pass the output format
	info to `names_add`.  For VMS, `names_add` allocates longer
	buffer to append "64__".

	* apinames.c (SUFFIX_VMS_64ADDR): New macro of "64__".
	(main): Pass the format info to `read_header_file`.
	(read_header_file): Pass the format info to `names_add`.
	(names_add): Receive the format info, and reserve the symbol
	name buffer 4 byte longer in the case of VMS, to append the
	suffix in `names_dump`.

2024-10-13  suzuki toshiya  <mpsuzuki@hiroshima-u.ac.jp>

	apinames: Fix out-of-scope reference of a static array.

	* apinames.c (names_dump): For WATCOM_LBC format, the
	  DLL name with no suffix is constructed on a static
	  array temp[], but the scope is closed before use it.
	  The declaration of temp[] is moved to the wider
	  scope for the dumping part to refer it.

2024-10-12  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* vms_make.com: Format rules.

	Use tabs in rules only à la Makefile.

2024-10-12  Marian Klymov  <nekto1989@gmail.com>

	* meson.build: Define DLL_EXPORT for shared library only.

	Fixes #1298.

2024-10-12  Benoit Pierre  <benoit.pierre+freedesktop@gmail.com>

	* meson.build: Minor improvements.

2024-10-12  Benoit Pierre  <benoit.pierre+freedesktop@gmail.com>

	* meson.build: Fix `bzip2` option handling.

2024-10-12  Benoit Pierre  <benoit.pierre+freedesktop@gmail.com>

	* meson.build: Add support for compiling with error strings.
	* meson_options.txt: Document it.

2024-10-10  suzuki toshiya  <mpsuzuki@hiroshima-u.ac.jp>

	Fix help message of apinames.

	* src/tools/apinames.c: The first header file must be
	  given after the options.  All arguments after the
	  first header file are dealt as header files to be
	  parsed, regardless with their leading "-".

	  For example,
	  "apinames include/freetype/freetype.h -dFREETYPE.DLL"
	  warns "unable to open -dFREETYPE.DLL".

	  Thus, the "header1" must be given after the arguments
	  to be parsed as the options.

2024-09-21  Jouk Jansen  <joukj@hrem.nano.tudelft.nl>

	Minor fixes for OpenVMS.

	* vms_name.com: Suppress a warning with the latest Clang compiler.

	* builds/vms/apinames_vms.bash: Use absolute path to avoid dependency on the
	  environment.

2024-09-07  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/sfnt/ttsbit.c (tt_face_load_sbix_image): Respect metrics_only.

	Also fixes recursive flip.

2024-09-06  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/sfnt/ttsbit.c (tt_face_load_sbix_image): Tweak loop.

2024-09-06  Andrew Murray  <radarhere@users.noreply.github.com>

	[sfnt] Support sbix graphicType 'flip'.

	* src/sfnt/ttsbit.c (tt_face_load_sbix_image): Currently undocumented by
	Apple, this flips the bitmap data horizontally.  It is used on macOS in
	Apple Color Emoji; 19.4d6e1; 2024-02-05 (file `Apple Color Emoji.ttc`).

	Fixes issue #1282.

2024-09-05  suzuki toshiya  <mpsuzuki@hiroshima-u.ac.jp>

	Add `clang` to host compiler candidates in cross building.

	* builds/unix/configure.raw: In cross building,
	`clang` is tried if there is no `gcc`, nor `cc`.

2024-09-05  suzuki toshiya  <mpsuzuki@hiroshima-u.ac.jp>

	Improve the build rule for `apinames`.

	* builds/unix/configure.raw: copy `CFLAGS` &
	`LDFLAGS` values to `CFLAGS_BUILD` &
	`LDFLAGS_BUILD`, in a self-hosting case.

	* builds/unix/unix-cc.in: set `CCexe_CFLAGS` &
	`CCexe_LDFLAGS` by `CFLAGS_BUILD` &
	`LDFLAGS_BUILD`.

	In some confused environments, simple building
	like `cc -o apinames apinames.c` is no longer
	able to build an executable running on the host.

	The validity of `CC` is tested with consideration
	of `CFLAGS` and `LDFLAGS`, thus, duplicating
	`CFLAGS` & `LDFLAGS` to `CCexe_CFLAGS` &
	`CCexe_LDFLAGS` (via XXX_BUILD) would be slightly
	safer in a self-hosting build.

	Fixes the issue #1296.

2024-08-26  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/sfnt/ttcmap.c (tt_cmap*_get_info): Remove casting.

2024-08-25  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* include/freetype/ftimage.h (FT_Bitmap): Describe empty bitmap.

2024-08-14  luz paz  <luzpaz@github.com>

	Fix various typos.

2024-08-13  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* messon.build: Install `include/freetype/ftlogging.h`.

	Fixes #1292.

2024-08-12  Werner Lemberg  <wl@gnu.org>

	* Version 2.13.3 released.
	==========================

	Tag sources with `VER-2-13-3'.

	* docs/VERSION.TXT: Add entry for version 2.13.3.
	* docs/CHANGES: Updated.
	* docs/release, docs/README, builds/macs/README: Updated.

	* README, src/base/ftver.rc, builds/windows/vc2010/index.html,
	builds/windows/visualc/index.html, builds/windows/visualce/index.html,
	builds/wince/vc2005-ce/index.html, builds/wince/vc2008-ce/index.html,
	docs/freetype-config.1: s/2.13.2/2.13.3/, s/2132/2133/.

	* include/freetype/freetype.h (FREETYPE_PATCH): Set to 3.

	* builds/unix/configure.raw (version_info): Set to 26:2:20.
	* CMakeLists.txt (VERSION_PATCH): Set to 3.

2024-08-12  Werner Lemberg  <wl@gnu.org>

	* meson.build: Install `freetype2.m4`.

	Fixes #1290.

2024-08-12  Werner Lemberg  <wl@gnu.org>

	* src/*/*: Fix C++ compilation; fix clang warnings.

2024-08-12  Werner Lemberg  <wl@gnu.org>

	* subprojects/*.wrap: Updated.

2024-08-12  Werner Lemberg  <wl@gnu.org>

	Various minor documentation or formatting fixes.

2024-08-07  Werner Lemberg  <wl@gnu.org>

	tttables.h (FT_Get_CMap_Format): Minor documentation improvement.

2024-08-05  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/truetype/ttgxvar.c (ft_var_readpacked*): Minor.

2024-08-05  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/base/ftstream.c (FT_Stream_ReadFields): Switch to `FT_Offset`.

2024-08-02  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/winfonts/winfnt.c (fnt_face_get_dll_font): Unwrap arithmetic.

2024-08-02  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/base/ftstream.c (FT_Stream_ReadFields): Update condition.

2024-08-02  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[truetype/GX] Use more robust conditions.

	* src/truetype/ttgxvar.c (ft_var_readpacked{points,deltas}): Rewrite
	conditions to avoid undefined behavior.

2024-07-31  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[truetype/GX] Read points and deltas more carefully.

	Hopefully fixes newly introduced buffer overflows:
	  https://bugs.chromium.org/p/oss-fuzz/issues/detail?id=70807
	  https://bugs.chromium.org/p/oss-fuzz/issues/detail?id=70809

	* src/truetype/ttgxvar.c (ft_var_readpacked{points,deltas}): Explicitly
	check stream frame limits and modify run counting.

2024-07-30  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[truetype/GX] Read stream more aggressively.

	With ample checks against the table size, we should be able to use
	macros without the limit checks and functional calls.

	* src/truetype/ttgxvar.c (ft_var_readpacked{points,deltas}):
	Use FT_NEXT_* instead of FT_GET_*.

2024-07-29  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/sfnt/ttload.c (tt_face_load_name): Shorten dereference.

2024-07-29  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/autofit/afmodule.c (af_autofitter_load_glyph): Shorten deref.

2024-07-29  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[bdf,pcf,winfonts,sfnt] Remove barely used marcros.

	* include/freetype/internal/ftobjs.h (FT_FACE_SIZE, FT_SIZE_FACE):
	Removed.
	* src/bdf/bdfdrivr.c (BDF_Glyph_Load): Updated.
	* src/pcf/pcfdrivr.c (PCF_Glyph_Load): Ditto.
	* src/winfonts/winfnt.c (FNT_Load_Glyph): Ditto
	* src/sfnt/ttbdf.c (tt_face_find_bdf_prop): Ditto.

2024-07-27  Dan Rosser  <danoli3@gmail.com>

	* include/freetype/internal/ftcalc.h (FT_MSB)[_M_ARM64EC]: Added.

2024-07-19  Werner Lemberg  <wl@gnu.org>

	* src/truetype/ttobjs.c (tt_size_run_prep): Correct scaling of CVT values.

	This reverts the scaling behaviour introduced in commit 37580053.

	Fixes issue #1005.

2024-06-29  Philip Race  <philip.race@oracle.com>

	* psobjs.c (ps_table_add): Check length before calling `FT_MEM_CPY`.

	Fixes issue #1280.

2024-06-29  Don Olmstead  <don.j.olmstead@gmail.com>

	CMakeLists.txt: Respect FT_DISABLE_ZLIB value

	The CMake build uses `find_package` to look for dependencies. Before calling `find_package` it looks to see if the dependency was disabled. If not the associated `_FOUND` variable will be set. This value is then checked to determine if the dependency is added.

	However `find_package(PNG)` calls `find_package(ZLIB)` within its find module. So in the case of `FT_DISABLE_ZLIB=TRUE` and `FT_DISABLE_PNG=FALSE` the `ZLIB_FOUND` value can be set and even though `FT_DISABLE_ZLIB` is turned on.

	Unset the value of `ZLIB_FOUND` after the call to `find_package(PNG)` so the value is only set when `FT_DISABLE_ZLIB` is turned off.

2024-06-26  Werner Lemberg  <wl@gnu.org>

	Make 'multi' build work again.

	* src/psaux/psobjs.c: Include `psft.h`.

	* src/sfnt/rules.mk (SFNT_DRV_SRC): Add `ttgpos.c`.

	Fixes issue #1284.

2024-06-23  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/truetype/ttgload.c (load_truetype_glyph): Unsigned fix.

2024-06-21  Alexei Podtelezhnikov  <apodtele@gmail.com>

	Use unsigned tags `FT_Outline`.

	This change comes along with 2a7bb4596f56 ans is only meant to reduce
	pointer casting in the code.

	* include/freetype/ftimage.h (FT_Outline): Do it.
	* src/*: Update `FT_Outline` users.

2024-06-21  Ben Wagner  <bungeman@chromum.org>

	[ttgxvar] Avoid "applying zero offset to null pointer"

	In C it is undefined behavior to do arithmetic on a null pointer, including
	adding zero. When using NotoSansKhmer[wdth,wght].ttf UBSAN produces a report
	like

	ttgxvar.c:1052:31: runtime error: applying zero offset to null pointer

	when adding zero to `varData->deltaSet` (which is null) to produce `bytes`.
	Protect against all the potential issues of this kind by returning early if
	`varData->regionIdxCount == 0`.

	* src/truetype/ttgxvar.c (tt_var_get_item_delta): early return on no regions

2024-06-21  Alexei Podtelezhnikov  <apodtele@gmail.com>

	Use unsigned point and contour indexing in `FT_Outline`.

	This doubles the number or allowed points, see
	    https://github.com/harfbuzz/harfbuzz/issues/4752

	Although it is hardly practical to use more than 32767 points,
	other font engines seem to support it.

	* docs/CHANGES: Announce it.
	* include/freetype/ftimage.h (FT_Outline): Do it and update limits.
	* src/*: Update `FT_Outline` users.

2024-06-20  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/pfr/pfrgload.c (pfr_glyph_curve_to): Avoid casting.

2024-06-19  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/base/ftgloadr.c (FT_GlyphLoader_Prepare): Minor refactoring.

2024-06-18  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[base, autofit, psaux] Remove unnecessary casting.

	

	* src/autofit/afhints.c (af_glyph_hints_reload): Remove (short) casting.

	* src/base/ftgloadr.c (FT_GlyphLoader_Add): Ditto.

	* src/psaux/psobjs.c ({t1,cff,ps}_builder_{add,close}_contour): Ditto.


2024-06-18  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* include/freetype/ftimage.h: Explain standard types.

2024-05-29  Ben Wagner  <bungeman@chromium.org>

	[ttgxvar] Replace tabs with spaces

	Also clarify comments around conversion and clamping.

	* src/truetype/ttgxvar.c (ft_var_to_normalized): doit

2024-05-27  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[truetype/GX] Consolidate memory allocations.

	* src/truetype/ttgxvar.c (tt_face_vary_cvt, TT_Vary_Apply_Glyph_Deltas):
	Allocate and split bigger memory blocks, avoid unnecessary zeroing,
	do not copy shared tuples, revise error exit paths.

2024-05-26  Alexei Podtelezhnikov  <apodtele@gmail.com>

	Whitespace.

2024-05-24  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/truetype/ttgxvar.c (ft_var_apply_tuple): Reduce checks.

2024-05-24  Alexei Podtelezhnikov  <apodtele@gmail.com>

	Revert "[truetype] Reduce allocation scope."

	This reverts commit 9ff4153cbfd60491f11bb56905ce6e20e94d23c7.

2024-05-23  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[truetype] Reduce allocation scope.

	* src/truetype/ttgxvar.c (TT_Vary_Apply_Glyph_Deltas): Reduce scope
	of `points_org` and 'points_out`.

2024-05-23  Alexei Podtelezhnikov (Алексей Подтележников)  <apodtele@gmail.com>

	* .gitlab-ci.yml: Disable UWP compilation.

2024-05-23  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* include/freetype/internal/ftmemory.h (FT_MEM_DUP): Fix g++ error.

2024-05-21  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[cff, truetype] Validate variation axes immediately.

	Instead of validating variation axes in every access, OpenType specs
	suggest that peak = 0 be used to tag invalid ranges.  This implements
	just that once during loading.

	* src/cff/cffload.c (cff_blend_build_vector): Move the range checks...
	(cff_vstore_load): ... here.
	* src/truetype/ttgxvar.c (tt_var_get_item_delta): Ditto...
	(tt_var_load_item_variation_store): ... ditto.

2024-05-21  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[cff, truetype] Rearrange variation range checks.

	

	This should achieve quicker results for common cases.

	

	* src/cff/cffload.c (cff_blend_build_vector): Rearrange conditionals.

	* src/truetype/ttgxvar.c (tt_var_get_item_delta): Ditto.

2024-05-21  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/truetype/ttgxvar.c (tt_var_get_item_delta): Align with specs.

2024-05-21  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/truetype/ttgxvar.c (tt_var_get_item_delta): Minor refactoring.

2024-05-21  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[cff] Optimize the blend vector computations.

	* src/cff/cffload.c (cff_blend_build_vector): Use FT_MulDiv and skip
	multiplying by 1.

2024-05-20  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[bdf] Use concise macros.

	* src/bdf/bdflib.c (bdf_create_property): Use FT_STRDUP.
	(bdf_parse_glyphs_, bdf_parse_start_): Use FT_DUP for brevity.

2024-05-20  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[cache] Use FT_DUP to duplicate data.

	* src/cache/ftcsbits.c (ftc_sbit_copy_bitmap): Use concise FT_MEM_DUP.

2024-05-20  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[truetype, type1] Use FT_DUP to duplicate data.

	* src/truetype/ttgload.c (TT_Load_Simple_Glyph): Use concise FT_DUP.
	* src/truetype/ttgxvar.c (TT_Get_MM_Var): Ditto.
	* src/type1/t1load.c (parse_subrs): Ditto.

2024-05-18  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* builds/windows/ftsystem.c: Use _WINRT_DLL to check for UWP.

	Fixes compilation using Windows GDK, reported by Erin Melucci.

2024-05-13  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* include/freetype/ftmm.h: Include `freetype.h`.

	Reported by Ben Wagner, see !326.

2024-05-13  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[type1/MM] Safer handle arrays of different types.

	* src/type1/t1load.c (parse_blend_design_map): Separately allocate...
	(T1_Done_Blend): ... and free `design_points` and `blend_points`.

2024-05-12  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/type1/t1load.c (parse_blend_design_map): Add risky cast.

2024-05-12  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* docs/CHANGES: Mention the last commit.

2024-05-12  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[type1/MM] Tighten headers.

	* include/freetype/internal/t1types.h: Host PS_DesignMap and PS_Blend.
	* include/freetype/ftmm.h: Host and document TT_MAX_MM_XXX.
	* include/freetype/t1tables.h: Remove them from here.

2024-05-11  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/pshinter/pshrec.c (ps_hints_stem): Correct argument.

2024-05-08  Ben Wagner  <bungeman@chromium.org>

	[psaux] Fix location and type order in initializer

	`T1_FIELD_ZERO` is used to zero initialize a `T1_FieldRec`.
	`T1_FIELD_ZERO` is currently initilizing `T1_FieldRec::location` with a
	`T1_FieldType` and `T1_FieldRec::type` with a `T1_FieldLocation`. This
	was detected with `-Wenum-conversion`.

	* include/freetype/internal/psaux.h (T1_FIELD_ZERO): correct order of
	initalizers

2024-05-08  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* include/freetype/internal/psaux.h: Fix g++ warning.

	Reported by Hin-Tak Leung.

2024-05-08  Ben Wagner  <bungeman@chromium.org>

	[colr] Avoid overflow in range checks

	In 32 bit builds `FT_ULong` is 32 bits and can silently overflow when a
	large number is read into one and then it is summed or multiplied with
	another number.  Checks for range overflow must be written so that they
	themselves do not overflow.  Also ensure that the table_size is always the
	first part of the range check and consistently use `<` or `<=`.

	* src/sfnt/ttcolr.c (tt_face_load_colr): Avoid overflow.
	(find_base_glyph_v1_record): Remove old work-around.

	Bug: https://issues.chromium.org/issues/41495455
	Bug: https://issues.chromium.org/issues/40945818

2024-05-06  Werner Lemberg  <wl@gnu.org>

	.mailmap: Fix entry for Ben Wagner.

2024-05-06  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[sdf, bsdf] Use shared FT_SqrtFixed.

	

	FT_SqrtFixed (95b0fe2a6dff) is faster and does not overflow.

	

	* src/sdf/ftsdfcommin.h (square_root): Replace with a macro.

	* src/sdf/ftsdfcommin.c (square_root): Remove function.


2024-05-04  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/autofit/aflatin.c (af_latin_metrics_scale_dim): Remove FT_ABS.

	See
	    https://bugs.chromium.org/p/oss-fuzz/issues/detail?id=68679

2024-05-03  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/sfnt/sfwoff2.c (woff2_open_font): Fix copy-paste typo.

2024-05-03  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[woff,woff2] Limit the number of tables and use FT_MSB.

	

	The upper limit of 4095 is implied by the SFNT header format

	where the multiplication by 16 would overflow without it.

	

	* src/sfnt/sfwoff.c (woff_open_font): Updated.

	* src/sfnt/sfwoff2.c (woff2_open_font): Ditto.


2024-05-02  Ben Wanger  <bungeman@gmail.com>

	[woff2] Disallow zero table font entries

	The existing code already disallows zero table woff2 overall, but still
	allows for individual CollectionFontEntry to create font instances with
	zero tables. Such fonts are not useful so error early.

	This also fixes an MSAN discovered issue where if a CollectionFontEntry
	numTables is zero then the sfnt_header was not fully initialized.

	* src/sfnt/sfwoff2.c (woff2_open_font): error on zero tables, always
	initalize sfnt_header

	Fixes: https://bugs.chromium.org/p/oss-fuzz/issues/detail?id=68384

2024-05-02  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[sfnt] Use faster macros in checksums.

	* src/truetype/ttobjs.c (tt_synth_sfnt_checksum): Use FT_NEXT_XXX.
	* src/sfnt/sfwoff2.c (compute_ULong_sum): Use macros.

2024-05-01  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/sfnt/sfwoff2.c (compute_ULong_sum): Clean up.

2024-04-30  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* docs/CHANGES: Updated.

2024-04-30  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/cache/ftccache.c (FTC_Cache_RemoveFaceID): Remove nodes instantly.

2024-04-29  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[cache] Remove unused `node_reset`.

	* src/cache/ftcmru.h (FTC_MruListClassRec): Remove `node_reset` field.
	* src/cache/ftcbasic.c (ftc_basic_{image,sbit}_family_class): Ditto.
	* src/cache/ftcmanag.c (ftc_face_list_class): Ditto.
	(ftc_size_node_reset): Remove function.
	* src/cache/ftcglyph.h: Fix comment.

2024-04-29  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/cache/ftcmru.c (FTC_MruList_New): Do not reset nodes.

	Resetting of the size nodes can crash, if a parent face purge happens
	simultaneously and destroys the node. It is safer to create a new node.
	Fixes #1270, reopened with a separate issue.

2024-04-28  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/cache/ftcimage.c (ftc_inode_weight): Formatting.

2024-04-28  Alexei Podtelezhnikov  <apodtele@gmail.com>

	Document the SDF spread further.

2024-04-23  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* include/freetype/ftdriver.h: s/truncated/clamped/.

2024-04-23  Alexei Podtelezhnikov  <apodtele@gmail.com>

	Improve SDF documentation.

2024-04-21  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[cache] Minor tweaks.

	* src/cache/ftcimage.c (ftc_inode_free): Remove unnecessary check.
	* src/cache/ftcmanag.c (FTC_Manager_Done): Do not zero before freeing.

2024-04-21  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/cache/ftcbasic.c: Cosmetic harmonization.

2024-04-20  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[cache] Reduce type mismatches.

	* src/cache/ftcbasic.c (FTC_BasicAttrRec): Match type of `load_flags`
	to its main purpose in `FT_Load_Glyph`.
	(FTC_ImageCache_Lookup{,Scaler},FTC_SBitCache_Lookup{,Scaler}): Updated.

2024-04-19  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/cache/{ftcbasic.c,ftccmap.c}: Use FTC_INLINE.

2024-04-19  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[cache] Tweak headers.

	* src/cache/ftccback.h: Include less and move `ftc_node_destroy`...
	* src/cache/ftccache.h: ... to here.
	* src/cache/ftcmanag.c: Include less.

2024-04-19  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/cache/ftcglyph.c [!FTC_INLINE]: Fix compilation.

2024-04-17  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[cache] Improve MRU list management.

	

	* src/cache/ftcmru.c (FTC_MruList_Remove): Cosmetic.

	(FTC_MruList_New): Accept only valid changes.

	* src/cache/ftcmanag.c (ftc_size_node_done):  Simplify.


2024-04-17  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[cache] Fix error handling.

	Manipulate the cache after a face is requested or a size is looked up
	successfully. Fixes #1270.

	* src/cache/ftcmanag.c (ftc_size_node_init, ftc_size_node_reset,
	ftc_face_node_init): Check for errors before accepting a change.
	* src/cache/ftcmru.c (FTC_MruList_New): Do nothing if reset fails.

2024-04-14  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[smooth] Switch to vertical bisections.

	With horizontal bisections, the smallest section is a whole single
	scanline. Almost horizontal lines or other complex scanlines can
	easily overflow the rendering pool. Switching to vertical bisections
	splits the scanlines and should rule out the overflows.  Fixes #1269.

	* src/smooth/ftgrays.c (gray_convert_glyph): Bisect vertically.

2024-04-14  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/smooth/ftgrays.c (gray_convert_glyph): Refactor for convenience.

2024-04-14  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[smooth] Store persistent clipping box.

	* src/smooth/ftgrays.c (gray_TWorker, gray_raster_render): Add and set
	the new structure field.
	(gray_convert_glyph): Use it.

2024-03-08  Ben Wanger  <bungeman@gmail.com>

	[colr] Ensure enough bytes for PaintColrLayers

	* src/sfnt/ttcolr.c (read_paint): check that there are five additional
	bytes to be read when reading PaintColrLayers.

	Reported as

	  https://bugs.chromium.org/p/oss-fuzz/issues/detail?id=66566

2024-03-08  Ben Wagner  <bungeman@gmail.com>

	Avoid n^2 scanning for binary data.

	When creating a CID parser the location of the 'StartData' or '/sfnts'
	tokens needs to be known.  However, the token parser requires that the
	entire document be in memory and flattening the entire stream into memory is
	to be avoided.

	To avoid forcing the entire stream into memory, previously this code would
	scan through the stream looking for 'StartData' or '/sfnts' as strings.
	However, these strings could have been in a comment or string token, so the
	stream would be read into memory up to that point and the parser run to
	check that these strings were actually tokens.  This forced a parser restart
	from the beginning each time; as a result, data with many 'StartData'
	non-tokens would take n^2 time to check.

	* src/cid/cidparse.c (cid_parser_new): Change algorithm to make the initial
	scan look for the last possible 'StartData' or '/sfnts' string in the
	stream.  The stream is read forward instead of backward as a typical normal
	CID font will have one 'StartData' toward the beginning of the data and it
	it much faster to read the data from beginning to end instead of end to
	beginning.  For memory-based fonts the limit is set to the end of the stream
	since the stream is already in memory.  Then the parser is run once to look
	for 'StartData' or '/sfnts' tokens.  If they are found the parser is re-set
	to reflect this new information.

	Reported as

	  https://issues.chromium.org/issues/40201695

2024-03-06  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* CMakeLists.txt: Bump required version to 3.5.

	

	Fixes #1267.

2024-03-04  Jordan Williams  <jordan@jwillikers.com>

	meson: Use the standard dependency mechanism to find bzip2

	This follows standard conventions in Meson by using the pkg-config file.
	This change allows Conan to switch to the Meson build system.

2024-02-29  Ben Wanger  <bungeman@gmail.com>

	[cff, truetype] Always set up default variable instance.

	For default variable instances `cff_face_init` did not set the blend.  This
	mostly worked as later use of the unset blend produced the default
	variation.  However, if a user called `TT_Get_MM_Var` the blend would be
	partially set up, but not fully.  In particular the number of axes, the axis
	definitions, and the instance locations would be set up, but not the current
	instance location (`coords` and `normalizedcoords`).  This could lead to the
	default instances of CFF2 fonts erroring on any use of `blend`.

	Ensure the default variable instance is fully set up by always calling
	`FT_Set_Named_Instance` on a variable face.

	* src/cff/cffobjs.c (cff_face_init): Call `FT_Set_Named_Instance` on
	default instances.
	* src/truetype/ttobjs.c (tt_face_init): Ditto.

	Fixes #1268.

2024-02-23  Werner Lemberg  <wl@gnu.org>

	* src/truetype/ttgxvar.c (ft_var_to_normalized): Integer overflow.

	Reported as

	  https://bugs.chromium.org/p/oss-fuzz/issues/detail?id=66543

2024-01-27  Alexei Podtelezhnikov  <apodtele@gmail.com>

	Update all copyright notices.

2024-01-27  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/sfnt/ttgpos.c (tt_gpos_get_glyph_class): Fix warning C4018.

2024-01-27  David Saltzman  <davidbsaltzman@gmail.com>

	Add support for kerning from 'GPOS' tables.

	This commit adds support for kerning from 'GPOS' tables, while maintaining
	support for basic 'kern' tables.  `FT_HAS_KERNING` will be true for a font
	with either available and `FT_Get_Kerning` will still use the basic 'kern'
	table data if avilable, otherwise check the GPOS 'kern' feature.

	This feature is disabled by default; it can be enabled with the
	`TT_CONFIG_OPTION_GPOS_KERNING` flag.

	Only basic kerning (pair positioning with just an x advance) is supported
	from the GPOS layout features; support for that was added to make the
	existing `FT_Get_Kerning` API more consistently functional.  FreeType does
	not intend to extend itself to further GPOS functionality though; a
	higher-level library like HarfBuzz can be used instead for that.

	* include/freetype/config/ftoption.h, include/devel/ftoption.h
	(TT_CONFIG_OPTION_GPOS_KERNING): New configuration option.

	* include/freetype/internal/fttrace.h: Add `ttgpos` trace handler.

	* include/freetype/internal/sfnt.h (SFNT_Interface): Add `load_gpos` and
	`get_gpos_kerning` fields.
	(FT_DEFINE_SFNT_INTERFACE): Updated.

	* include/freetype/internal/tttypes.h: Include `fttypes.h`.
	(TT_FaceRec) [TT_CONFIG_OPTION_GPOS_KERNING]: Add `gpos_table` and
	`gpos_kerning_available` fields.

	* src/sfnt/ttgpos.c, src/sfnt/ttgpos.h: New files.

	* src/sfnt/sfdriver.c [TT_CONFIG_OPTION_GPOS_KERNING]: Include `ttgpos.h`.
	(sfnt_interface): Updated.

	* src/sfnt/sfnt.c: Include `ttgpos.c`.

	* src/sfnt/sfobjs.c [TT_CONFIG_OPTION_GPOS_KERNING]: Include `ttgpos.h`.
	(sfnt_load_face) [TT_CONFIG_OPTION_GPOS_KERNING]: Load and free GPOS kerning
	data; check GPOS kerning availability.

	* src/truetype/ttdriver.c (tt_get_kerning): Use GPOS kerning if there's no
	'kern' table.

2024-01-14  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[smooth] Remove SSE2.

	As a result of 7b308a29dd10, the regular 64-bit execution is now faster
	than SSE2. The rendering speed of script fonts at 64 ppem or larger is
	improved by about 3% without SSE2. See !314 for the testing results.

	* src/smooth/ftgrays.c (gray_render_conic)[FT_INT64]: Remove SSE2 code.

2024-01-14  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* CMakeLists.txt: Accommodate MingGW.

	See https://github.com/StephanTLavavej/mingw-distro/issues/97.

2024-01-08  Ozkan Sezer  <sezeroz@gmail.com>

	* src/sfnt/ttcolr.c (find_base_glyph_v1_record): Fix build in C90 mode.

2024-01-07  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[base] Fix up Mac resource forks and dfonts.

	* src/base/ftobjs.c (IsMacResource): Assign `face_index`.
	* src/base/ftmac.c (FT_New_Face_From_Suitcase): Ditto after rework.

2024-01-05  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[sfnt] Restrict POST version 1.0.

	A font has surfaced with `post` version 1.0 and fewer than 258 glyphs.
	Its glyphs did not correspond to their names. We now reject such `post`
	strictly following specifications.

	* src/sfnt/ttpost.c (tt_face_get_ps_name): Check the number of glyphs
	for version 1.0.

2024-01-03  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* .gitlab-ci.yml: Use detached CI pipelines.

	

	See issue freedesktop/freedesktop#540.

2024-01-02  Werner Lemberg  <wl@gnu.org>

	[sfnt] Guard access in 'COLR' v1 glyph binary search.

	Reported as

	  https://bugs.chromium.org/p/chromium/issues/detail?id=1505216

	* src/sfnt/ttcolr.c (find_base_glyph_v1_record): Guard access of the search
	pointer during binary search.  The pointer needs to be checked as we go as
	the test that compares number of v1 glyphs with table size at the time of
	loading the table is not sufficient on its own.

	A scenario is possible in which the `BaseGlyphRecord` list extends into
	non-`BaseGlyphRecord` parts of the 'COLR' v1 table (but passed the size
	comparison check).  Then, at those locations, invalid glyph ID values are
	read and may provoke an invalid read due to reassigning min and max values
	during the binary search.

2023-12-18  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[ci] Add support for MSBuild on Windows.

	This adds msbuild job for VS2019 (x64).

	* .gitlab-ci.yml: Added "windows msbuild vs2019 amd64".

2023-12-14  Skef Iterum  <github@skef.org>

	[CFF] Extract `BlueValues` as `Fixed` rather than `Int`.

	This is a follow-up to commit 26a7f047,

	  [cff] Make blend operator work with floats in private dicts.

	which addressed the 'party baseline' bug.  However, the reporting user
	indicated that the default location and some other points in design space
	rendered OK, but other points in design space still had problems.  The most
	obvious issue being that the x-heights of lower-case letters did not align;
	see

	  https://github.com/adobe-fonts/source-serif/issues/121#issuecomment-1773794136

	After some analysis we determined that this was due to an interaction
	between `BlueValue` rounding and the zone-based algorithm.  In short, for a
	point to be considered in a zone it must fall within the bounds of the zone.
	(There is a slop factor in some cases, but only a very small one.)  In the
	Adobe-contributed side of the code, point values are not integer-rounded,
	instead they're kept as (some form of) fixed.  Rounding just the `BlueValues`
	means that points that need to be considered within a zone will fall outside
	of it at some points in design space.

	The majority of this patch changes the storage and parsing of `BlueValues`
	to keep them as `FT_Fixed`.  No significant code changes were needed because
	the values are converted to `Fixed` anyway when stored in `CF_BlueRec`.  No
	attempt was made to address problems in the older pshinter code beyond
	converting the values from `FT_Fixed` to `FT_Short` when copying the private
	dictionary.  (However, as the point values are also rounded in that code,
	the problem is much less likely to occur, although inconsistency between
	rounding and truncation could cause an analogous problem.)

	* include/freetype/internal/cfftypes.h (CFF_PrivateRec): Use `FT_Fixed` for
	`blue_values`, `other_blues`, `family_blues`, and `family_other_blues`.

	* src/cff/cffload.c (cff_blend_doBlend): Updated.

	* src/cff/cffobjs.c (CFF_fixedToInt): New macro.
	(cff_make_private_dict): Use it.

	* src/cff/cffparse.h (cff_kind_delta_fixed): New enum value.

	* src/cff/cffparse.c (do_fixed): Updated.
	(CFF_FIELD_DELTA, CFF_FIELD_DELTA_FIXED, CFF_DELTA_KIND): New set of macros,
	replacing `CFF_FIELD_DELTA`.
	(cff_parser_run): Updated to handle fixed-float deltas.

	* src/cff/cfftoken.h: Updated to use `CFF_FIELD_DELTA_FIXED` for blue
	values.

	* src/psaux/psblues.c (cf2_blueToFixed): Removed, no longer needed.
	(cf2_blues_init): Updated.

	* src/pxaux/psft.c, src/pxaux/psft.h (cf2_getBlueValues, cf2_getOtherBlues,
	cf2_getFamilyBlues, cf2_getFamilyOtherBlues): Updated signatures.

	* src/psaux/psobjs.c (t1_make_subfont): Updated.

2023-12-14  Skef Iterum  <github@skef.org>

	[psaux] Improve tracing.

	* src/psaux/psintrp.c (cf2_doBlend, cf2_interpT2CharString [cf2_cmdBLEND]):
	Show blended values.

2023-12-14  Jouk Jansen  <joukj@hrem.nano.tudelft.nl>

	* vms_make.com: Switch to `clang`.

	Also add proper bzip2 support.

2023-12-14  Werner Lemberg  <wl@gnu.org>

	* src/truetype/ttgxvar.c (ft_var_to_normalized): Fix undefined left-shift.

	Reported as

	  https://bugs.chromium.org/p/oss-fuzz/issues/detail?id=63723

2023-12-07  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[msbuild] Streamline the process.

	MSBuild.exe can now be fired from the root folder without options.

	* builds/windows/vc2010/freetype.sln: Relocated to...
	* MSBuild.sln: ... here with minor changes.
	* MSBuild.rsp: New file with command line options.
	* docs/INSTALL: Reference `MSBuild.sln`.

2023-12-02  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/raster/ftraster.c (Draw_Sweep): Swap stub conditions.

2023-12-02  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/raster/ftmisc.h (FT_MulDiv): Remove unused copy.

2023-11-28  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[raster] Speed up Bézier arches with extrema.

	While it is recommended to have an explicit point at each curve
	extrema, they might be missing or outline could be rotated. This
	leads to excessive bisections in raster to find them.  This change
	helps to decrease the number of bisections.  The scanline
	intersections remain monotonous, of course.

	* src/raster/ftraster.c (Conic_To, Cubic_To): Check that control
	points cross the scanlines to bisect.

2023-11-25  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* docs/*: Typos.

2023-11-24  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[raster] Eliminate intensive flow checking.

	* src/raster/ftraster.c (Draw_Sweep): Pass the flow increment.
	(Increment): Accept the flow increment.

2023-11-23  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/raster/ftraster.c: Comments, defines, includes, cleanups.

2023-11-21  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/raster/ftraster.c (FT_Outline_Get_CBox ) [STANDALONE_]: Removed.

2023-11-21  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/raster/ftraster.c (Draw_Sweep): No-fault return.

	(Render_Single_Pass): Updated.

2023-11-21  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[raster] Sweep polishing.

	

	* src/raster/ftraster.c (*_Sweep_Span): Polish.

	(*_Sweep_Drop): Restore tracing, polish.

	(Draw_Sweep): Simplify the dropout processing loop.

2023-11-21  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[raster] Rearrange dropout control.

	This reduces the code duplication.

	* src/raster/ftraster.c (Function_Sweep_Span): Change signature.
	(Vertical_Sweep_Drop, Horizontal_Sweep_Drop): Focus on pixel setting
	and move duplicated the dropout control logic to...
	(Draw_Sweep): ... this function and refactor.
	(Vertical_Sweep_Span, Horizontal_Sweep_Span): Minor.

2023-11-21  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[raster] Use bitwise dropout mode interpretation.

	* src/raster/ftraster.c (Vertical_Sweep_Drop, Horizontal_Sweep_Drop,
	Draw_Sweep, Render_GLyph): Interpret dropout mode using bit masks.

2023-11-16  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* docs/CHANGES: Updated.

2023-11-16  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[raster] Keep only bottom y-turns.

	This results in noticeable performance improvement.

	* src/raster/ftraster.c (Insert_Y_Turns): All bottom y-turns are still
	sorted and stored; only the maximum top y-turn is recorded now. The
	function is renamed.
	(End_Profile): Updated accordingly.
	(Convert_Glyph): Reserve space for the top value.

2023-11-15  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/raster/ftraster.c (End_Profile): Reduce branching.

	(InsNew): Tweak condition.

2023-11-15  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/raster/ftraster.c (Draw_Sweep): Use more natural loop.

2023-11-15  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[raster] Dissolve a loop.

	* src/raster/ftraster.c (End_Profile): Set initial `X` here...
	(Draw_Sweep): ... instead of here; delay the `start` decrement.

2023-11-15  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/raster/ftraster.c: Comments.

2023-11-14  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[raster] Stylistic changes.

	

	* src/raster/ftraster.c (Line_To): Code it similar to curves;

	shortcut the flat lines here...

	(Line_Up): ... instead of here.

2023-11-14  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[raster] Revise overshoot setting.

	

	* src/raster/ftraster.c (New_Profile, End_Profile): Deal with overshoots

	locally.

	(Line_To, Conic_To, Cubic_To): Update callers.

2023-11-14  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/raster/ftraster.c (Conic_To, Cubic_To): Fix recent regression.

2023-11-14  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* include/freetype/ftimage.h: Fix type and link.

2023-11-14  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/raster/ftraster.c (Increment): Minor tweak.

2023-11-13  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[raster] Get rid of the fresh flag.

	* src/raster/ftraster.c (black_TWorker): Remove the fresh flag.
	(New_Profile): Set the starting scanline here based on the current
	coordinate and initialize the joint crossing if necessary.
	(Line_Up, Bezier_Up): Do not deal with fresh and joint starts at all.
	(Line_Down, Bezier_Down): Simplify.
	(Conic_To, Cubic_To): Update the current coordinate after each
	subsection.

2023-11-12  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[raster] Get rid of the joint flag.

	* src/raster/ftraster.c (Line_Up, Bezier_Up): Deal with the scanline
	joints directly based on the initial y-coordinate.
	(New_Profile, black_TWorker): Remove the boolean flag.

2023-11-11  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/raster/ftraster.c (Line_Up, Bezier_Up): Check "between" earlier.

2023-11-11  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/raster/ftraster.c (Line_Up): Updated and fixed up.

	This largely synchronizes the entries into `Line_Up` and `Bezier_Up`.
	Minor bugs in the remainder calculations and accumulations are fixed.

2023-11-10  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/raster/ftraster.c (End_Profile, Convert_Glyph): Clean up.

2023-11-10  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/raster/ftraster.c (Bezier_Up): Improve joint and loop.

2023-11-07  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[raster] Harmonize target bitmap navigation.

	* src/raster/ftraster.c (black_TWorker): Store signed maximum indexes
	in both directions instead of unsigned dimensions of the original bitmap.
	(*_Sweep_*, Render_Glyph, ft_black_render): Updated all users.

2023-11-06  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/raster/ftraster.c (Bezier_Up): Improve flow.

2023-11-06  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[raster] Reshuffle code for readability.

	* src/raster/ftraster.c (Render_Glyph): Setup the rendering pool here.
	(ft_black_render): Setup the target bitmap helpers here.

2023-11-04  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[raster] Improve profile accounting during sweeping.

	* src/raster/ftraster.c (TProfile): Get rid of `countL`.
	(Draw_Sweep): Use `start` for countdown to activation.
	(Horizontal_Sweep_Drop, Vertical_Sweep_Drop): Rely on `height` and
	`offset` to verify profile ends for the stub detection.

2023-11-04  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[raster] Consolidate profile increment to the next line.

	* src/raster/ftraster.c (s/Sort/Increment): Rename this function to
	reflect its true purpose, delete exhausted profiles here...
	(Draw_Sweep): ... instead of here.

2023-11-04  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[raster] Instantly remove profiles from linked lists.

	* src/raster/ftraster.c (DelOld): Remove loopy function.
	(Draw_Sweep): Implement instant profile removal.

2023-11-03  Alexei Podtelezhnikov (Алексей Подтележников)  <apodtele@gmail.com>

	[raster] Modify the split condition.

	While curving close to a pixel center, vertical and horizontal pass
	might split the curve differently and cause a rare dropout.  This
	makes the split condition invariant of the sweep direction and more
	robust.

	* src/raster/ftraster.c (Bezier_Up): Modify the split condition.

2023-11-03  Alexei Podtelezhnikov (Алексей Подтележников)  <apodtele@gmail.com>

	[raster] Remove the jitter exception.

	The jitter exception used to be applied when two neighboring pixels
	were barely inside the outline. One the left one was turned on then,
	which contradicts the OpenType specifications.  Intended to remove
	glitches, it caused disappearing lines and was softened by adding an
	exception to the exception (#54589).

	* src/raster/ftraster.c (Vertical_Sweep_Span): Drop the jitter exception.

2023-10-31  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[raster] Simplify dropout detection.

	

	* src/raster/ftrater.c (Draw_Sweep): Use a single dropout condition.

2023-10-31  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[raster] Simplify sweeping entry and exit.

	* src/raster/ftraster.c (Draw_Sweep): Use y-turns to set the range,
	correctly set the initial position, directly loop through y_turns,
	and remove a 5-gray remnant at exit.

2023-10-26  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[raster] Switch to routine Int instead of Short.

	This is mostly cosmetic and removes a few casts, plus Short is
	promoted to Int in calculations anyway.

	* src/raster/ftraster.c (Vertical_Sweep_Init, Vertical_Sweep_Span,
	Vertical_Sweep_Drop, Horizontal_Sweep_Init, Horizontal_Sweep_Span,
	Horizontal_Sweep_Drop, Draw_Sweep): Mostly s/Short/Int/ and remove
	casting.

2023-10-24  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[raster] Increase the raster pool density.

	This only helps to delay the pool overflow and bisections to larger
	sizes and benefits only very intricate glyphs at reasonable sizes.

	* src/raster/ftraster.c (TProfile): Use Int instead of Long or PLong
	when it is sufficient.
	(New_Profile, End_Profuile, Bezier_Up, Sort): Updated accordingly.

2023-10-23  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[raster] Slightly improve the pool design.

	* src/raster/ftraster.c (TProfile): Include the variable array member
	and repackage with pointers first.
	(New_Profile): Advance the top using the variable array pointer.

2023-10-22  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[raster] Clean up sweeping.

	* src/raster/ftraster.c (Draw_Sweep): Zero initialize the working
	lists directly and remove unnecessary y-turn checks.
	(Init_Linked): Removed.

2023-10-22  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/raster/ftraster.c (Insert_Y_Turn): Improve flow.

2023-10-22  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/pcf/pcfutil.c (BSWAP16): Limit clang support.

	These ancient builtins have been supported by clang since 2013. We
	condition it somewhat stricter but still around 2017.  This is more
	portable than `__has_builtin`. Fixes #1260.

2023-10-19  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[raster] Small optimizations.

	* src/raster/ftraster.c (New_Profile): Set important fields only and
	delay setting `gProfile` until...
	(End_Profile): ... it is checked to be valid here.
	(Convert_Glyph): Updated.

2023-10-18  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/raster/ftraster.c (Convert_Glyph): Remove redundant check.

2023-10-18  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[raster] Fix linked profiles in contour loops.

	This fixes a subtle bug when the last profile in a contour was not
	properly short-circuited if it was still empty at `End_Profile`.
	We finalize all linking in `Finalize_Profile_List` now and do nothing
	else there.  The turns are added in `End_Profile`.

	* src/raster/ftraster.c (Insert_Y_Turn): Moved up unchanged.
	(End_Profile): Take care of turns but set only preliminary linking.
	(Finalize_Profile_Table): Take care of linking and null-termination.
	(Convert_Glyph): Adjusted accordingly.

2023-10-15  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/raster/ftraster.c: Improve tracing.

2023-10-13  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[raster] Improve profile accounting.

	

	* src/raster/ftraster.c (End_Profile): Do not initiate next profile.

	(New_Profile): Fully initiate new profile.

	(Convert_Glyph): Clean up variables, initialize `fProfile` here.

2023-10-13  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/raster/ftraster.c (Convert_Glyph): Fix null-dereference.

2023-10-13  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[raster] Fix pool overflow checking.

	* src/raster/ftraster.c (New_Profile, End_Profile): Check for overflow
	immediately.
	(Convert_Glyph, Render_Single_Pass): Fix boundaries.

2023-10-13  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[raster] Miscellaneous clean-ups.

	* src/raster/ftraster.c (New_Profile): Use NULL.
	(End_Profile): Optimize variables.
	(Convert_Glyph): Do not initialize `cProfile` yet.
	(Render_Single_Pass): Tracing.

2023-10-10  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/smooth/ftgrays.c: Move the sweep functions...

	... out of the setjmp/longjmp scope for readability.

2023-10-10  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/raster/ftraster.c: Tracing updates.

2023-10-09  Zachary Zollman  <zacharyzollman@pm.me>

	fix typo in FT_Outline_Decompose note

2023-09-29  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/smooth/ftgrays.c (gray_render_conic) [SSE2]: Improve flow.

2023-09-26  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/gxvalid/gxvcommn.h (GXV_USHORT_TO_SHORT): Removed.

2023-09-25  Alexei Podtelezhnikov  <apodtele@gmail.com>

	Comment typos.

2023-09-25  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/base/ftcalc.c (FT_MOVE_SIGN): Enclose assignments.

2023-09-21  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* include/freetype/internal/ftcalc.h (FT_MSB): Define for Solaris 11.

2023-09-20  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[psaux] Use `FT_SqrtFixed`.

	* src/psaux/cffdecode.c <cff_op_sqrt>: Call `FT_SqrtFixed`.
	* src/psaux/psintrp.c <cf2_escSQRT>: Ditto.

2023-09-20  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[base] Reintroduce `FT_SqrtFixed`.

	The general square root calculations are not necessary in FreeType.
	For vector normalization or length, FreeType uses special functions.
	It is, however, required in the legacy CFF specifications.

	* src/base/ftcalc.c (FT_SqrtFixed): New function that uses either
	Babylonian or bit-wise algorithm, whichever is faster for the given
	situation.
	* include/freetype/internal/ftcalc.h (FT_SqrtFixed): Declare it.

2023-09-18  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/base/ftcalc.c /* FT_SqrtFixed */: Fix defunct overflow.

2023-09-14  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/tools/apinames.c (read_header_file): Typos.

2023-09-13  Alexei Podtelezhnikov  <apodtele@gmail.com>

	Update 2 files

	- /src/base/ftcalc.c
	- /include/freetype/internal/ftcalc.h

2023-09-13  Ben Wagner  <bungeman@chromium.org>

	[base] Fix typo to correct predicate for call

	* src/base/ftobj.c (FT_Get_Color_Glyph_Paint): check
	`get_colr_glyph_paint` before calling `get_colr_glyph_paint` and not
	`get_colr_layer`

2023-09-12  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/psaux/cffdecode.c (cff_op_sqrt): Correct upper limit.

2023-09-11  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/psaux/cffdecode.c (cff_op_sqrt): Improve initial guess.

2023-09-11  Alexei Podtelezhnikov  <apodtele@gmail.com>

	src/psaux/psintrp.c (cf2_escSQRT): Improve initial guess.

	

	The worst number of iterations decreased from 11 to 5.

2023-09-11  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/type1/t1afm.c (t1_get_index): Restore `strlen` call.

	This reverts commit 8ed6d97446f2f3e5523da62eefbbf32ef7c1290e
	and fixes
	   https://bugs.chromium.org/p/oss-fuzz/issues/detail?id=62246

2023-09-10  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/cff/cffparse.c (CFF_Field_Handler): Some s/0/NULL/.

2023-09-10  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[type1, cid, type42] Post-cleanup.

	* include/freetype/internal/psaux.h (T1_FIELD_ZERO): Terminating macro.
	* src/cid/cidload.c (cid_parse_dict): Use while-loop.
	* src/type1/t1load.c (parse_dict): Ditto.
	* src/type42/t42parse.c (t42_parse_dict): Ditto.

2023-09-09  Alexei Podtelezhnikov  <apodtele@gmail.com>

	Update forgotten array termini.

	* src/cid/cidload.c (cid_field_records): Account for added `len`.
	* src/type1/t1load.c (t1_keywords): Ditto.
	* src/type42/t42parse.c (t42_keywords): Ditto.

2023-09-09  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[type1, cid, type42] Streamline dictionary parsing.

	When matching the keywords, we avoid calculating their lengths by
	checking the stored values. This itself is a sufficient pre-check
	before diving into `memcmp`. Therefore, we remove explicit check of
	the first characters.

	* include/freetype/internal/psaux.h (T1_FieldRec): Store length.
	* src/cid/cidload.c (cid_parse_dict): Use `memcmp` and stored length.
	* src/type1/t1load.c (parse_dict): Ditto.
	* src/type42/t42parse.c (t42_parse_dict): Ditto.

2023-09-09  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/type1/t1afm.c (t1_get_index): Avoid `strlen` call.

	Instead, we check the terminal zero.

2023-09-08  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/type1/t1driver.c (t1_ps_get_font_value): Avoid redundant null.

2023-09-08  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[cff, truetype] Improve prefix and suffix removal.

	* src/cff/cffobjs.c (remove_style): Rewrite using pointers.
	(remove_subset_prefix): Unwrap loop and use `memmove`.
	* src/truetype/ttobjs.c (tt_skip_pdffont_random_tag): Unwrap loop
	and avoid `strlen`.

2023-09-07  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/sfnt/ttpost.c (load_format_20): Micro-optimize.

2023-09-05  Werner Lemberg  <wl@gnu.org>

	[autofit] Fix synchronization mistake between FreeType and ttfautohint.

	Found by Behdad.

	* src/autofit/aflatin.c (af_latin_metrics_init_blues): Fix array size of
	`blue_sorted`: FreeType doesn't have artificial blue zones.

2023-09-04  Werner Lemberg  <wl@gnu.org>

	[autofit] Fix typos.

	This also reduces the used heap size by a large factor.

	From Behdad.

	* src/autofit/afcjk.h (AF_CJKAxisRec): Use `AF_BLUE_STRINGSET_MAX_LEN`.
	* src/autofit/aflatin.h (AF_LatinAxisRec): Ditto.

2023-08-31  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/sfnt/ttpost.c (load_format_20): Rework tracing.

2023-08-30  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[builds] Abbreviate the DLG submodule update.

	* autogen.sh, builds/toplevel.mk: Revise the command options.

2023-08-29  Alexei Podtelezhnikov  <apodtele@gmail.com>

	Comment added.

2023-08-29  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/sfnt/ttpost.c (load_format_20): Permit long names.

	

	Fixes #1254.

2023-08-27  Werner Lemberg  <wl@gnu.org>

	[gzip] Update sources to zlib 1.13.

2023-08-25  Werner Lemberg  <wl@gnu.org>

	docs/release: Minor fixes.

2023-08-25  Anurag Thakur  <anuthadev@gmail.com>

	docs/freetype-web.txt: New file.

2023-08-25  Werner Lemberg  <wl@gnu.org>

	* Version 2.13.2 released.
	==========================

	Tag sources with `VER-2-13-2'.

	* docs/VERSION.TXT: Add entry for version 2.13.2.
	* docs/CHANGES: Updated.
	* docs/release, docs/README, builds/macs/README: Updated.

	* README, src/base/ftver.rc, builds/windows/vc2010/index.html,
	builds/windows/visualc/index.html, builds/windows/visualce/index.html,
	builds/wince/vc2005-ce/index.html, builds/wince/vc2008-ce/index.html,
	docs/freetype-config.1: s/2.13.1/2.13.2/, s/2131/2132/.

	* include/freetype/freetype.h (FREETYPE_PATCH): Set to 2.

	* builds/unix/configure.raw (version_info): Set to 26:1:20.
	* CMakeLists.txt (VERSION_PATCH): Set to 2.

2023-08-25  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/base/ftcalc.c (FT_MulAddFix): Simplify 32-bit rounding.

2023-08-25  Werner Lemberg  <wl@gnu.org>

	Fix clang warnings.

	* src/cffload.c (cff_blend_doBlend): Fix type of `sum`.
	* src/truetype/ttgxvar.c (tt_var_load_item_variation_store): Fix type of
	  `word_delta_count`.

2023-08-24  Werner Lemberg  <wl@gnu.org>

	* subprojects/*.wrap: Updated.

2023-08-24  Hugh McMaster  <hugh.mcmaster@outlook.com>

	builds/unix/configure.raw: Use variable to specify minimum Python version.

2023-08-24  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* builds/toplevel.mk: Simplify version extraction.

2023-08-22  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[base] Improve the matrix degeneracy check.

	Also fixes #1251.

	* src/base/ftcalc.c (FT_Matrix_Check): To avoid overflow, scale by shifting.
	* include/freetype/internal/ftcalc.h (FT_Matrix_Check): Update description.

2023-08-22  Werner Lemberg  <wl@gnu.org>

	builds/toplevel.mk: Don't use `\#` in functions.

	The behaviour changed in GNU make 4.3, where `#` (without the backslash)
	would be necessary.  Using a variable instead the code works with both older
	and newer GNU make versions.

	Fixes #1252.

2023-08-19  Hugh McMaster  <hugh.mcmaster@outlook.com>

	builds/freetype.mk: Invoke `mkdocs` as a Python module

	FreeType's `refdoc` target currently allows users to override the
	default Python path, which is useful for testing and development.

	In contrast, `mkdocs` is invoked via the default Python path.

	Invoking `mkdocs` via Python's module syntax allows for greater
	flexibility, although there is no change for the default use case.

2023-08-17  Ben Wagner  <bungeman@chromium.org>

	[base] Avoid UB with memcpy

	`FT_NEW_ARRAY(p, 0)` sets `p` to `NULL`. `FT_Stream_ReadAt` with a
	memory based stream uses `FT_MEM_COPY` which is `memcpy` which specifies
	that it is undefined behavior for either the `src` or `dst` to be
	`NULL`. Instead of forcing all callers work around calling
	`FT_Stream_Read` when `buffer == NULL && count == 0` do the check in
	`FT_StreamRead`. This allows any call with `count == 0` to succesfully
	read zero bytes without UB.

	* src/base/ftstream.c (FT_Stream_ReadAt): skip `FT_MEM_COPY` when
	`count == 0`. (FT_Stream_TryRead): ditto

	Fixes: #1250

2023-08-12  Werner Lemberg  <wl@gnu.org>

	Fix warnings in tracing messages for 32bit compilation.

	Since we now require C99, use `%td` for `ptrdiff_t` and `%zu` for `size_t`.

2023-08-04  Ben Wagner  <bungeman@chromium.org>

	Avoid overflow in COLR bounds checks.

	The values read into `base_glyphs_offset_v1` and `layer_offset_v1` may
	be in the range 0xFFFFFFFD-0xFFFFFFFF. On systems where `unsigned long`
	is 32 bits adding 4 to such values will wrap and pass bounds checks but
	accessing values at such offsets will be out of bounds.

	On the other hand `table_size` has already been tested to be at least
	`COLRV1_HEADER_SIZE` (34) so it is safe to subtract 4 from it.

	* src/sfnt/ttcolr.c (tt_face_load_colr): subtract 4 from `table_size`
	instead of adding 4 to font data offsets in bounds checks

	Fixes: https://crbug.com/1469348

2023-08-02  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/base/ftobjs.c (open_face_from_buffer): Silence `maybe-uninitialized`.

	We never call this function without a `driver_name` (#1245).

2023-07-29  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[truetype] Reduce v40 footprint.

	*  src/truetype/ttgload.c (TT_HInt_Glyph, tt_loader_set_pp,
	tt_loader_init): Refactor code.

2023-07-27  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[truetype] Remove Infinality for good (remaining bits).

	* src/truetype/ttobjs.h: Remove remaining fields.
	* src/truetype/ttinterp.c: Do not initialize them.
	* include/freetype/internal/tttypes.h: Remove descriptions.

2023-07-27  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[truetype] Remove Infinality for good.

	Remove everything `#ifdef TT_SUPPORT_SUBPIXEL_HINTING_INFINALITY`,
	which was undefined for a while now.

	* include/freetype/internal/tttypes.h: Ditto.
	* src/truetype/truetype.c: Ditto.
	* src/truetype/ttdriver.c: Ditto.
	* src/truetype/ttgload.c: Ditto.
	* src/truetype/ttinterp.c: Ditto.
	* src/truetype/ttinterp.h: Ditto.
	* src/truetype/ttobjs.c: Ditto.
	* src/truetype/ttsubpix.[ch]: Remove files.
	* src/truetype/rules.mk: Don't mention "ttsubpix.c".

2023-07-21  Jouk Jansen  <joukj@hrem.nano.tudelft.nl>

	* vms_make.com: Provide separate library compiled with C++.

	Some types on OpenVMS x86_64 (for example, `long') have different sizes
	depending on whether compiled with either C or C++.  In particular,
	X-Windows applications crash if linked with the C++ version.

	This patch makes `vms_make.com` create a second version of the FreeType
	library compiled with C++ if OpenVMS is running on the x86_64 platform.

2023-07-21  Jouk Jansen  <joukj@hrem.nano.tudelft.nl>

	* vms_make.com: Fix typos.

2023-07-21  Jouk Jansen  <joukj@hrem.nano.tudelft.nl>

	* src/smooth/ftgrays.c (FT_SSE2): Fix definition for VMS.

2023-07-19  Jouk Jansen  <joukj@hrem.nano.tudelft.nl>

	vms_make.com: Make use of additional libraries optional.

	Check whether `.olb` files are present.

	Also check for the HarfBuzz library.

2023-07-19  Jouk Jansen  <joukj@hrem.nano.tudelft.nl>

	vms_make.com: Add `/warn=noinfo` to `CFLAGS`.

	This reduces enormously the informationals while compiling on x86_64 (i.e.,
	which `.h` file is inluded form where).

2023-07-18  Ben Wagner  <bungeman@chromium.org>

	[woff2] Clean up on large brotli expansion

	* src/sfnt/sfwoff2.c (woff2_open_font): set error and goto cleanup

	Fixes: https://bugs.chromium.org/p/oss-fuzz/issues/detail?id=60711

2023-07-16  Werner Lemberg  <wl@gnu.org>

	[woff2] Avoid allocation bomb.

	This is a fix for commit 85167dbd5, reported as

	  https://bugs.chromium.org/p/oss-fuzz/issues/detail?id=60615

	* src/sfnt/sfwoff2.c (MAX_SFNT_SIZE): New macro.
	(woff2_open_font): Use it to limit the maximum size of an uncompressed WOFF2
	font.

2023-07-14  Werner Lemberg  <wl@gnu.org>

	[cff] Fix compiler warning.

	* src/cff/cffparse.c, src/cff/cffparse.h: Make `cff_parse_fixed` a local
	function.

2023-07-14  Ben Wagner  <bungeman@chromium.org>

	[woff2] Remove sfnt size guess check

	In WOFF the `totalSfntSize` must be correct, however in WOFF2 this value
	is now just a hint and a conforming implementation must not reject
	otherwise valid data if the `totalSfntSize` turns out not to be exact.

	* src/sfnt/sfwoff2.c (woff2_open_font): remove check that uncompressed
	woff2 data would fit in the sfnt size guess.

	Fixes: #1235

2023-07-14  Skef Iterum  <github@skef.org>

	[cff] Make blend operator work with floats in private dicts.

	The CFF2 blend operator takes N default values and corresponding
	sets of deltas and pushes N values specific to a designspace
	location.  CFF has a floating point numeric type and the FreeType
	blending code was not converting those into its internal 16.16
	Fixed type format.

	Fixes #1243.

	* src/cff/cffparse.c (do_fixed): Handle floating point numbers.
	Also fix scaling overflow check for integer-to-fixed conversion.

	* src/cff/cffload.c (cff_blend_doBlend): Updated.

2023-07-08  Hin-Tak Leung  <htl10@users.sourceforge.net>

	* src/truetype/ttgload.c (TT_Hint_Glyph): More mostly cosmetic update.

	This is a follow-up to commit 49c74ac02, which creates a new local variable
	"exec = loader->exec", and shortening a lot of "loader->exec".  This commit
	does two more such changes missed in that first commit.

2023-07-06  Hugh McMaster  <hugh.mcmaster@outlook.com>

	[gzip] Don't compile internal zlib development files when using system zlib.

	`src/gzip/rules.mk` compiles the internal zlib sources even when using the
	zlib development files provided by a host system.  If the internal zlib
	development files are not present, FreeType fails to build from source.

	This patch ensures the internal zlib development files are only
	prerequisites when not using zlib development files on a host system.

	* src/gzip/rules.mk (GZIP_DRV_SRCS): Define conditionally.

2023-06-24  Werner Lemberg  <wl@gnu.org>

	* Version 2.13.1 released.
	==========================

	Tag sources with `VER-2-13-1'.

	* docs/VERSION.TXT: Add entry for version 2.13.1.
	* docs/CHANGES: Updated.
	* docs/release, docs/README, builds/macs/README: Updated.

	* README, src/base/ftver.rc, builds/windows/vc2010/index.html,
	builds/windows/visualc/index.html, builds/windows/visualce/index.html,
	builds/wince/vc2005-ce/index.html, builds/wince/vc2008-ce/index.html,
	docs/freetype-config.1: s/2.13.0/2.13/1/, s/2130/2131/.

	* include/freetype/freetype.h (FREETYPE_PATCH): Set to 1.

	* builds/unix/configure.raw (version_info): Set to 26:0:20.
	* CMakeLists.txt (VERSION_PATCH): Set to 1.

	* subprojects/libpng.wrap, subprojects/zlib.wrap, subprojects/dlg: Updated.

2023-06-09  suzuki toshiya  <mpsuzuki@hiroshima-u.ac.jp>

	Comment fixes.

2023-06-09  Werner Lemberg  <wl@gnu.org>

	[sdf] Correct handling of empty glyphs.

	This is a refinement of commit 7b3ebb9.

	* src/sdf/ftsdfrend.c (ft_sdf_render): Goto 'Exit' instead of directly
	returning.
	(fd_bsdf_render): Ditto, also taking care of setting `FT_GLYPH_OWN_BITMAP`
	correctly.

2023-06-05  Ben Wagner  <bungeman@chromium.org>

	Mark FT_Renderer_Class::raster_class as pointer to const

	The `FT_DEFINE_RASTER_FUNCS` macro declares a `const FT_Raster_Funcs`.
	The address of the definition is taken and assigned to
	`FT_Renderer_Class::raster_class` which is currently `FT_Raster_Funcs*`.
	Until recently the `const` was cast away and with the removal of the
	cast there are now warnings about dropping this `const`. Instead of
	adding back the casts, make `FT_Renderer_Class::raster_class` a pointer
	to const, as is done with pointers in other interfaces.

	* include/freetype/ftrender.h (FT_Renderer_Class_): mark `raster_class`
	as const.

2023-06-03  Ben Wagner  <bungeman@chromium.org>

	Fix some `FT_Fixed` vs. `FT_Long` confusion.

	`FT_Fixed` and `FT_Long` are both typedef'ed to be `signed long`.  However,
	`FT_Fixed` implies that the lower 16 bits are being used to express
	fractional values and so these two types should not be confused.

	* include/freetype/internal/services/svmm.h (FT_Set_MM_Blend_Func): Use
	`FT_Fixed` for `coords`.  Users are passing `FT_Fixed` and implementations
	are taking `FT_Fixed`.
	(FT_Get_MM_Blend_Func): Ditto.

	* src/autofit/afcjk.c (af_cjk_metrics_check_digits): Use `FT_Long` for
	`advance` and `old_advance`.  `advance`'s address is passed as `FT_Long*` to
	`af_shaper_get_elem`, which writes the advance in em units (not fixed).  The
	exact value is not important here as it is only compared to check whether it
	has changed.

	* src/autofit/aflatin.c (af_latin_metrics_check_digits): Ditto.

2023-06-03  Ben Wagner  <bungeman@chromium.org>

	*/*: Remove many function pointer casts.

	In C it is undefined behavior to call a function through a function pointer
	of a different type.  This is now detected by the Control Flow Integrity
	Sanitizer.  All known issues have already been fixed.  Prevent any
	accidental re-introduction by removing function pointer casts when defining
	services.  The services will call the service functions through the function
	pointers on the service.  As a result the functions must have the same type
	so there should be no need to cast.  Removing the casts allows compilers to
	warn about assignment to an incompatible function pointer type.

2023-06-03  Werner Lemberg  <wl@gnu.org>

	Minor formatting.

2023-05-23  Werner Lemberg  <wl@gnu.org>

	Replace `sprintf` with `snprintf`.

	Fixes #1233.

	* include/freetype/config/ftstdlib.h (ft_sprintf): Replace with...
	(ft_snprintf): This new macro.

	* src/autofit/afhints.c (af_print_idx): Add argument to pass the buffer
	size.
	(af_glyph_hints_dump_points, af_glyph_hints_dump_segments,
	af_glyph_hints_dump_edges): Updated.

	* src/bdf/bdflib.c (BUFSIZE): New macro.
	(bdf_parse_properties_, bdf_parse_start_): Use `ft_snprintf`.

	* src/tools/ftrandom/ftrandom.c (do_test): Use `snprintf`.

2023-05-23  Werner Lemberg  <wl@gnu.org>

	docs/DEBUG: Formatting.

2023-05-20  suzuki toshiya  <mpsuzuki@hiroshima-u.ac.jp>

	[doc] Type1 GX (sfnt-wrapped Type1) is not supported.

	* docs/formats.txt: Clarify the reference of Type1 GX,
	and state that this format is not supported.  This
	is because the content `TYP1' table is not exactly same
	with the Type1 font format specification; no eexec
	encryption is used.  For detail and concrete examples,
	see the analysis on:

	https://gitlab.freedesktop.org/freetype/freetype/-/issues/1231

2023-05-19  Craig White  <gerzytet@gmail.com>

	Add missing end quote of a string in the example code of FT_Trace_Set_Level

2023-05-19  Seigo Nonaka  <nona@google.com>

	[truetype] Reduce heap allocation of `deltaSet` variation data.

	`deltaSet` is an array of packed integers that can be 32 bits, 16 bits, or
	8 bits.  Before this change, these values were unpacked to 32-bit integers.
	However, this can cause big heap allocations, e.g., around 500 KByte for
	'NotoSansCJK'.  To reduce this amount, store the packed integers and unpack
	them just before passing to the calculation.  At calculation time, due to
	the variable length of region indices, temporary heap allocations are
	necessary.  This heap allocation is not negligible and visible in `ftbench`
	results.  So, use stack-allocated arrays for short array calculations.

	Fixes #1230.

	* include/freetype/internal/ftmmtypes.h (GX_ItemVarDataRec): New fields
	`wordDeltaCount` and `longWords`.

	* src/truetype/ttgxvar.c (tt_var_load_item_variation_store): Load packed
	data.
	(tt_var_get_item_delta): Unpack data before applying.

2023-05-17  Jouk Jansen  <joukj@hrem.nano.tudelft.nl>

	vms_make.com: Create shared executable for x86 version of OpenVMS.

2023-05-15  Werner Lemberg  <wl@gnu.org>

	Add new load flag `FT_LOAD_NO_SVG`.

	Modern color fonts often contain both an 'SVG' and 'COLR' table.  FreeType
	always preferred 'SVG' over 'COLR' (this was a design decision), however,
	this might not be the right choice for the user.  The new flags makes
	FreeType ignore the 'SVG' table while loading a glyph.

	Fixes #1229.

	* include/freetype/freetype.h (FT_LOAD_NO_SVG): New macro.

	* src/base/ftobjs.c (FT_Load_Glyph), src/cff/cffgload.c (cff_slot_load),
	src/truetype/ttgload.c (TT_Load_Glyph): Use it.

2023-05-13  Werner Lemberg  <wl@gnu.org>

	.mailmap: Updated.

2023-05-13  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[cache] Merge functions.

	* src/cache/ftccache.c (FTC_Cache_Init): Merge into...
	(ftc_cache_done): ... this function, with unnecessary checks removed.

2023-05-13  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[cache] Minor casting and cosmetic updates.

	* src/cache/ftcglyph.c (ftc_gcache_{init,done}): Remove casting.
	(FTC_GCache_Lookup): Cosmetic variable renaming.
	* src/cache/ftcsbits.c (ftc_snode_compare): Formatting.

2023-05-12  Werner Lemberg  <wl@gnu.org>

	* include/freetype/ftcache.h: Typo, punctuation.

2023-05-12  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* include/freetype/ftcache.h: Formatted and updated.

2023-05-12  suzuki toshiya  <mpsuzuki@hiroshima-u.ac.jp>

	* include/freetype/internal/t1types.h: Fix the indentation.

2023-05-11  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[cache] Revise the dynamic hash table accounting.

	Instead of counting entries relative to the middle of the hash table,
	this switches to the absolute counter with the full index range mask.
	As a result, some calculations become a bit simpler.  The cache resizing
	logic stays largely the same.

	* src/cache/ftccache.h (FTC_NODE_TOP_FOR_HASH): Revised with new counter.
	* src/cache/ftccache.c (ftc_get_top_node_for_hash): Ditto.
	(ftc_cache_resize): Simplify reallocations and stop their zeroing.
	(ftc_cache_init): Stop over-allocating but keep zeroing initially.
	(FTC_Cache_Clear, FTC_Cache_RemoveFaceID): Updated accordingly.

2023-05-11  suzuki toshiya  <mpsuzuki@hiroshima-u.ac.jp>

	[t1cid] Set FT_FACE_FLAG_CID_KEYED.

	* cidobjs.c (cid_face_init): Set FT_FACE_FLAG_CID_KEYED.

	* cidriver.c (cid_get_is_cid): Comment about the case that
	is_cid cannot guarantee the glyph collection specification.

2023-05-09  Jouk Jansen  <joukj@hrem.nano.tudelft.nl>

	* src/smooth/ftgrays.c (FT_SSE2): Don't define for VMS.

2023-05-08  Werner Lemberg  <wl@gnu.org>

	* src/cff/cffdrivr.c (cff_glyph_load): Fix guard for `size`.

	This was forgotten to change in commit 2b54eba36b (in May 2004).

	Reported as

	  https://bugs.chromium.org/p/oss-fuzz/issues/detail?id=58739

2023-05-08  Werner Lemberg  <wl@gnu.org>

	Minor compiler warning fixes.

	* src/autofit/afcjk.c (af_cjk_get_standard_widths), src/autofit/aflatin.c
	(af_latin_get_standard_widths): Use `FT_CALLBACK_DEF`.

	* src/cff/cffparse.c (cff_parser_run): Initialize and fix allocation of `q`.

2023-05-08  Werner Lemberg  <wl@gnu.org>

	* src/psaux/t1cmap.c: Signature fixes.

2023-05-08  Werner Lemberg  <wl@gnu.org>

	* src/bzip2/ftbzip2.c: Signature fixes.

2023-05-08  Werner Lemberg  <wl@gnu.org>

	[cache] Signature fixes.

	* src/cache/ftcglyph.c, src/cache/ftcglyph.h (FTC_GNode_Compare): Remove
	redundant function.  It is equivalent to `ftc_gnode_compare` and becomes
	completely meaningless with fixed signatures.
	Update all callers.

	* src/cache/ftcsbits.c, src/cache/ftcsbits.h (FTC_SNode_Compare): Remove
	redundant function.  It is equivalent to `ftc_snode_compare` and becomes
	completely meaningless with fixed signatures.
	Update all callers.

2023-05-07  Werner Lemberg  <wl@gnu.org>

	[sdf] Signature fixes.

2023-05-07  Werner Lemberg  <wl@gnu.org>

	* src/svg/ftsvg.c: Signature fixes.

2023-05-07  Werner Lemberg  <wl@gnu.org>

	[raster] Signature fixes.

2023-05-07  Werner Lemberg  <wl@gnu.org>

	[smooth] Signature fixes.

2023-05-07  Werner Lemberg  <wl@gnu.org>

	[pshinter] Signature fixes.

	* src/pshinter/pshrec.c (t1_hints_close, t1_hints_apply): New wrapper
	functions.
	(t1_hints_funcs_init): Use them.
	(t2_hints_close, t2_hints_apply): New wrapper functions.
	(t2_hints_funcs_init): Use them.

2023-05-07  Werner Lemberg  <wl@gnu.org>

	[autofit] Signature fixes.

2023-05-07  Werner Lemberg  <wl@gnu.org>

	* src/sfnt/ttcmap: Signature fixes.

2023-05-07  Werner Lemberg  <wl@gnu.org>

	* src/pcf/pcfdrivr.c: Signature fix.

2023-05-07  Werner Lemberg  <wl@gnu.org>

	* src/winfonts/winfnt.c: Signature fixes.

2023-05-07  Werner Lemberg  <wl@gnu.org>

	* src/type42/t42parse.c: Signature fixes.

2023-05-07  Werner Lemberg  <wl@gnu.org>

	[pfr] Signature fixes.

2023-05-07  Werner Lemberg  <wl@gnu.org>

	* src/cid/cidload.c: Signature fixes.

2023-05-07  Werner Lemberg  <wl@gnu.org>

	* src/cff/cffcmap.c: Signature fixes.

2023-05-07  Werner Lemberg  <wl@gnu.org>

	* src/type1/t1load.c: Signature fixes.

2023-05-07  Werner Lemberg  <wl@gnu.org>

	[truetype] Signature fixes.

2023-05-07  Werner Lemberg  <wl@gnu.org>

	[base] Signature fixes.

2023-05-07  Werner Lemberg  <wl@gnu.org>

	* src/type42/t42drivr.c: Clean up interface.

	Ensure that all driver functions use the signature of the service or driver.
	This avoids pointer mismatches, which are technically undefined behaviour.
	Recent compilers are more picky in catching them as part of Control Flow
	Integrity tests.

2023-05-07  Werner Lemberg  <wl@gnu.org>

	* src/type1/*: Clean up interface.

	Ensure that all driver functions use the signature of the service or driver.
	This avoids pointer mismatches, which are technically undefined behaviour.
	Recent compilers are more picky in catching them as part of Control Flow
	Integrity tests.

2023-05-07  Werner Lemberg  <wl@gnu.org>

	* src/truetype/*: Clean up interface.

	Ensure that all driver functions use the signature of the service or driver.
	This avoids pointer mismatches, which are technically undefined behaviour.
	Recent compilers are more picky in catching them as part of Control Flow
	Integrity tests.

2023-05-07  Werner Lemberg  <wl@gnu.org>

	* src/sfnt/sfdriver.c, src/sfnt/ttbdf.c: Clean up interface.

	Ensure that all driver functions use the signature of the service or driver.
	This avoids pointer mismatches, which are technically undefined behaviour.
	Recent compilers are more picky in catching them as part of Control Flow
	Integrity tests.

	* src/sfnt/sfdriver.c (sfnt_load_table): New wrapper function.
	(sfnt_service_sfnt_table): Use it.

2023-05-07  Werner Lemberg  <wl@gnu.org>

	* src/psnames/psmodule.c: Use `FT_CALLBACK_DEF`.

2023-05-07  Werner Lemberg  <wl@gnu.org>

	* src/pfr/pfrdrivr.c: face -> pfrface, pfrface -> face.

2023-05-07  Werner Lemberg  <wl@gnu.org>

	* src/pcf/pcfdrivr.c: Clean up interface.

	Ensure that all driver functions use the signature of the service or driver.
	This avoids pointer mismatches, which are technically undefined behaviour.
	Recent compilers are more picky in catching them as part of Control Flow
	Integrity tests.

2023-05-07  Werner Lemberg  <wl@gnu.org>

	* src/cid/cidriver.c: Clean up interface.

	Ensure that all driver functions use the signature of the service or driver.
	This avoids pointer mismatches, which are technically undefined behaviour.
	Recent compilers are more picky in catching them as part of Control Flow
	Integrity tests.

2023-05-07  Werner Lemberg  <wl@gnu.org>

	* src/bdf/bdfdrivr.c: Clean up interface.

	Ensure that all driver functions use the signature of the service or driver.
	This avoids pointer mismatches, which are technically undefined behaviour.
	Recent compilers are more picky in catching them as part of Control Flow
	Integrity tests.

2023-05-07  Werner Lemberg  <wl@gnu.org>

	* src/cff/*: Clean up interface.

	Ensure that all driver functions use the signature of the service or driver.
	This avoids pointer mismatches, which are technically undefined behaviour.
	Recent compilers are more picky in catching them as part of Control Flow
	Integrity tests.

2023-05-06  Werner Lemberg  <wl@gnu.org>

	[truetype] Fix style name handling for variation fonts.

	* include/freetype/internal/tttypes.h (TT_FaceRec): New field
	`non_var_style_name`.

	* src/sfnt/sfobjs.c (sfnt_load_face): Initialize `non_var_style_name`.
	(sfnt_done_face): Free `non_var_style_name`.

	* src/truetype/ttgxvar.c (TT_Set_Named_Instance): Restore non-VF style name
	if switching back to non-VF mode.

2023-05-06  Werner Lemberg  <wl@gnu.org>

	[truetype] Fix PostScript name handling for variation fonts.

	A variation font's PostScript name of a named instance is usually different
	from the PostScript name of an unnamed instance.  However, if a change
	between a named instance and an unnamed instance with exactly the same
	design axis values happened, it was possible that the PostScript name wasn't
	correctly updated.

	This commit reorganizes the code to handle this issue within the top-level
	API functions, using a new service to trigger recomputation of the
	PostScript name.

	* include/freetype/internal/services/svmm.h (FT_Construct_PS_Name_Func): New
	typedef.
	(FT_Service_MultiMasters): New field `construct_ps_name`.
	(FT_DEFINE_SERVICE_MULTIMASTERSREC): Updated.

	* src/base/ftmm.c (FT_Set_Var_Design_Coordinates,
	FT_Set_MM_Blend_Coordinates, FT_Set_Var_Blend_Coordinates): Call
	`mm->construct_ps_name` to handle `postscript_name`.
	(FT_Set_Named_Instance): Call `mm->construct_ps_name` to handle
	`postscript_name`.
	Use shortcut.
	* src/cff/cffdrivr.c (cff_construct_ps_name): New function.
	(cff_service_multi_masters): Updated.

	* src/truetype/ttgxvar.c (tt_set_mm_blend): Don't handle `postscript_name`.
	(TT_Set_MM_Blend): Simplify.
	(TT_Set_Named_Instance): Return -1 if axis values haven't changed.
	Don't set `face_index`.
	(tt_construct_ps_name): New function.

	* src/truetype/ttgxvar.h: Updated.

	* src/truetype/ttdriver.c (tt_service_gx_multi_masters): Updated.

	* src/type1/t1driver.c (t1_service_multi_masters): Updated.

	* src/type1/t1load.c (T1_Set_MM_Blend): Simplify.

2023-05-06  Werner Lemberg  <wl@gnu.org>

	* include/freetype/internal/services/svmm.h: Minor changes.

2023-05-06  Werner Lemberg  <wl@gnu.org>

	[truetype] Fix deactivation of variation font handling.

	According to the documentation, the functions `FT_Set_Named_Instance`,
	`FT_Set_MM_Design_Coordinates`, `FT_Set_Var_Design_Coordinates`, and
	`FT_Set_Var_Blend_Coordinates` can unset the `FT_FACE_FLAG_VARIATION` flag.
	(The same is true for `FT_Set_MM_WeightVector` but this information was
	accidentally omitted from the documentation.)

	However, if a call of these functions didn't change the axis values this
	could fail because internal shortcuts exited too early.

	This commit reorganizes the code to handle `FT_FACE_FLAG_VARIATION` in the
	top-level API functions, also taking care of the issue at hand.

	* src/base/ftmm.c (FT_Set_MM_Design_Coordinates, FT_Set_MM_WeightVector,
	FT_Set_Var_Design_Coordinates, FT_Set_MM_Blend_Coordinates,
	FT_Set_Var_Blend_Coordinates): Handle `FT_FACE_FLAG_VARIATION`.

	* src/truetype/ttgxvar.c (TT_Set_MM_Blend, TT_Set_Var_Design,
	TT_Set_Named_Instance) Don't handle `FT_FACE_FLAG_VARIATION`.

	* src/type1/t1load.c (T1_Set_MM_Blend, T1_Set_MM_WeightVector,
	T1_Set_MM_Design): Ditto.

	* src/cff/cffobjs.c (cff_face_init): Use `FT_Set_Named_Instance` instead of
	low-level functions.

	* src/truetype/ttobjs.c (tt_face_init): Ditto.

2023-05-06  Werner Lemberg  <wl@gnu.org>

	s/set_instance/set_named_instance/

	* include/freetype/internal/services/svmm.h (FT_Set_Instance_Func): Renamed
	to...
	(FT_Set_Named_Instance_Func): ...this.
	(FT_Service_MultiMasters): Rename `set_instance` to `set_named_instance`.
	(FT_DEFINE_SERVICE_MULTIMASTERSREC): Updated.

	* src/base/ftmm.c (FT_Set_Named_Instance): Updated.

	* src/cff/cffdrivr.c (cff_set_instance): Renamed to...
	(cff_set_named_instance): ...this.
	(cff_service_multi_masters): Updated.
	* src/cff/cffobjs.c (cff_face_init): Updated.

	* src/truetype/ttdriver.c (tt_service_gx_multi_masters): Updated.

	* src/type1/t1driver.c (t1_service_multi_masters): Updated.

2023-05-06  Werner Lemberg  <wl@gnu.org>

	New Variation Font function `FT_Get_Default_Named_Instance`.

	* include/freetype/ftmm.h, src/base/ftmm.c (FT_Get_Default_Named_Instance):
	New function.

	* include/freetype/internal/services/svmm.h
	(FT_Get_Default_Named_Instance_Func): New typedef.
	(FT_Service_MultiMasters): New field `get_default_named_instance`.
	(FT_DEFINE_SERVICE_MULTIMASTERSREC): Updated.

	* include/freetype/internal/tttypes.h (TT_Face): New field
	`var_default_named_instance`.

	* src/sfnt/sfobjc.s (sfnt_init_face): Initialize
	`var_default_named_instance`.

	* src/cff/cffdrivr.c (cff_get_default_named_instance): New function.
	(cff_service_multi_masters): Updated.

	* src/truetype/ttgxvar.c (TT_Get_MM_Var): Initialize
	`var_default_named_instance`.
	(TT_Get_Default_Named_Instance): New function.
	* src/truetype/ttgxvar.h: Updated.
	* src/truetype/ttdriver.c (tt_service_gx_multi_masters): Updated.

	* src/type1/t1driver.c (t1_service_multi_masters): Updated.

	* docs/CHANGES: Updated.

2023-05-06  Werner Lemberg  <wl@gnu.org>

	[cid] Improve tracing messages; formatting.

2023-05-04  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/cache/ftccache.c (ftc_node_hash_unlink): Minor.

2023-05-04  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/cache/ftcmru.c (FTC_MruList_RemoveSelection): Purge backwards.

2023-05-04  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[cache] Revise list cleansing.

	* src/cache/ftcmru.c (FTC_MruList_RemoveSelection): Use one loop to
	do it.
	* src/cache/ftcmanag.c (FTC_Manager_Compress, FTC_Manager_FlushN):
	Streamline loops.

2023-05-03  suzuki toshiya  <mpsuzuki@hiroshima-u.ac.jp>

	[t1cid] Improve cid_get_cid_from_glyph_index().

	Update cid_get_cid_from_glyph_index() to
	return an error and CID=0 in the case that
	the specified glyph index points to an invalid
	entry.

	cidgload.h (cid_compute_fd_and_offsets):
	Declare new helper function to set the
	fd_select and 2 offsets to access the glyph
	description data.

	cidgload.c (cid_compute_fd_and_offsets):
	Move the part loading fd_select and 2 offsets
	from cid_load_glyph() to here.  If the loaded
	parameters are broken, return the Invalid_Offset
	error.  This function does not load the glyph
	data, only fills these parameters.

	(cid_load_glyph): Use new helper function in above.

	cidriver.c (cid_get_cid_from_glyph_index):
	Check whether the requested glyph index points
	to a valid entry, by calling cid_compute_fd_and_offsets().
	If it is valid, fill the cid by the glyph
	index (=CID).  If it is invalid, return an
	error and fill the cid by 0.

2023-04-30  Werner Lemberg  <wl@gnu.org>

	API documentation: Re-organize chapters and sections

	* Split the very long 'Base Interface' section into smaller sections.
	* Split the 'Core API' chapter into two chapters.
	* Remove single enumeration values from `@order` fields since they have no
	  effect.

2023-04-29  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/sfnt/pngshim.c (Load_SBit_Png): Remove FALL_THROUGH warning.

2023-04-28  Werner Lemberg  <wl@gnu.org>

	* src/sfnt/ttload.c (tt_face_load_font_dir): Add another guard.

	Reject 'OTTO' fonts with no valid tables.

2023-04-28  Werner Lemberg  <wl@gnu.org>

	* src/cff/cffdrivr/c (cff_get_ps_name): Avoid unnecessary crash.

	The situation can happen if `FT_New_Face` (or one of its siblings) is called
	with a negative index to get the number of contained faces, followed
	immediately by a call to `FT_Get_Postscript_Name`.  While this is not a valid
	use of the FreeType library there is no need for a crash.

	Fixes #1219.

2023-04-28  Werner Lemberg  <wl@gnu.org>

	* src/cff/cffdrivr.c (cff_ps_get_font_info): Reject 'CFF2' format.

2023-04-28  Werner Lemberg  <wl@gnu.org>

	* src/cid/cidgload.c (cid_load_glyph): Fix compiler warnings.

2023-04-28  Werner Lemberg  <wl@gnu.org>

	Minor documentation updates.

2023-04-27  Werner Lemberg  <wl@gnu.org>

	* src/ttgxvar.c: Minor changes.

	(TT_Get_MM_Var): Improve tracing messages.
	(tt_set_mm_blend): Minor speed-up.

2023-04-27  Werner Lemberg  <wl@gnu.org>

	s/this is,/that is,/

2023-04-27  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[bdf] Clean up the atom property parsing.

	* src/bdflib.c (bdf_is_atom_): Refactor code with fewer checks.
	(bdf_list_join_): Return NULL.
	(bdf_add_comment_): Use const argument.
	(bdf_get_property): Ditto, ditto, make the function static.
	* src/bdf.h (bdf_get_property): Remove prototype.

2023-04-25  Werner Lemberg  <wl@gnu.org>

	Improve/add source comments and documentation.

2023-04-25  Werner Lemberg  <wl@gnu.org>

	[sfnt] Fix handling of PS names for Variation Fonts.

	* src/sfnt/sfdriver.c (get_win_string, get_apple_string): Continue
	construction of string if an invalid character is encountered.

	Fixes #1218.

2023-04-24  suzuki toshiya  <mpsuzuki@hiroshima-u.ac.jp>

	[t1cid] Change the trace messages of the charstrings retrieval errors.

	The t1cid driver catches 3 types of errors in
	the charstrings retrieval;
	A) The invalid FD number, there are 2 subtypes;
	  A-1) FD number is the maximum number fitting to FDBytes.
	  A-2) FD number is greater than num_dicts.
	B) Declared length is overrunning.
	C) Declared length is invalid (its end is before its head).

	Considering that some widely distributed fonts
	(e.g., "CJKV" book by O'Reilly) have A-1 errors
	in the unimplemented glyphs, the trace level for
	A-1 is calmed to level 1.

	The errors A-2, B, and C would be irregular;
	their trace levels are kept at level 0, but
	the updated trace messages include the CID number.

2023-04-24  suzuki toshiya  <mpsuzuki@hiroshima-u.ac.jp>

	[truetype] Fix `make multi'.

	* src/truetype/ttgxvar.c: Include freetype/internal/services/svmetric.h
	for the FT_Service_MetricsVariations type definition.

2023-04-19  Ben Wagner  <bungeman@chromium.org>

	[services] FT_Size_Reset_Func to return FT_Error

	The `MetricsVariations` `FT_Size_Reset_Func` is currently defined to
	return `void`, but the implementations return `FT_Error`. Even though
	the pointers passed will be the same at runtime, calling a function
	through a pointer of a different type from the original function pointer
	type is undefined behavior. This may be caught at runtime by Control
	Flow Integrity with something like clang's `cfi-icall`.

	Issue: https://crbug.com/1433651

	* include/freetype/internal/services/svmetric.h (FT_Size_Reset_Func):
	return `FT_Error` instead of `void`.

2023-04-17  Ben Wagner  <bungeman@chromum.org>

	[truetype] tt_size_reset_height to take FT_Size

	The `MetricsVariations` `FT_Size_Reset_Func` is defined to take an
	`FT_Size`. Because `tt_size_reset_height` is to be used as such a
	function, it must also take an `FT_Size` instead of a `TT_Size`. Even
	though the pointers passed will be the same at runtime, calling a
	function through a pointer of a different type from the original
	function pointer type is undefined behavior. This may be caught at
	runtime by Control Flow Integrity with something like clang's
	`cfi-icall`.

	Issue: https://crbug.com/1433651

	* src/truetype/ttobjs.h (tt_size_reset_height): take `FT_Size`

	* src/truetype/ttobjs.c (tt_size_reset_height): take `FT_Size` and
	update documentation

2023-04-13  Werner Lemberg  <wl@gnu.org>

	* src/truetype/ttinterp.c: Remove outdated comments.

2023-04-11  Ben Wagner  <bungeman@chromium.org>

	[sfnt, truetype] Add `size_reset` to `MetricsVariations`.

	This is a generalization of commit

	```
	commit e6699596af5c5d6f0ae0ea06e19df87dce088df8
	Author: Werner Lemberg <wl@gnu.org>
	Date:   Thu Feb 2 11:38:04 2017 +0100

	    [truetype] Fix MVAR post-action handling.
	```

	It is also possible for plain `CFF ` style fonts to contain an `fvar` and
	`MVAR` table and use `cff_metrics_adjust`.  `tt_size_reset` should only be
	called with `TT_Size` and never with `CFF_Size`.

	Allow the "metrics-variations" service to specify the correct function (if
	any) to reset `FT_Size`s after adjusting metrics.

	* src/truetype/ttobjs.c (tt_size_reset): Split off some functionality
	into...
	(tt_size_reset_height): ... this new function.

	* src/truetype/ttdriver.c (tt_service_metrics_variations): Add
	`size_reset`.
	(tt_size_select, tt_size_request): Updated.

	* src/truetype/ttobjs.h: Updated.

	* include/freetype/internal/services/svmetric.h (MetricsVariations): Add
	`size_reset`.
	(FT_DEFINE_SERVICE_METRICSVARIATIONSREC): Updated.

	* include/freetype/internal/tttypes.h (TT_FaceRec_): Rename `var` to
	`tt_var` and add `face_var`.

	* src/cff/cffdrivr.c (cff_service_metrics_variations): Add `size_reset`.
	(cff_hadvance_adjust, cff_metrics_adjust): Updated.

	* src/cff/cffobjs.c (cff_face_init): Use `face_var`.

	* src/sfnt/sfobjs.c (sfnt_init_face): Initialize `face_var`.

	* src/sfnt/ttmtx.c (tt_face_get_metrics): Use `tt_var`.

	* src/truetype/ttgxvar.c (tt_size_reset_iterator): Renamed to...
	(ft_size_reset_iterator): ... this new function.
	Call `size_reset`.
	(tt_apply_mvar): Pass `size_reset` to `ft_size_reset_iterator`.

	Fixes #1211

2023-04-10  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/cff/cffcmap.c (cff_cmap_encoding_char_next): Abbreviate.

2023-04-10  Alexei Podtelezhnikov  <apodtele@gmail.com>

	Align `char_next` return types.

	This is mostly cosmetic because FT_UInt and FT_UInt32 are likely identical.

	* src/sfnt/ttcmap.c, src/cff/cffcmap.c, src/psaux/t1cmap.c,
	src/psnames/psmodule.c, include/freetype/internal/service/svpcsmap.h,
	src/pfr/pfrcmap.c, src/winfonts/winfnt.c (*_char_next): return FT_UInt.

2023-04-09  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[sfnt] Clean up CMAP{4,12,13} handling.

	This moves the charcode overflow checks upstream and turns some
	while-loops into the do-while ones to avoid the uninitialized warnings.
	This should slightly reduce the number of checks and jumps.

	* src/sfnt/ttcmap.c (tt_cmap{4,12,13}_next,
	tt_cmap{4.12.13}_char_map_linear): Remove the charcode overflow check.
	(tt_cmap{4,12,13}_char_map_binary): Ditto and use do-while.
	(tt_cmap{12,13}_char_next): Add the overflow check.

2023-04-03  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/sfnt/ttpost.c (load_format_25): Do not abort frame reading.

2023-04-03  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/sfnt/ttpost.c (load_format_*): Streamline frame reading.

2023-04-02  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/sfnt/ttpost.c: Formatting and comments.

2023-04-02  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[sfnt] Consolidate POST version 2.0 and 2.5 (pt 2).

	* src/sfnt/ttpost.c (load_format_20, load_format_25): Update arguments
	and move shared calls and checks upstream to...
	(load_post_names): ... this function.
	(tt_face_free_ps_names, tt_face_get_ps_name): Updated.

2023-04-02  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[sfnt] Consolidate POST version 2.0 and 2.5 (pt 1).

	The deprecated POST version 2.5 can be handled using the data
	structures of version 2.0.  The goal is to reduce the footprint.

	* include/freetype/internal/tttypes.h (TT_Post_Names): Absorb and...
	(TT_Post_20, TT_Post_25): ... remove these structures.
	src/sfnt/ttpost.c (load_post_names, tt_face_get_ps_name,
	tt_face_free_ps_names, load_format_20): Updated accordingly.
	(load_format_25): ditto and convert offsets to glyph indices.

2023-04-01  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[sfnt] Miscellaneous POST clean-ups.

	* src/sfnt/ttpost.c (load_format_20): Decrease casts.
	(load_format_25): Check the table length and impose a theoretical
	glyph number limit usable with 8-bit offset.  Decrease casts.
	(load_post_names): Pass the mapping data length without 2 bytes.

2023-03-30  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/sfnt/ttpost.c (load_format_20): Simplify comutations.

2023-03-29  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[sfnt] Streamline POST format 2.0 handing (cont'd).

	* src/sfnt/ttpost.c (load_format_20): Co-allocate the string data and
	their pointers, which makes it easier to handle and free them.
	(tt_face_free_ps_names): Updated.
	* include/freetype/internal/tttypes.h (TT_Post_20): Update type.

2023-03-20  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[cff] Simplify `t2_strings` management in the old engine.

	* src/cff/cffparse.c (cff_parser_run): Allocate the charstring buffers
	and the list nodes together so that they can be freed at once.
	(finalize_t2_strings): Removed as no longer needed.
	(cff_parser_done): Updated.

2023-03-19  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[cff] Rework the stream limit checks.

	The old stream limit checks, before 6986ddac1ece, were good but
	pointless for the crafted t2_strings.  Checking limits there is
	not necessary as they are created to hold all data.  By using two
	conditions, we can detect the actual crossing of the stream boundary
	as appropriate for the stream pointer only.  The t2_strings parsing
	will not be triggering these checks.

	* src/cff/cffparse.c (cff_parser_within_limits): Removed.
	(cff_parse_real, cff_parse_integer): Redesign the stream limit check.
	(cff_parse_num, do fixed, cff_parse_fixed_dynamic): Update callers.

2023-03-18  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/truetype/ttgload.c (TT_Load_Simple_Glyph): Use for-loop.

	Even though we never call `TT_Load_Simple_Glyph` with zero contours,
	out of abundance of precaution, let's handle this case properly.

2023-03-18  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[truetype] Clean up zeroing and local variables.

	* src/truetype/ttgload.c (TT_Process_Simple_Glyph): Avoid zeroing.
	(load_truetype_glyph): Avoid zeroing and clean local variables.

2023-03-16  Werner Lemberg  <wl@gnu.org>

	* include/freetype/ftsystem.h (FT_Stream_IoFunc): Improve documentation.

	Fixes #1208.

2023-03-16  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/base/ftsynth.c (FT_GlyphSlot_AdjustWeight): New API.

2023-03-16  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[truetype] Clean up glyph loading.

	* src/truetype/ttgload.c (TT_Load_Simple_Glyph): Clean space checking.
	(TT_Hint_Glyph): Don't copy the outline structure.
	(TT_Process_Simple_Glyph): Cosmetic update.

2023-03-15  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/truetype/ttgload.c (TT_Load_Simple_Glyph): Clean up.

2023-03-13  Werner Lemberg  <wl@gnu.org>

	builds/vms/apinames_vms.bash: Fix `unzip` artifact

	The problem occured when unpacking a zip file created on OpenVMS on Linux.
	While OpenVMS knows many different file formats, Unix only knows stream-LF
	and binary.  In principle `zip` on Linux should have translated the file to
	stream-LF but failed to do so.  That caused the file to incorrectly contain
	only one line with control-characters.

2023-03-11  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[truetype] Fix recent fallout in memory management.

	* src/truetype/ttgload.c (TT_Process_Composite_Glyph,
	TT_Load_Simple_Glyph): Clean up old instructions regardless of
	new ones, postpone setting `control_len` and `control_data` until...
	(TT_Load_Glyph): ... the exit from this function.

2023-03-10  Jouk Jansen  <joukj@hrem.nano.tudelft.nl>

	Update VMS installation support.

2023-03-10  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/truetype/ttgload.c (TT_Hint_Glyph): Mostly cosmetic update.

	The number of instructions is now taken from the executed context.
	Technically, this means that `control_len` and `control_data`
	values are no longer _used_ internally but only expose them.

2023-03-08  Werner Lemberg  <wl@gnu.org>

	apinames.c: Add comment.

2023-03-07  Werner Lemberg  <wl@gnu.org>

	[gzip] File `infback.c` is not needed.

	* src/gzip/infback.c: Remove.
	* src/gzip/rules.mk (GZIP_DRV_SRCS): Updated.

2023-03-07  Werner Lemberg  <wl@gnu.org>

	[apinames] Fix VMS handling of overly long function names.

	Based on ideas from Jouk Jansen <joukj@hrem.nano.tudelft.nl>.

	* src/tools/vms_shorten_symbol.c: New file, taken from

	  https://sourceforge.net/p/vms-ports/vmsshortsym/ci/default/tree/vms_shorten_symbol.c

	with some minor edits to allow compilation with C++ and being included in
	another source code file.

	* src/tools/apinames.c: Include `vms_shorten_symbol.c`.
	(PROGRAM_VERSION): Set to '0.5'.
	(names_dump) [OUTPUT_VMS_OPT]: Call `vms_shorten_symbol` to get unique function
	identifiers not longer than 31 characters.

2023-03-07  Werner Lemberg  <wl@gnu.org>

	* src/tools/apinames.c (panic): Accept variable number of arguments.

2023-03-07  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/truetype/ttgload.c (TT_Process_Composite_Glyph): Fix leak too.

2023-03-07  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/truetype/ttgload.c (TT_Load_Simple_Glyph): Triage memory leak.

	This leak has been introduced in the previous commit and immediately
	detected:
	  https://chromium-review.googlesource.com/c/chromium/src/+/4313202

2023-03-06  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[truetype] Simplify memory management.

	Instead of using `Update_Max`, switch to regular FreeType memory
	allocation macros, stop pre-allocating the glyph instruction arrays.

	* src/truetype/ttgload.c (TT_Load_Simple_Glyph,
	TT_Process_Composite_Glyph): Switch to regular memory allocation.
	* src/truetype/ttinterp.c (Update_Max): Removed.
	(TT_Load_Context): Reallocate stack and free old instructions.
	(Modify_CVT_Check, Ins_WS): Switch to regular memory allocation.
	* src/truetype/ttinterp.h (Update_Max): Removed.

2023-03-06  David PROVENT  <dprovent@annecy-elec.local>

	Added information about the zlib version update in the changelog

2023-03-06  Alexei Podtelezhnikov  <apodtele@gmail.com>

	Fix a couple of MSVC warnings.

	* src/base/ftcalc.c (FT_MulAddFix): Add cast.
	* src/sfnt/ttcolr.c (tt_face_get_colorline_stops, read_paint): Ditto.

2023-03-05  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* builds/windows/vc2010/freetype.vcxproj: Suppress C4267 on _WIN64.

	This usually comes from `strlen` returning 64-bit `size_t`, which
	we often assign to 32-bit `FT_ULong` on Windows-64 (LLP64).

2023-03-05  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/cff/cffparse.c (cff_parser_run): Thinko.

2023-03-05  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[cff] Clean up CharString number encoding.

	* src/cff/cffparser.c (cff_parser_run): Work with signed numbers.

2023-03-05  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/cff/cffparse.c (cff_parser_run): Fix variable type.

2023-03-04  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[cff] Clean up memory management in the old engine.

	* src/cff/cffparse.c (finalize_t2_strings): Fix NULL-dereferencing
	in the out-of-memory situation, use `FT_FREE`.
	(cff_parser_run): Use FreeType memory allocation macros and avoid
	uninitialized pointers.

2023-03-04  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/cff/cffobjs.c (cff_size_init): Synonymous change.

2023-03-04  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/sfnt/sfobjs.c (sfnt_load_face): Shorten de-referencing.

2023-03-04  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[pfr] Shorten de-referencing.

	* src/pfr/pfrobjs.c (pfr_face_done, pfr_face_init): Use closer `memory`.
	* src/pfr/pfrgload.c (pfr_glyph_load_compound): Remove `loader`.

2023-03-03  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/cff/cffobjs.c (cff_size_get_globals_funcs): Shorten de-referencing.

2023-03-03  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[cff,cid,type1] Shorten de-referencing.

	* src/cff/cffobjs.c (cff_clot_init): Use immediate library reference.
	* src/cid/cidobjs.c (cid_slot_init): Ditto.
	* src/type1/t1objs.c (T1_GlyphSlot_Init): Ditto.

2023-03-02  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* configure: Use `sed` instead of `grep`.

	This is more portable and consistent with `autogen.sh`.

2023-03-02  Ben Wagner  <bungeman@chromium.org>

	Avoid strtol on non-null-terminated data.

	Technically, `strtol` can only be used with C strings terminated with
	`\0`.  CID data is not generally null-terminated and often does not
	contain a `\0` if it is hex-encoded.  AddressSanitizer with `ASAN_OPTIONS`
	containing `strict_string_checks=1` verifies this by using an adversarial
	`strtol` that always reads to the terminating `\0`.

	To avoid undefined behavior from `strtol` in `cid_parser_new`, use the
	parser to parse the tokens instead of attempting to parse them ad-hoc.
	This will internally use `PS_Conv_Strtol` to parse the integer, which
	respects the parser's limits and directly implements the PostScript
	parsing rules for integers.

	* src/cid/cidparse.c (cid_parser_new): Use the parser to parse the
	tokens.

	Fixes: https://bugs.chromium.org/p/chromium/issues/detail?id=1420329

2023-03-02  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/cff/cffload.c (cff_subfont_load): Synonymous update.

2023-03-01  ubawurinna  <ubawurinna-6079@yopmail.com>

	* src/gzip/README.freetype: Update version.

2023-03-01  ubawurinna  <you@example.com>

	[gzip] Fix static linking.

	Without this patch, static linking with MS Visual Studio causes linking
	errors.

	* src/gzip/ftgzip.c: Set `ZEXPORT` to nothing and `ZEXTERN` to static for
	all compilers.

2023-03-01  Werner Lemberg  <wl@gnu.org>

	* include/freetype/internal/compiler-macros.h (FALL_THROUGH): Update.

	This follows

	  https://lists.gnu.org/archive/html/bug-gnulib/2023-02/msg00200.html

2023-02-28  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[truetype] Treat 38 as 40 without Infinality.

	* include/freetype/ftdriver.h (TT_INTERPRETER_VERSION_38): Reinstate.
	* src/truetype/ttdriver.c (tt_property_set): Fallback from 38 to 40.

2023-02-26  Werner Lemberg  <wl@gnu.org>

	* include/freetype/internal/compiler-macros.h (FALL_THROUGH): Update.

	This follows

	  https://lists.gnu.org/archive/html/bug-gnulib/2023-02/msg00159.html

2023-02-26  Werner Lemberg  <wl@gnu.org>

	* src/*: Replace leading underscores with trailing ones in dummy variables.

	This is to avoid clang warnings.

2023-02-26  Karl Berry  <karl@freefriends.org>

	* configure: Don't hardcode `grep -E`.

	TeXLive still supports Solaris 5.10, where the system's `grep` doesn't
	accept the `-E` option.  We thus introduce an `EGREP` variable that is set
	to either `grep -E` or `-egrep`.

2023-02-26  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/cff/cffload.c (cff_encoding_load): Optimize array zeroing.

	This is unnecessary for predefined standard and expert encodings.
	Even for custom encodings the arrays might be already zeroed when
	CFF_FontRec is created but we keep it just in case.

2023-02-25  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/type1/t1load.c (T1_Get_MM_Var): Optimize array zeroing.

2023-02-25  Tamir Duberstein  <tamird@google.com>

	* src/base/ftsystem.c (ft_ansi_stream_io): Avoid undefined behaviour.
	Also short-circuit on `offset` to avoid checking `count` a second time when
	`ft_ansi_stream_io` is used for reading.

	Per ISO/IEC 9899:

	  If an argument to a function has an invalid value (such as a value outside
	  the domain of the function, or a pointer outside the address space of the
	  program, or a null pointer, or apointer to non-modifiable storage when the
	  corresponding parameter is not const-qualified) or a type (after
	  promotion) not expected by a function with variable number of arguments,
	  the behavior is undefined.  If a function argument is described as being
	  an array, the pointer actually passed to the function shall have a value
	  such that all address computations and accesses to objects (that would be
	  valid if the pointer did point to the first element of such an array) are
	  in fact valid.

	Per IEEE Std 1003.1:

	  size_t fread(void *restrict ptr, size_t size, size_t nitems,
	               FILE *restrict stream);

	  The `fread` function shall read into the array pointed to by `ptr` up to
	  `nitems` elements whose size is specified by `size` in bytes, from the
	  stream pointed to by `stream`.

	Since the first argument to `fread` is described as being an array, its
	behavior is undefined when that argument is a null pointer.

	Per the documentation on `ft_ansi_stream_io`:

	  If `count' is zero (this is, the function is used for seeking), a non-zero
	  return value indicates an error.

	Thus the intent is clear, and the call to `fread` can be skipped, avoiding
	undefined behaviour.

2023-02-21  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[raster] Clean up contour indexing.

	* src/raster/ftraster.c (Decompose_Curve, Convert_Glyph): Use consistent
	index types (Int) and compact iterations.

2023-02-21  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[autofit] Clean up contour indexing.

	* src/autofit/aflatin.c (af_latin_metrics_init_blues): Refactor.
	* src/autofit/afcjk.c (af_cjk_metrics_init_blues): Ditto.

2023-02-21  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/base/ftoutln.c (FT_Outline_Check): Fix C4701 warning.

2023-02-21  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/sdf/ftsdf.c (get_min_distance_cubic): Fix C4701, typos.

2023-02-20  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/base/ftstroke.c (FT_Stroker_ParseOutline): Clean up contour indexing.

2023-02-20  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[base] Clean up contour indexing.

	* src/base/ftoutln.c (FT_Outline_Reverse, FT_Outline_EmboldenXY,
	FT_Outline_Get_Orientation): Set the first and last indexes together.
	(FT_Outline_Decompose): Ditto and check them more stringently.
	* src/smooth/ftgrays.c (FT_Outline_Decompose)[STANDALONE_]: Ditto.

2023-02-20  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/base/ftoutln.c (FT_Outline_Check): Update error code, clean up.

2023-02-17  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[truetype] Hide Infinality.

	Remove Infinality as an option before its complete extraction.

	* include/freetype/ftoption.h: Remove the Infinality option.
	* devel/ftoption.h: Ditto.
	* include/freetype/ftdriver.h (TT_INTERPRETER_VERSION_38): Is 40 now.

2023-02-17  Alex Ringlein  <aringlein@figma.com>

	* src/base/ftoutln.c (FT_Outline_Reverse): Anchor first contour points.

	A cubic contour has to always start from an on-point. Therefore, we
	should not swap the first with the last point, which might be off, and
	obtain an invalid contour. This does not matter for conic contours.
	If anything, it also saves one swap there. Fixes #1207.

2023-02-16  Werner Lemberg  <wl@gnu.org>

	Documentation improvement for `FT_Bitmap`.

	Fixes #1205.

2023-02-10  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[type1/MM] Round design coordinates.

	The design coordinates for MM fonts were not rounded. For example,
	`FT_Get_Var_Design_Coordinates` returned values with fractional part.

	* src/type1/t1load.c (mm_axis_unmap): Refactor with rounding.

	* include/freetype/ftmm.h (FT_Var_Axis, FT_Set_Var_Design_Coordinates,
	FT_Get_Var_Design_Coordinates): Reword documentation.

2023-02-09  Jan Alexander Steffens (heftig)  <heftig@archlinux.org>

	* builds/meson/parse_modules_cfg.py: Handle `gxvalid` and `otvalid`.

	These need a name mapping similar to what was done for other modules,
	or linking will fail.

2023-02-09  Werner Lemberg  <wl@gnu.org>

	* build/toplevel.mk (do_dist): Fix typo.

2023-02-09  Werner Lemberg  <wl@gnu.org>

	* Version 2.13 released.
	==========================

	Tag sources with `VER-2-13-0'.

	* docs/VERSION.TXT: Add entry for version 2.13.
	* docs/CHANGES: Updated.

	* README, src/base/ftver.rc, builds/windows/vc2010/index.html,
	builds/windows/visualc/index.html, builds/windows/visualce/index.html,
	builds/wince/vc2005-ce/index.html, builds/wince/vc2008-ce/index.html,
	docs/freetype-config.1: s/2.12.1/2.13/, s/2121/2130/.

	* include/freetype/freetype.h (FREETYPE_MINOR): Set to 13.
	(FREETYPE_PATCH): Set to 0.

	* builds/unix/configure.raw (version_info): Set to 25:0:19.
	* CMakeLists.txt (VERSION_MINOR): Set to 13.
	(VERSION_PATCH): Set to 0.

2023-02-09  Alexei Podtelezhnikov  <apodtele@gmail.com>

	Comment on `FT_GlyphSlot_Slant'.

2023-02-08  Werner Lemberg  <wl@gnu.org>

	[autofit] Fix 'multi' compilation.

	* src/autofit/ft-hb.c: Decorate with `FT_LOCAL_DEF`.
	Add ANSI boilerplate code for otherwise empty file.
	* src/autofit/ft-hb.h: Include `compiler-macros.h` and `freetype.h`.
	Use `FT_BEGIN_HEADER` and `FT_END_HEADER`.
	Decorate with `FT_LOCAL`.

	* src/autofit/rules.mk (AUTOF_DRV_SRC): Add `ft-hb.c`.

2023-02-08  Werner Lemberg  <wl@gnu.org>

	Fix `FT_LOCAL` and `FT_LOCAL_DEF` tags.

2023-02-08  Werner Lemberg  <wl@gnu.org>

	Fix 'fall-through' warning messages.

	Modern compilers get more insistent on that...

	* include/freetype/internal/compiler-macros.h (FALL_THROUGH): Define.
	* src/*: Use it instead of `/* fall through */` comments.

2023-02-08  Werner Lemberg  <wl@gnu.org>

	For debugging, avoid implicit conversion from integer to double.

	Otherwise we get zillions of clang 15 warnings.

	* src/autofit/afcjk.c, src/autofit/afhints.c, src/autofit/aflatin.c,
	src/base/ftobjs.c, src/base/ftoutln.c, src/cff/cffparse.c,
	src/raster/ftraster.c, src/sfnt/pngshim.c, src/truetype/ttgload.c,
	src/truetype/ttgxvar.c, src/truetype/ttobjs.c, src/type1/t1gload.c: Use
	`double` cast in debugging and tracing macros.

2023-02-08  Werner Lemberg  <wl@gnu.org>

	Avoid reserved identifiers that are globally defined.

	This is mandated by the C99 standard, and clang 15 produces zillions of
	warnings otherwise.

	* devel/ftoption.h, include/freetype/config/ftoption.h,
	include/freetype/internal/ftmemory.h, src/autofit/afhints.h,
	src/autofit/afmodule.c, src/autofit/aftypes.h, src/base/ftadvanc.c,
	src/base/ftdbgmem.c, src/base/ftstream.c, src/bdf/bdflib.c,
	src/truetype/ttinterp.c: Replace identifiers of the form `_foo` with `foo_`.

2023-02-08  Werner Lemberg  <wl@gnu.org>

	Fix minor clang and clang++ warnings.

2023-02-08  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[truetype, type1] Additional variation tags.

	Sync with
	  https://learn.microsoft.com/en-us/typography/opentype/spec/dvaraxisreg#registered-axis-tags

	* src/truetype/ttgxvar.h (TTAG_ital): New tag.
	* src/truetype/ttgxvar.c (TT_Get_MM_Var): Use it.
	* src/type1/t1load.c (T1_Get_MM_Var): Handle 'slnt' and 'ital'.

2023-02-08  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/base/ftsynth.c (FT_GlyphSlot_Slant): Add vertical slant.
	* include/freetype/ftsynth.h (FT_GlyphSlot_Slant): Update it.

2023-02-08  anuj  <95867901+anuj99@users.noreply.github.com>

	[sdf] Use 32-bit integers internally.

	* src/sdf/ftsdfcommon.h (FT_16D16, FT_26D6): Use 32-bit integers
	  instead of `FT_Fixed` for internal data types. `FT_Fixed` i.e.
	  `signed long` is 64-bit on some architectures.

2023-02-07  Werner Lemberg  <wl@gnu.org>

	docs/CHANGES: Updated.

2023-02-04  Alexei Podtelezhnikov  <apodtele@gmail.com>

	Comment on optional ascender and descender.

2023-02-04  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/type1/t1afm.c (T1_Read_Metrics): Reaffirm ascender and descender.

2023-02-04  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/type1/t1afm.c (T1_Read_Metrics): Validate ascender and descender.

	The ascender and descender are optional in the AFM specifications.
	They could be omitted or even set to zero, e.g., in the current release
	of URW++ base 35 fonts.

2023-02-02  Werner Lemberg  <wl@gnu.org>

	* src/cff/cffgload.c (cff_slot_load): Avoid memory leak.

	Fixes issue #1204.

2023-02-01  Werner Lemberg  <wl@gnu.org>

	* src/truetype/ttgxvar.c (tt_var_get_item_delta): Check `face->blend`.

	Reported as

	  https://bugs.chromium.org/p/oss-fuzz/issues/detail?id=55581

2023-02-01  Werner Lemberg  <wl@gnu.org>

	* docs/CHANGES: Add news for 'freetype-demos'.

2023-01-30  Werner Lemberg  <wl@gnu.org>

	* subprojects/harfbuzz.wrap, subprojects/libpng.wrap: Updated.

2023-01-28  Werner Lemberg  <wl@gnu.org>

	Minor changes.

	Comment fixes, typos, removing of unnecessary parentheses.

2023-01-28  Werner Lemberg  <wl@gnu.org>

	Whitespace.

2023-01-27  Behdad Esfahbod  <behdad@behdad.org>

	[ttgxvar] Fix crash in COLRv1.

	This is a stopgap until issue #1202 is properly fixed.

	* src/truetype/ttxgvar.c (tt_var_get_item_delta): Check `normalizedcoords`.

2023-01-19  Werner Lemberg  <wl@gnu.org>

	The 'COLR' v1 API will no longer be experimental in the next release.

2023-01-18  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* docs/oldlogs/ChangeLog.210: Typos.

2023-01-18  Ben Wagner  <bungeman@chromium.org>

	[base] Fix typo.

	* src/base/ftobjs.c (open_face_PS_from_sfnt_stream): Request module 't1cid',
	not 'cid'.

2023-01-18  Ben Wagner  <bungeman@chromium.org>

	[base] Return error if requested driver is not found.

	In `open_face_from_buffer` it is possible that a driver is requested but
	FreeType was built without the requested module.  Return an error in this
	case to indicate that the request could not be satisfied, rather than trying
	all existing driver modules.

	* src/base/ftobjs.c (open_face_from_buffer): Return `FT_Err_Missing_Module`
	if a driver is specified but not found.

2023-01-18  Dominik Röttsches  <drott@chromium.org>

	[sfnt] Avoid nullptr dereference in reading malformed 'COLR' v1 table.

	Fixes https://bugs.chromium.org/p/chromium/issues/detail?id=1408044.

	* src/sfnt/ttcolr.c (tt_face_load_colr): When the 'COLR' v1 table header is
	too small, don't deallocate delta set index map structures.

2023-01-17  Werner Lemberg  <wl@gnu.org>

	* src/tools/update-copyright: Allow execution from other repositories.

	We use this for `freetype-demos`.

2023-01-17  Werner Lemberg  <wl@gnu.org>

	Update all copyright notices.

2023-01-17  Werner Lemberg  <wl@gnu.org>

	* src/tools/no-copyright: Updated.

2023-01-17  Ben Wagner  <bungeman@chromium.org>

	[base] 'close' callback may not use `stream->memory`.

	The documentation for `FT_StreamRec::memory` states that it 'shouldn't be
	touched by stream implementations'.  This is true even for internal
	implementations of the 'close' callback, since it is not guaranteed that
	`memory` will even be set when the 'close' callback occurs.

	* src/base/ftobjs.c (new_memory_stream): stash current `memory` in
	`stream->descriptor`.
	(memory_stream_close): Use it.

2023-01-17  Ben Wagner  <bungeman@chromium.org>

	[base] Always close user-provided stream.

	The `FT_Open_Face` documentation states

	> If `FT_OPEN_STREAM` is set in `args->flags`, the stream in `args->stream`
	> is automatically closed before this function returns any error (including
	> `FT_Err_Invalid_Argument`).

	However, if the user provides a stream in `args.stream` with
	`FT_OPEN_STREAM` set and a `close` function, but then for some reason passes
	NULL for `aface` and a non-negative `face_index`, the error
	`Invalid_Argument` is returned but the `close` callback will not be called
	on the user-provided stream.  This may cause resource leaks if the caller is
	depending on the `close` callback to free resources.

	The difficulty is that a user may fill out a `FT_StreamRec` and pass its
	address as `args.stream`, but the stream isn't really 'live' until
	`FT_Stream_New` is called on it (and `memory` is set).  In particular, it
	cannot really be cleaned up properly in `ft_open_face_internal` until the
	stream pointer has been copied into the `stream` local variable.

	* src/base/ftobj.c (ft_open_face_internal): Ensure that user-provided
	`args.stream.close` is called even with early errors.

2023-01-17  Ben Wagner  <bungeman@chromium.org>

	[base] Fix leak of internal stream marked external.

	`open_face_from_buffer` allocates a new `FT_Stream` to pass to
	`ft_open_face_internal`.  Because this is an `FT_OPEN_STREAM`,
	`ft_open_face_internal` will mark this as an 'external stream', which the
	caller must free.  However, `open_face_from_buffer` cannot directly free it
	because the stream must last as long as the face.  There is currently an
	attempt at this by clearing the 'external stream' bit after
	`open_face_from_buffer` returns successfully.  However, this is too late as
	the original stream may have already been closed and the stream on the face
	may not be the same stream as originally passed.

	It is tempting to use `FT_OPEN_MEMORY` and let `ft_open_face_internal`
	create the stream internally.  However, with this method there is no means
	to pass through a 'close' function to the created stream to free the
	underlying data, which must be owned by the stream.

	A possibility is to check on success if the stream of the face is the same
	as the original stream.  If it is then unset the external flag.  If not,
	then free the original stream.  Unfortunately, while no current
	implementation does so, it is possible that the face still has the original
	stream somewhere other than as the `FT_FaceRec::stream`.  The stream needs
	to remain available for the life of the face or until it is closed,
	whichever comes earlier.

	The approach taken here is to let the stream own itself.  When the stream is
	closed it will free itself.

	* src/base/ftobjs.c (memory_stream_close): Free `stream`.
	(open_face_from_buffer): Simplify error handling, since
	`ft_open_face_internal` always closes `args.stream` on any error.

	Fixes: https://bugs.chromium.org/p/oss-fuzz/issues/detail?id=54930

2023-01-16  Werner Lemberg  <wl@gnu.org>

	sr/*.c: Various minor fixes.

	* src/autofit/ft-hb.c (_hb_ft_reference_table): Call `FT_UNUSED` after
	variable declarations.

	* src/gxvalid/gxvjust.c (gxv_just_widthDeltaClusters_validate): Eliminate
	unused variable.

	* src/gzip/ftgzip.c: Don't call GCC '-Wstrict-prototypes' pragma for C++
	compiler.

	* src/sfnt/ttcolr.c (ENSURE_READ_BYTES): Remove final semicolon to avoid
	compiler warning.

	* src/sfnt/ttsvg.c (tt_face_load_svg_doc): Fix signedness warning.

2023-01-16  Dominik Röttsches  <drott@chromium.org>

	[sfnt] Remove temporary runtime flag for variable 'COLR' v1.

	Fixes #1187.

	* src/sfnt/ttcolr.c (top level, read_paint, tt_face_load_colr,
	tt_face_free_colr, get_deltas_for_var_index_base,
	tt_face_get_color_glyph_clipbox, tt_face_get_colorline_stops): Remove macro
	definition `VARIABLE_COLRV1_ENABLED` and its usage.

	* src/truetype/ttdriver.c (tt_property_set): Remove parsing of
	'TEMPORARY-enable-variable-colrv1' property name.

	* src/truetype/ttobjs.h (TT_DriverRec): Remove `enable_variable_colrv1`
	flag.

2023-01-07  Werner Lemberg  <wl@gnu.org>

	* src/autofit/ft-hb.c (_hb_ft_reference_table): Minor integration fixes.

2023-01-07  Ben Wagner  <bungeman@chromium.org>

	[truetype] Reset cvt and storage in context load.

	Currently the cvt and storage are saved and restored in `TT_RunIns`.
	However, this is too granular as the cvt and storage area should be set to
	the original cvt and storage area only when setting up the hinting context.
	This allows for the cvt and storage area to be modified while parsing
	multiple glyphs, as is the case with composite glyphs.

	* src/truetype/ttinterp.h (TT_ExecContextRec): Remove `origCvt` and
	`origStorage`.

	* src/truetype/ttinterp.c (TT_RunIns): Don't save and restore the cvt and
	storage area.
	(Modify_CVT_Check, Ins_WS): Switch from "if in glyph and using original data
	do copy on write" to "if in glyph and not using glyph specific data do copy
	on write".

2023-01-06  Matthias Clasen  <mclasen@redhat.com>

	[autofit] Don't depend on 'hb-ft'.

	The circular dependency is still there, but at least we no longer depend on
	the HarfBuzz API that is only present if HarfBuzz has been built with
	FreeType support, making the bootstrapping a bit easier.

	* src/autofit/ft-hb.c, src/autofit/ft-hb.h: New files, providing
	`_hb_ft_font_create`, which is more or less a verbatim copy of the
	corresponding HarfBuzz code from file `hb-ft.cc`.

	* src/autofit/afglobal.c (af_face_globals_new): Use it.
	* src/autofit/afshaper.h: Don't include `hb-ft.h` but `ft-hb.h`.
	* src/autofit/autofit.c: Include `ft-hb.c`.

	* LICENSE.TXT: Updated.

2023-01-06  Ben Wagner  <bungeman@chromium.org>

	[truetype] Keep variation store consistent.

	`tt_var_load_item_variation_store` fills out a `GX_ItemVarStore`.  While it
	may return an error, the item store must be left in a consistent state so
	that any use or destruction of the item store can properly use or free the
	data in it.  Before this change the counts from the font data were read
	directly into the item store before the actual allocation of the arrays to
	which they referred.  There exist many opportunities between the time the
	counts are read and the arrays are allocated to return early due to invalid
	data.  When this happened the item store claimed to have entires it actually
	did not, leading to crashes later when it was used.

	Fixes: https://bugs.chromium.org/p/oss-fuzz/issues/detail?id=54449

	* src/truetype/ttgxvar.c (tt_var_load_item_variation_store): Read the counts
	into local variables and store them in the item store only after the related
	arrays are actually created on the item store.

2023-01-05  Ben Wagner  <bungeman@chromium.org>

	[base] Report used stream's external status.

	In `open_face` the initial stream is set on the face, along with the
	information about if FreeType is the owner of the stream object itself.  The
	loaders may in the course of their work replace this stream with a new
	stream (as is the case for 'woff' and 'woff2'), which may have a different
	ownership than the initial stream object (likely the original stream object
	is owned by the user and is external, while the new stream object is created
	internally to FreeType and is internal).  When the stream is replaced, the
	face's flags are updated with the new ownership status.

	However, `open_face` cannot itself free this stream as its caller
	`ft_open_face_internal` is responsible for this.  In addition, in the case
	of an error `open_face` cannot return an actual face with the new stream and
	its ownership status to the caller.  As a result, it must pass this
	information back to the caller as a sort of "failed face" so that the caller
	can clean up.

	`open_face` was already passing back the new stream but was not passing back
	the stream ownership information.  As a result the stream may not have been
	free'd when needed.

	Fixes https://bugs.chromium.org/p/oss-fuzz/issues/detail?id=54700

	* src/base/ftobjs.c (open_face): Pass back the ownership information as
	well.
	(ft_open_face_internal): Updated.

2023-01-05  Noah Cabral  <cnoah1705@gmail.com>

	fix spelling err in LICENSE.txt

2023-01-05  Dominik Röttsches  <drott@chromium.org>

	[sfnt] Fix color stop bounds check calculation at table end.

	Fixes https://bugs.chromium.org/p/skia/issues/detail?id=14021

	* src/sfnt/ttcolr.c (VAR_IDX_BASE_SIZE): New macro.
	(tt_face_get_colorline_stops): Fix off-by-one bounds check calculation, take
	`VarColorStop` into account, and hopefully make it easier to read.

2023-01-05  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/base/ftobjs.c (FT_Request_Metrics): Avoid division by zero.

	The division-by-zero might happen in broken fonts (see #1194).
	Instead of returning a huge number from FT_DivFix and failing
	to scale later, we now bail immediately.

2022-12-20  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[psaux] Delay the upem validity assertion.

	

	Fixes #1194.

	

	* src/psaux/psft.c (cf2_getUnitsPerEm): Remove the upem assert.

	(cf2_checkTransform): Assert the upem validity after checking the scale.

2022-12-14  David Vanderson  <david.vanderson@gmail.com>
	    Werner Lemberg  <wl@gnu.org>

	[gzip] Make static compilation not leak global symbols.

	* src/gzip/ftgzip.c (HAVE_HIDDEN): Do not define; it is no longer needed
	because everything is static.
	(HAVE_MEMCPY): Define.
	(zcalloc, zcfree): Remove no longer needed definitions (because `Z_SOLO` is
	active).

	* src/gzip/patches/freetype-zlib.diff: Regenerated.

	Fixes #1146.

2022-12-14  Werner Lemberg  <wl@gnu.org>

	* src/gzip/ftzconf.h: Updated to zlib 1.2.13.

	I forgot to copy that file.

2022-12-14  Werner Lemberg  <wl@gnu.org>

	* builds/unix/configure.raw: Don't check for `memcpy` and `memmove`.

	We expect a C99 compiler, and both functions are part of this standard.

2022-12-13  Werner Lemberg  <wl@gnu.org>

	[sdf, sfnt] Handle minor compiler warnings.

	* src/sdf/ftsdf.c (get_min_distance_conic): Initialize `nearest_point`.

	* src/sfnt/ttsvg.c (find_doc): Initialize `mid_doc`.

	Fixes #1195.

2022-12-07  Werner Lemberg  <wl@gnu.org>

	* subprojects/zlib.wrap: Micro-update from upstream.

2022-12-06  Jiří Malák  <malak.jiri@gmail.com>

	* include/freetype/internal/ftcalc.h (FT_MSB): Support Open Watcom 2.0.

	Closes !232.

2022-11-23  Luca Bacci  <luca.bacci982@gmail.com>

	* src/base/ftdbgmem.c (ft_mem_source_compare): Add FT_COMPARE_DEF.

	Closes !230.

2022-11-21  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/autofit/afloader.c (af_loader_load_glyph): Remove `size` check.

	This is done by `FT_Load_Glyph`.

2022-11-18  Alexei Podtelezhnikov  <apodtele@gmail.com>

	Comments added.

2022-11-16  Johan Matsson  <mjunix@ at github>

	* src/autofit/afloader.c (af_loader_load_glyph): Fix dereference.

	This must happen after the NULL check.

	Taken from

	  https://github.com/freetype/freetype/pull/2

2022-11-15  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/pcf/pcfutil.c ({Two,Four}ByteSwap): Use builtins or shifts.

	We trust glibc which uses shifts or builtins to swap bytes.  This
	must be more efficient.

2022-11-14  Werner Lemberg  <wl@gnu.org>

	* src/truetype/ttgxvar.c (tt_hvadvance_adjust): Integer overflow.

	Reported as

	  https://bugs.chromium.org/p/oss-fuzz/issues/detail?id=50462

2022-11-14  Loïc Yhuel  <loic.yhuel@softathome.com>

	[meson] Use generated ftmodule.h

	ftmodule.h is generated at the root of the build directory, but FT_CONFIG_MODULES_H
	(freetype/config/ftmodule.h) is used instead.
	This makes the build fail when disabling modules in modules.cfg.

	* meson.build (harfbuzz_dep): Add '-DFT_CONFIG_MODULES_H=<ftmodule.h>'.

2022-11-14  Loïc Yhuel  <loic.yhuel@softathome.com>

	[meson] Fix generated ftmodule.h

	The sdf module wasn't recognized, so the generated ftmodule.h had "None_renderer_class".

	* builds/meson/parse_modules_cfg.py: Handle sdf in RASTER_MODULES.

2022-11-12  Dominik Röttsches  <drott@chromium.org>

	Add `TT_CONFIG_OPTION_NO_BORING_EXPANSION` configuration macro.

	This gives users a possibility to deactivate new features not (yet) in the
	OpenType standard.

	* include/freetype/config/ftoption.h, devel/ftoption.h
	(TT_CONFIG_OPTION_NO_BORING_EXPANSION): New macro.

	* src/truetype/ttgxvar.c (ft_var_load_avar): Use it to disable 'avar'
	version 2.0 support.

2022-11-12  Behdad Esfahbod  <behdad@behdad.org>

	[truetype] Improve bounds checks for `ItemVariationStore`.

	* src/truetype/ttgxvar.c (tt_hvadvance_adjust): Move bounds check ...
	(tt_var_get_item_delta): ...  to this function, because it is safer.  For
	example, the 'avar' table 2.0 codepath was not performing a bounds check at
	all.

2022-11-12  Behdad Esfahbod  <behdad@behdad.org>

	[truetype] In `ItemVariationStore`, value 0xFFFF for `dataCount` is valid.

	It corresponds to outer indices of 0 to 0xFFFE.

	* src/truetype/ttgxvar.c (tt_var_load_item_variation_store): Remove invalid
	code.

2022-11-11  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[pcf] Improve CMap efficiency and readability.

	* src/pcf/pcfdrivr.c (pcf_cmap_char_{index,next}): Check and walk
	the encoding array indexes.

2022-11-10  Sam James  <sam@gentoo.org>

	Fix `-Wstrict-prototypes`.

	* builds/unix/configure.raw: Fix `-Wstrict-prototypes`.
	Clang 16 warns on these and they will be dropped in C23.

	* builds/unix/freetype2.m4: Ditto.

2022-11-09  Ben Wagner  <bungeman@chromium.org>

	[truetype] Check avar_segment before access

	* src/truetype/ttgxvar.c (tt_done_blend): check `avar_segment` before
	accessing to free its `correspondence`.

	Reported as:

	  https://bugs.chromium.org/p/oss-fuzz/issues/detail?id=53062

2022-11-09  Ben Wagner  <bungeman@chromium.org>

	[truetype] Restore behavior of ft_var_load_hvvar

	* src/truetype/ttgcvar.c (ft_var_load_hvvar): restore previous behavior

	In a previous change [0] the behavior of `ft_var_load_hvvar` was changed
	to not load the item variation store if it was at offset 0, but not
	return an error when this happened. This broke any users, like
	`tt_hvadvance_adjust`, that rely on successful completion of
	`ft_var_load_hvvar` to imply that returned table's `itemStore` had been
	initialized. This lead such users to dereference NULL.

	This change appears to have been unintentional and unrelated to the
	actual avar2 changes. As a result, fix these NULL dereferences by
	restoring the code to always attempt to initialize the `itemStore`.

	[0] ae4eb996 "[truetype] Add support for `avar` table 2.0 format."

	Reported as

	  https://bugs.chromium.org/p/oss-fuzz/issues/detail?id=53061

2022-11-08  Werner Lemberg  <wl@gnu.org>

	docs/CHANGES: Updated.

2022-11-08  suzuki toshiya  <mpsuzuki@hiroshima-u.ac.jp>

	[build] use AC_CHECK_PROG() macro for libpng-config detection

	* builds/unix/configure.raw: use AC_CHECK_PROG() instead of `which` to find `libpng-config`.

2022-11-08  suzuki toshiya  <mpsuzuki@hiroshima-u.ac.jp>

	[build] fix for make multi

	Fix "make multi" by MR !223

	* include/freetype/internal/services/svmm.h: include ftmm.h to define FT_Get_MM_Func.
	* src/truetype/ttgxvar.h: include ftmmtypes.h to use GX_AVarTable properly.
	* src/base/ftmac.c: include ftdebug.h to use FT_THROW() properly.

2022-11-08  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/pfr/pfrsbit.c (pfr_lookup_bitmap_data): Accelerate the search.

	This is mostly for consistency because PFR fonts with bitmap strikes
	do not seem to exist.

2022-11-06  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[bdf, pfr, psnames] Accelarate charmap searches.

	The binary searches within charmaps can be accelerated because they
	often contain dense continuous blocks of character codes. Within such
	blocks, you can predict matches based on misses.  This method has been
	deployed in `bdf` since 0f122fef34; we only refactor it there.  We now
	use it in `pfr` and `psnames`, which speeds up the unicode charmap
	access by about 50% in PFR and Type 1 fonts.

	* src/bdf/bdfdrivr.c (bdf_cmap_char_{index,next}): Refactor.
	* src/pfr/pfrcmap.c (pfr_cmap_char_{index,next}): Predict `mid` based
	on the mismatch distance.
	* src/psnames/psmodule.c (ps_unicodes_char_{index,next}): Ditto.

2022-11-04  Behdad Esfahbod  <behdad@behdad.org>

	[truetype] Add support for `avar` table 2.0 format.

	See

	  https://github.com/harfbuzz/boring-expansion-spec/blob/main/avar2.md

	for the specification.

	Currently, this is implemented only in most recent OS versions on Apple
	platforms and in the HarfBuzz library, but it is expected to be added to the
	OpenType standard soon.

	* src/truetype/ttgxvar.h (GX_AVarTableRec): New structure.
	(GX_BlendRec): Use it to replace `avar_segment` with `avar_table`.

	* src/truetype/ttgxvar.c (ft_var_load_avar): Load new table version.
	(ft_var_to_normalized, tt_done_blend): Extend for new format.
	(ft_var_load_hvvar, ft_var_to_design): Updated.

2022-10-24  Werner Lemberg  <wl@gnu.org>

	Replace '1/64th' (and similar entries) with '1/64' in docs and comments.

2022-10-24  Ivan Panchenko  <ivanpan3@gmail.com>

	* include/freetype/*: Fix documentation typos.

2022-10-21  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/truetype/ttgload.c: Cosmetic changes.

2022-10-21  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[cff, truetype] Simplify SVG metrics scaling.

	Use pre-calculated scaling factors. Also, the advance widths used
	to be rounded, which was incorrect.

	* src/cff/cffgload.c (cff_slot_load): Use `x_scale` and `y_scale`.
	* src/truetype/ttgload.c (TT_Load_Glyph): Ditto.

2022-10-20  Werner Lemberg  <wl@gnu.org>

	* subprojects/zlib.wrap: Update to zlib version 1.2.13.

2022-10-18  Dominik Röttsches  <drott@chromium.org>

	[sfnt] Additional bounds checks for `COLR` v1 table handling.

	* src/sfnt/ttcolr.c (read_paint): Add `colr` argument, necessary for...
	... another use of `ENSURE_READ_BYTES`.
	Update callers.
	(tt_face_get_paint_layers): Ensure that the 4-byte paint table
	offset can be read.

	This is a follow-up to !124 and issue
	https://bugs.chromium.org/p/oss-fuzz/issues/detail?id=52404

2022-10-18  Werner Lemberg  <wl@gnu.org>

	[gzip] Update sources to zlib 1.2.13.

2022-10-18  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/sfnt/ttsbit.c (tt_face_load_strike_metrics): Simplify calculations.

2022-10-18  Werner Lemberg  <wl@gnu.org>

	Minor formatting.

2022-10-18  Dominik Röttsches  <drott@chromium.org>

	[sfnt] Guard individual `COLR` v1 paint field reads.

	* src/sfnt/ttcolr.c (ENSURE_READ_BYTES): New macro.
	(read_paint): Use it – after the start pointer `p` has been checked for
	whether it allows reading the format byte, each successive paint table field
	read need to be bounds-checked before reading further values.

	Reported as

	  https://bugs.chromium.org/p/oss-fuzz/issues/detail?id=52404

2022-10-17  Xiang Xiao  <xiaoxiang@xiaomi.com>

	* builds/toplevel.mk: Prefix all paths with `$(TOP_DIR)/`.

	This is useful for builds that are not started from the root directory.

2022-10-17  Liu Kunpeng(柳鲲鹏)  <liukunpeng@ts-it.cn>

	* src/base/ftsynth.c (FT_GlyphSlot_Slant): New API with custom slant.
	* include/freetype/ftsynth.h (FT_GlyphSlot_Slant): Declare it.

2022-10-15  Alexei Podtelezhnikov  <apodtele@gmail.com>

	Note the lack of floating-point data types.

2022-10-10  Werner Lemberg  <wl@gnu.org>

	[cff] Remove `FT_CONFIG_OPTION_NO_GLYPH_NAMES`.

	This ancient option stayed completely undocumented.  Given that the 'cff'
	driver requires the 'psnames' module, it makes no sense today to have this
	macro.

	* src/cff/cffdrivr.c (cff_services), src/cff/cffobjs.c (cff_face_init):
	Remove corresponding conditional code.

2022-10-10  Werner Lemberg  <wl@gnu.org>

	Synchronize `ftoption.h` flavours.

2022-10-10  Werner Lemberg  <wl@gnu.org>

	Minor comment changes.

2022-10-05  Alexei Podtelezhnikov  <apodtele@gmail.com>

	Improve FT_Get_Name_Index docs and place it next to FT_Get_Glyph_Name.

2022-10-04  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[autofit] Reset the face charmap directly.

	There is no need to validate the original charmap in `FT_Set_Charmap`.
	It can be reset directly.

	* src/autofit/afglobal.c (af_face_globals_compute_style_coverage):
	Use direct assignment.
	* src/autofit/af{latin,cjk,indic}.c (af_latin_metrics_init): Ditto.

2022-10-04  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/type1/t1afm.c (T1_Read_PFM): Set charmaps directly.

	As with the previous commit, we can avoid the validation checks
	of `FT_Set_Charmap` and set it directly when choosing from the
	available list.

2022-10-03  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/cache/ftccmap.c (FTC_CMapCache_Lookup): Avoid `FT_Set_Charmap`.

	

	Set charmap aggressively without all validations of `FT_Set_Charmap`

	because we take it from the available array and only temporarily.

	Even CMap Format 14 will gracefully return 0.

2022-10-03  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/cache/ftcbasic.c (ftc_basic_family_get_count): Remove redundancy.

2022-09-30  Werner Lemberg  <wl@gnu.org>

	* src/psaux/pshints.c (cf2_hintmap_insertHint): Fix midpoint computation.

	Replace '(start + end) / 2' with 'start + (end - start) / 2' to avoid
	overflow.

	Fixes #1180.

2022-09-30  Werner Lemberg  <wl@gnu.org>

	* src/psaux/pshints.c (cf2_hintmap_build): Improve debugging output.

2022-09-29  mlugg  <mlugg@mlugg.co.uk>

	[truetype] Fix undefined pointer arithmetic.

	* src/truetype/ttgxvar.c (tt_var_get_item_delta, ft_var_load_mvar): Use
	`FT_OFFSET`.

2022-09-29  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/sfnt/ttsbit.c (tt_face_load_strike_metrics): Use lighter FT_DivFix.

2022-09-29  Ali Chraghi  <alichraghi@pm.me>

	[base] FT_Attach_Stream: Make `parameters` argument constant.

2022-09-29  Azamat Hackimov  <azamat.hackimov@gmail.com>

	* src/tools/*.py: Migrate to Python 3.

	Fixes #1185, closes !205. Formatting changes according to PEP8.

2022-09-27  Dominik Röttsches  <drott@chromium.org>

	[sfnt] Guard access in 'COLR' table when requesting child table pointer.

	* src/sfnt/ttcolr.c (tt_face_get_colorline_stops, read_paint): Tighten
	pointer bounds checks.
	(get_child_table_pointer): Check whether incoming pointer `p` lies within
	the 'COLR' table.

	Reported as

	  https://bugs.chromium.org/p/oss-fuzz/issues/detail?id=51816

2022-09-27  Ben Wagner  <bungeman@chromium.org>

	[sfnt] Add SVG document bounds checking.

	Add a check that the document content is actually contained within the
	`SVG ` table.  Without this check a malformed font may claim arbitrary
	memory as its document content.

	* src/sfnt/ttsvg.c (tt_face_load_svg): Take `numEntries` into account when
	testing 'documentRecord' extents.
	(find_doc): Rename `stream` to `document_records` for clarity.
	(tt_face_load_svg_doc): Split `doc` from `doc_list` pointer for clarity.
	Test that the document content is contained within the table.
	Ensure minimum length of document before testing for gzip format.

	Reported as

	  https://bugs.chromium.org/p/oss-fuzz/issues/detail?id=51812

2022-09-23  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[base] Clean up the bitmap flow control.

	* src/base/ftbitmap.c (FT_Bitmap_Copy): Flip the copy if its pitch
	is trully opposite, zero is not a positive value.
	(FT_Bitmap_Convert): Set negative pitch as needed, accept negative
	alignment values.

2022-09-22  Alexei Podtelezhnikov  <apodtele@gmail.com>

	[base] Discard and recreate bitmaps for copying and converting.

	

	Reusing target bitmaps for copying and converting is permitted.  It is,

	however, pointless to preserve their content before overwriting.  Free-

	malloc might be faster than realloc.

	

	* src/base/ftbitmap.c (FT_Bitmap_Copy, FT_Bitmap_Convert): Free

	an old buffer and create a new one.

2022-09-16  Dominik Röttsches  <drott@chromium.org>

	Reject 'COLR' table if version is 1 but header too small.

	* src/sfnt/ttcolr.c (tt_face_load_colr): If the version is determined to
	be 1, then the table size has to be at least the size of the v1 header.
	Also, for peeking the number of base glyphs and entries in the layer list,
	ensure that the table is sufficiently long.

	Fixes #1179.  Original patch by Sergey Temnikov.

2022-09-15  Werner Lemberg  <wl@gnu.org>

	* src/otvalid/otvgsub.c (otv_SingleSubst_validate): Fix format 1 handling.

	Fixes #1181.

2022-09-06  Dominik Röttsches  <drott@chromium.org>

	[truetype] Reject 'fvar' loading when `num_instances` is too small.

	* src/truetype/ttgxvar.c (TT_Get_MM_Var): Reject retrieving master when
	'fvar' values locally do not match with sanitized values from initialization
	at `sfnt_init_face` time.

	Reported as

	  https://bugs.chromium.org/p/chromium/issues/detail?id=1360295

2022-09-05  Dominik Röttsches  <drott@chromium.org>

	[sfnt] Handle variable `COLR` v1 fonts without delta set index map

	Fixes #1178.

	* src/sfnt/ttcolr.c (get_deltas_for_var_index_base): Set outer index to
	0 and inner index to the delta index when retrieving deltas if the
	`COLR` table has no delta set index map.

2022-09-05  Dominik Röttsches  <drott@chromium.org>

	[sfnt] Pointer sanity checks before reading layer info in 'COLR' v0

	* src/sfnt/ttcolr.c (tt_face_get_colr_layer): Check that the pointer to
	read from is within the 'COLR' table.

	Reported as

	  https://bugs.chromium.org/p/oss-fuzz/issues/detail?id=50633

2022-09-05  Werner Lemberg  <wl@gnu.org>

	[autofit] Minor fix.

	* src/autofit/afglobal.c (af_face_globals_compute_style_coverage): Avoid
	compiler warning.

2022-09-05  Dominik Röttsches  <drott@chromium.org>

	[sfnt] Don't require 'gvar' table to support variation fonts.

	Fixes #1172.

	* src/sfnt/sfobjs.c (sfnt_load_face): Tag font as Multiple Masters font if
	`fvar` is present; do not require other tables to be present.

	* src/truetype/ttgxvar.c (tt_set_mm_blend): Allow for a missing 'gvar' table
	when setting variation coordinates.  However, if a 'gvar' table is actually
	present, do perform a sanity check and fail on malformedness.
	(TT_Get_MM_Var): Don't assume 'fvar' needs 'gvar' or 'CFF2 tables in all
	cases, which is an overly tight check.

2022-08-27  Alexei Podtelezhnikov  <apodtele@gmail.com>

	* src/base/ftver.rc: Explicitly use UTF-16.

	Fixes #1177 to avoid mistranslation and other problems.

2022-08-26  Dominik Röttsches  <drott@chromium.org>

	[sfnt] Avoid undefined shifts in `COLR` v1 color line retrieval

	* src/sfnt/ttcolr.c (tt_face_get_colorline_stops): Disambiguate shift
	behavior by using multiplication using macros from ftcalc.h.

	Fixes: https://bugs.chromium.org/p/oss-fuzz/issues/detail?id=50573

2022-08-21  Sean Farrell  <sean.farrell@rioki.org>

	CMakeLists.txt (FT_ENABLE_ERROR_STRINGS): New configuration option.

	This option uncomments FreeType configuration macro
	`FT_CONFIG_OPTION_ERROR_STRINGS` to make function `FT_Error_String` return
	meaningful error strings.

	This option is off by default.

2022-08-21  Chris Liddell  <chris.liddell@artifex.com>

	[base, type1] Better handling of out-of-memory situations.

	This follows similar code in `cff_slot_done`.

	* src/base/ftobjs.c (ft_glyphslot_done), src/type1/t1objs.c
	(T1_GlyphSlot_Done): Check `internal` pointer.

	The Type1 problems was reported as

	  https://bugs.chromium.org/p/oss-fuzz/issues/detail?id=50057.

2022-08-06  Tim-Philipp Müller  <tim@centricular.com>

	ci: bump windows image and use newer runner and vs2019

	The old 1809 runner will be decommissioned at some point.

2022-08-04  @udoudou  <>

	* src/cache/ftcmanag.c (FTC_Manager_New): Initialize `cur_weight`.

	See !192.

2022-08-02  Alexei Podtelezhnikov  <apodtele@gmail.com>

